SystemOrganization addCategory: #'Xpf-Client-Tests'!
SystemOrganization addCategory: #'Xpf-Client-ProjectTalk'!
SystemOrganization addCategory: #'Xpf-Client-Helpers'!
SystemOrganization addCategory: #'Xpf-Client-AdminTool'!
SystemOrganization addCategory: #'Xpf-Client-Models'!
SystemOrganization addCategory: #'Xpf-Client-Proxies'!
SystemOrganization addCategory: #'Xpf-Client-Widgets'!
SystemOrganization addCategory: #'Xpf-Client'!
SystemOrganization addCategory: #'Xpf-Client-Rfb'!
SystemOrganization addCategory: #'Xpf-Client-Taskbar'!

!Time methodsFor: '*xpf-client' stamp: 'mt 4/29/2009 11:54'!
print24WithoutSeconds
	"Return as 8-digit string 'hh:mm', with leading zeros if needed"

	^ String streamContents:
		[ :aStream | self print24: true showSeconds: false on: aStream ]! !

RestPrefetchProxyObject subclass: #XpfProxyObject
	instanceVariableNames: 'updateCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Proxies'!

!XpfProxyObject methodsFor: 'accessing' stamp: 'mt 4/27/2009 14:47'!
currentUser

	^ self repository currentUser! !

!XpfProxyObject methodsFor: 'updating' stamp: 'cs 5/15/2009 15:04'!
needsUpdate

	| needsUpdate |
	self isDeleted ifTrue: [^ false].
	self updateCounter: self updateCounter - 1.
	needsUpdate := self updateCounter = 0.
	self updateCounter <= 0 ifTrue: [self updateCounter: self updateInterval].
	^ needsUpdate! !

!XpfProxyObject methodsFor: 'helping' stamp: 'cs 4/17/2009 16:52'!
parseJsonKey: key value: value

	^ key = 'timestamp'
		ifTrue: [key -> (TimeStamp fromString: value)]
		ifFalse: [super parseJsonKey: key value: value].! !

!XpfProxyObject methodsFor: 'printing' stamp: 'cs 4/17/2009 13:11'!
printString

	(self includesProperty: #title) ifTrue: [^ self title].
	(self includesProperty: #userName) ifTrue: [^ self userName].
	^ super printString! !

!XpfProxyObject methodsFor: 'accessing' stamp: 'cs 6/11/2009 14:55'!
properties: aDictionary 

	| wasLoaded |
	wasLoaded := self isLoaded and: [self isDeleted not].
	super properties: aDictionary.
	self updateCounter: self updateInterval.
	(wasLoaded and: [self isDeleted]) ifTrue: [self delete].! !

!XpfProxyObject methodsFor: 'accessing' stamp: 'mig 4/3/2009 15:29'!
revision

	^ properties isNil
		ifTrue: [nil]
		ifFalse: [super revision]! !

!XpfProxyObject methodsFor: 'accessing' stamp: 'mt 5/7/2009 10:38'!
updateCounter

	^ updateCounter ifNil: [0]! !

!XpfProxyObject methodsFor: 'accessing' stamp: 'mt 5/7/2009 10:34'!
updateCounter: anObject

	updateCounter := anObject.! !

!String methodsFor: '*xpf-client' stamp: 'mt 4/28/2009 16:39'!
withoutLineEndings

	^ self withSqueakLineEndings
		copyReplaceAll: String cr
		with: ' '
		asTokens: false! !

!String methodsFor: '*xpf-client' stamp: 'mt 4/28/2009 16:40'!
withoutLineEndingsTruncatedTo: aNumber

	^ self withoutLineEndings truncateWithElipsisTo: aNumber! !

PluggableTextMorph subclass: #XpfSaveEditingTextMorph
	instanceVariableNames: 'isBlocked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfSaveEditingTextMorph methodsFor: 'updating' stamp: 'topa 4/22/2009 15:22'!
update: aSymbol

	self hasUnacceptedEdits ifFalse: [super update: aSymbol].! !

TextMorph subclass: #XpfPluggableTextMorph
	instanceVariableNames: 'model getTextSelector isTruncatedWithEllipsis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfPluggableTextMorph class methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 20:18'!
on: model getTextSelector: selector

	^ self new
		model: model;
		getTextSelector: selector;
		yourself
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 20:18'!
changed

	super changed.
	(self model notNil and: [self getTextSelector notNil])
		ifTrue: [
			self update: self getTextSelector.
			self font: XpfClient sansFont].
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:48'!
getTextSelector

	^ getTextSelector
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:48'!
getTextSelector: anObject

	getTextSelector := anObject.
	self changed.
! !

!XpfPluggableTextMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 15:53'!
isTruncatedWithEllipsis
	"Discard all linebreaks and show first line with ellipsis according to extent."

	isTruncatedWithEllipsis ifNil: [self isTruncatedWithEllipsis: false].
	^ isTruncatedWithEllipsis! !

!XpfPluggableTextMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 15:52'!
isTruncatedWithEllipsis: aBoolean

	isTruncatedWithEllipsis := aBoolean! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:47'!
model

	^ model
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:47'!
model: anObject

	self model ifNotNil: [self model removeDependent: self].
	model := anObject.
	self model ifNotNil: [self model addDependent: self].
	self changed.
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 16:00'!
modelData

	^ (self model perform: self getTextSelector) ifNil: ['']! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'cs 4/29/2009 11:39'!
update: aSymbol

	aSymbol = self getTextSelector ifTrue: [
		self isTruncatedWithEllipsis
			ifFalse: [self updateContents]
			ifTrue: [self updateContentsTruncated]].
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 16:00'!
updateContents

	self contentsWrapped: self modelData.
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'cs 4/29/2009 11:36'!
updateContentsTruncated

	self contents: (self modelData asString withoutLineEndingsTruncatedTo: 20).! !

!TimeStamp methodsFor: '*xpf-client' stamp: 'mt 4/29/2009 11:54'!
printRelativeTimeStamp

	^ (self date printRelativeDate, ', ', self time print24WithoutSeconds)! !

PanelMorph subclass: #XpfDeveloperListEntryMorph
	instanceVariableNames: 'user onlineIcon userNameText connectDisconnectButton clientTunnel rfbClient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfDeveloperListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 13:57'!
forUser: anXpfUser

	^ self new
		user: anXpfUser! !

!XpfDeveloperListEntryMorph methodsFor: 'model' stamp: 'bs 7/8/2009 18:46'!
connect

	| forwardedVncClienPort |
	forwardedVncClienPort := 15000.
	clientTunnel := SSHTunnel new
							isLocalTunnel: true;
							localPort: forwardedVncClienPort;
							remotePort: self user sharingPort;
							server: self user repository url authority.
	clientTunnel execute.
	
	(0 to: 10) 
		do: [:ignore | (Delay forMilliseconds: 600) wait]
		displayingProgress: 'Giving SSH connection some time...'.

	rfbClient := RFBClient open.
	rfbClient xpfUserId: ActiveHand login.
	rfbClient connectToRfbHub: forwardedVncClienPort.! !

!XpfDeveloperListEntryMorph methodsFor: 'model' stamp: 'mt 5/6/2009 10:54'!
connectDisconnect

	self isConnected 
		ifFalse: [
			self connectDisconnectButton labelGraphic: MenuIcons xpfScreenDisconnect.
			self connect] 
		ifTrue: [
			self connectDisconnectButton labelGraphic: MenuIcons xpfScreenIndicatedShared.
			self disconnect].! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 14:22'!
connectDisconnectButton

	connectDisconnectButton ifNil: 
		[ self connectDisconnectButton: ((IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfScreenIndicatedShared;
			actionSelector: #connectDisconnect;
			setBalloonText: '')
			visible: self user sharingPort notNil)].	
	^ connectDisconnectButton! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:40'!
connectDisconnectButton: anObject 

	connectDisconnectButton := anObject! !

!XpfDeveloperListEntryMorph methodsFor: 'model' stamp: 'mt 4/27/2009 13:42'!
connectDisconnectLabel

	^ MenuIcons xpfScreenIndicatedShared asMorph! !

!XpfDeveloperListEntryMorph methodsFor: 'model' stamp: 'bs 4/27/2009 21:08'!
disconnect

	rfbClient ifNotNil: [
		rfbClient disconnectFromRfbHub.
		rfbClient close.
		rfbClient := nil].
	
	clientTunnel ifNotNil: [
		clientTunnel terminate.
		clientTunnel := nil].! !

!XpfDeveloperListEntryMorph methodsFor: 'as yet unclassified' stamp: 'cs 5/5/2009 10:40'!
initialize

	super initialize.
	self
		changeTableLayout;
		listDirection: #leftToRight;
		listCentering: #center;
		hResizing: #spaceFill;
		vResizing: #rigid;
		width: XpfDeveloperListWidget defaultExtent x;
		height: 20;
		cellInset: 4.! !

!XpfDeveloperListEntryMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 14:02'!
initializeUserInterface

	self
		removeAllMorphs;
		addMorphBack: self onlineIcon;
		addMorphBack: self userNameText;
		addMorphBack: self connectDisconnectButton.! !

!XpfDeveloperListEntryMorph methodsFor: 'model' stamp: 'bs 4/27/2009 18:59'!
isConnected
	
	^ clientTunnel notNil! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:59'!
onlineIcon

	onlineIcon ifNil: [self onlineIcon:
		(XpfPluggableImageMorph
			formOn: MenuIcons xpfDeveloperIsOnline
			formOff: MenuIcons xpfDeveloperIsOffline
			model: self user
			getOnOffSelector: #isOnline)].
	^ onlineIcon! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:35'!
onlineIcon: anObject

	onlineIcon := anObject.! !

!XpfDeveloperListEntryMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 16:54'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #sharingPort ifTrue: [
		self changed: #connectDisconnectLabel.
		self connectDisconnectButton visible: self user sharingPort notNil.
		self connectDisconnectButton setBalloonText: self user sharingPort asString].! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:57'!
user

	^ user! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 14:02'!
user: anXpfUser

	user ifNotNil: [user removeDependent: self].
	user := anXpfUser.
	user ifNotNil: [user addDependent: self].
	
	self initializeUserInterface.! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'cs 5/15/2009 13:22'!
userNameText

	userNameText ifNil: [self userNameText:
		((XpfPluggableTextMorph
			on: self user
			getTextSelector: #userName)
			lock;
			hResizing: #spaceFill)].
	^ userNameText! !

!XpfDeveloperListEntryMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:57'!
userNameText: anObject

	userNameText := anObject.! !

PanelMorph subclass: #XpfElementListMorph
	instanceVariableNames: 'model scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfElementListMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:34'!
defaultExtent

	^ self defaultWidth @ self defaultHeight.! !

!XpfElementListMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:33'!
defaultHeight

	self subclassResponsibility.! !

!XpfElementListMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:32'!
defaultWidth

	self subclassResponsibility.! !

!XpfElementListMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:43'!
for: anXpfIteration

	^self new model: anXpfIteration! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 13:38'!
buildList

	self submorphsDelete! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:32'!
initialize

	super initialize.
	self
		changeTableLayout;
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultExtent;
		listDirection: #topToBottom;
		fillStyle: Color transparent;
		borderWidth: 0;
		layoutInset: 0;
		cellInset: 2.! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'SR 4/11/2009 21:13'!
model

	^ model! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 13:39'!
model: anXpfIteration

	self model ifNotNil: [
		self model removeDependent: self.
		self model userStories ifNotNil: [self model userStories removeDependent: self]].
	
	model := anXpfIteration.
	self buildList.
	
	2 timesRepeat: [self scrollPane updateScrollbars]. "yep!!"
	
	self model ifNotNil: [
		self model addDependent: self.
		self model userStories ifNotNil: [self model userStories addDependent: self]].! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'mig 4/15/2009 16:20'!
scrollPane

	^ scrollPane ifNil: [scrollPane := GeneralScrollPane new]! !

!XpfElementListMorph methodsFor: 'accessing' stamp: 'cs 4/14/2009 17:01'!
scrollPane: anObject

	scrollPane := anObject.! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 13:38'!
submorphsDelete

	submorphs ifNotNilDo: [:s | s do: [:m | m delete]].! !

!XpfElementListMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:36'!
withScrollBars

	self 		
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	self scrollPane
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultExtent;
		fillStyle: Color transparent;
		borderWidth: 0;
		scrollTarget: self.
	^ self scrollPane! !

XpfElementListMorph subclass: #XpfTaskListMorph2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskListMorph2 class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:33'!
defaultHeight

	^ 500! !

!XpfTaskListMorph2 class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:31'!
defaultWidth 

	^ 180! !

!XpfTaskListMorph2 methodsFor: 'updating' stamp: 'cs 6/11/2009 14:57'!
buildList

	| filter |
	super buildList.
	self model ifNil: [^self].
	self model userStories
		do: [:us | us tasks isLoaded ifFalse: [us tasks reloadDepth: 3]]
		displayingProgress: 'Loading...'.

	filter := XpfTaskWidgetFilter new name: 'My';
		filterBlock: [:task | task responsibleDeveloper = self model currentUser & task isDone not].
	filter nextFilter: (XpfTaskWidgetFilter new name: 'Related';
		filterBlock: [:task | (task developers includes: self model currentUser) & task isDone not]).
	filter nextFilter: (XpfTaskWidgetFilter new name: 'Open';
		filterBlock: [:task | task isDone not]).
	filter nextFilter: (XpfTaskWidgetFilter new name: 'Finished').
	self model userStories do: [:us |
		us tasks
			do: [:task | filter process: task];			
			addDependent: self].
	
	filter createMorphListIn: self.! !

!XpfTaskListMorph2 methodsFor: 'updating' stamp: 'mt 5/14/2009 13:39'!
update: aSymbol

	aSymbol = #requestSorting | (aSymbol = #tasksLoaded) | (aSymbol = #userStoriesLoaded) ifTrue: [
		self buildList].
	super update: aSymbol.! !

XpfElementListMorph subclass: #XpfUserStoryListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfUserStoryListMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:33'!
defaultHeight

	^ 500! !

!XpfUserStoryListMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:31'!
defaultWidth 

	^ 200! !

!XpfUserStoryListMorph methodsFor: 'as yet unclassified' stamp: 'cs 6/11/2009 14:50'!
buildList
	super buildList.
	self model ifNil: [ ^ self ].
	self model userStories isLoaded ifFalse: [ self model userStories reloadDepth: 4 ].
	self model userStories do: [ :each | self addMorphBack: (XpfUserStoryListEntryMorph for: each) ]! !

!XpfUserStoryListMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 13:39'!
update: aSymbol

	aSymbol = #userStoriesLoaded ifTrue: [
		self buildList].
	super update: aSymbol.! !

PanelMorph subclass: #XpfEntityMorph
	instanceVariableNames: 'model inEditMode inZoomMode zoomContent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfEntityMorph class methodsFor: 'as yet unclassified' stamp: 'mt 3/13/2009 13:49'!
defaultColor

	^ self subclassResponsibility! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 7/1/2009 21:16'!
acceptChanges
	self acceptSubmorphs.
	self switchToViewMode.! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'cs 4/14/2009 18:28'!
acceptSubmorphs

	self model deferCommit: [
		self submorphsDo: [:m | m allMorphsDo: [:contentMorph |
			contentMorph isEntityMorphContent ifTrue: [contentMorph accept]]]].! !

!XpfEntityMorph methodsFor: 'content handling' stamp: 'bs 6/29/2009 13:38'!
buildContent
	self createMainContent! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 7/1/2009 21:16'!
cancelChanges
	self cancelSubmorphs.
	self switchToViewMode.! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'mt 4/28/2009 10:31'!
cancelSubmorphs

	self submorphsDo: [:m | m allMorphsDo: [:contentMorph |	
		contentMorph isEntityMorphContent ifTrue: [contentMorph cancel]]].! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 7/1/2009 21:16'!
click: evt

	evt yellowButtonPressed 
		ifTrue: [
			self openContextPopupMenu.
			evt wasHandled: true].
	
	(self inEditMode & evt redButtonPressed)
		ifTrue: [
			self cancelChanges.
			evt wasHandled: true].! !

!XpfEntityMorph methodsFor: 'private' stamp: 'SR 7/22/2009 11:28'!
createEstimateEdit
	| edit |
	edit := XpfCardEdit new
		convertTo: LargePositiveInteger;
		alwaysAccept: true;
		on: self
		text: #timeEstimated
		accept: #timeEstimated:
		readSelection: nil
		menu: nil;
		acceptOnCR: true;
		getEnabledSelector: #inEditMode;
		font: self theme textFont;
		cornerStyle: nil;
		hResizing: #rigid;
		vResizing: #rigid;
		borderStyle: (BorderStyle inset width: 1);
		color: Color white;
		hideScrollBarsIndefinitely;
		extent: 24@(self theme textFont height + 4);
		setBalloonText: nil.
	edit textMorph
		autoFit: true;
		wrapFlag: false;
		margins: (2@1 corner: 2@1).
	edit maxLength: 2;
		  borderWidth: 0;
		  color: Color transparent.
	^edit! !

!XpfEntityMorph methodsFor: 'content handling' stamp: 'bs 6/17/2009 10:43'!
createMainContent
	self subclassResponsibility! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'bs 6/22/2009 22:43'!
detailContentMorphs

	|morphs|
	
	(self hasProperty: #XpfTaskDetails) ifFalse: [
		morphs := self createDetailContentMorphs.
		morphs do: [:morph | self addMorphBack: morph].
		self setProperty: #XpfTaskDetails toValue: morphs ].
	
	^ self valueOfProperty: #XpfTaskDetails
	! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 7/1/2009 21:08'!
doubleClick: evt

	(evt redButtonPressed and: [self inEditMode not]) 
		ifTrue: [
			self switchToEditMode.
			evt wasHandled: true.
			].! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'mfp 3/18/2009 17:08'!
handlesMouseDown: evt

	^ true! !

!XpfEntityMorph methodsFor: 'content handling' stamp: 'bs 7/1/2009 19:58'!
hideDetailContent

	self detailContentMorph hide! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/19/2009 17:56'!
inEditMode

	^ inEditMode! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'bs 6/16/2009 23:01'!
inEditMode: anObject

	inEditMode := anObject.
	self update: #inEditMode.! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:30'!
inZoomMode

	^ inZoomMode! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:30'!
inZoomMode: anObject

	inZoomMode := anObject.! !

!XpfEntityMorph methodsFor: 'initialization' stamp: 'bs 6/29/2009 13:38'!
initialize
	super initialize.
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		inEditMode: false;
		inZoomMode: false;
		borderWidth: 1;
		color: self class defaultColor;
		enableDragNDrop;
		buildContent
	"layoutInset: 2;"! !

!XpfEntityMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 22:01'!
isXpfEntityMorph

	^true! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mt 3/13/2009 13:54'!
model

	^ model! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 17:17'!
model: anXpfEntity

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfEntity.
	
	self model ifNotNil: [
		self model addDependent: self].
	
	self updateContentModel.
	! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 6/29/2009 17:48'!
mouseDown: evt
	"Do nothing upon mouse-down except inform the hand to watch for a 
	double-click; wait until an ensuing click:, doubleClick:, or drag: 
	message gets dispatched"
	
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {#click:. #doubleClick:. nil. #startDrag:}
		threshold: 5.
	
	self comeToFront.! !

!XpfEntityMorph methodsFor: 'content handling' stamp: 'bs 7/1/2009 19:58'!
showDetailContent

	self detailContentMorph show.! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'SR 3/19/2009 19:39'!
startDrag: evt

	evt redButtonPressed ifTrue: [
		evt hand grabMorph: self].! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'bs 7/1/2009 20:56'!
switchToEditMode
	
	self toggleEditMode.! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'bs 7/1/2009 20:56'!
switchToViewMode
	
	self toggleEditMode.! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'bs 7/8/2009 19:15'!
timeEstimated
	^ self model timeEstimated ifNil: [0].! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'bs 6/16/2009 22:49'!
timeEstimated: aPositiveInteger
	^ self model timeEstimated: aPositiveInteger! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'SR 4/18/2009 11:26'!
toggleEditMode
	
	self 
		allSubmorphsWith: [:m | m isEntityMorphContent not] 
		do: [:m | m isEntityMorphContent ifTrue: [m toggleEditMode]].	
	self inEditMode: self inEditMode not.! !

!XpfEntityMorph methodsFor: 'not yet catagorized' stamp: 'bs 6/17/2009 10:03'!
toggleZoomMode
	
	self inEditMode ifTrue: [
		self cancelSubmorphs.
		self toggleEditMode].
	
	self inZoomMode
		ifTrue: [
			self hideDetailContent.
			self inZoomMode: false.
			self changed: #zoomOut]
		ifFalse: [
			self showDetailContent.
			self inZoomMode: true.
			self changed: #zoomIn].! !

!XpfEntityMorph methodsFor: 'event handling' stamp: 'bs 6/12/2009 13:25'!
update: aSymbol
	
	aSymbol = #accepted ifTrue: [
		self acceptChanges].
	
	aSymbol = #cancelled ifTrue: [
		self cancelSubmorphs.
		self toggleEditMode].
	
	aSymbol = #toggleZoom ifTrue: [self toggleZoomMode].
	aSymbol = #enterEditMode ifTrue: [self toggleEditMode].
	super update: aSymbol.

	! !

!XpfEntityMorph methodsFor: 'private' stamp: 'SR 4/18/2009 11:26'!
updateContentModel

	(self model isNil | self submorphs isNil) ifTrue: [^ self].
	self 
		allSubmorphsWith: [:m | m isEntityMorphContent not] 
		do: [:m | m isEntityMorphContent ifTrue: [m model: self model]].! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'SR 4/18/2009 11:09'!
zoomContent

	zoomContent ifNil: [
		self zoomContent: (XpfZoomButtonContent forModel: self model).
		self zoomContent addDependent: self.
		self addDependent: self zoomContent].
	^ zoomContent! !

!XpfEntityMorph methodsFor: 'accessing' stamp: 'mfp 3/18/2009 18:14'!
zoomContent: anObject

	zoomContent := anObject.! !

XpfEntityMorph subclass: #XpfTaskMorph
	instanceVariableNames: 'actionsMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskMorph class methodsFor: 'defaults' stamp: 'cs 5/13/2009 15:57'!
defaultColor

	^ Color lightRed alpha: 0.85! !

!XpfTaskMorph class methodsFor: 'defaults' stamp: 'cs 5/13/2009 15:57'!
defaultDoneColor

	^ Color lightGreen alpha: 0.85! !

!XpfTaskMorph class methodsFor: 'initialize-release' stamp: 'mfp 3/20/2009 11:23'!
forTask: anXpfTask

	^ self basicNew
		model: anXpfTask;
		initialize;
		update: anXpfTask! !

!XpfTaskMorph methodsFor: 'accessing' stamp: 'bs 6/23/2009 21:10'!
actionsMorph

	actionsMorph ifNil: [
		actionsMorph := (XpfTaskActionsContent forModel: self model).
		self actionsMorph addDependent: self.
		self addDependent: self actionsMorph].
	^ actionsMorph! !

!XpfTaskMorph methodsFor: 'content handling' stamp: 'bs 6/17/2009 10:12'!
createDetailContentMorphs

	^ {XpfSimpleTaskWidgetActionsContent forModel: self model.
		XpfTaskDeveloperContent forModel: self model}! !

!XpfTaskMorph methodsFor: 'content handling' stamp: 'bs 6/22/2009 22:39'!
createMainContent
	
	self layoutPolicy: TableLayout new.
	self
		addMorph: ((self theme 
				newRowIn: self
				for: { 
						(XpfTaskTitleContent forModel: self model).
						(self actionsMorph)
					 })
				layoutInset: 0;
				cellInset: 2;
				hResizing: #shrinkWrap);
		addMorphBack: ((self theme 
				newRowIn: self
				for: { 
						(self zoomContent).
						(XpfTaskProgressEstimationSliderContent withModel: self model)
					 })
				layoutInset: 0;
				cellInset: 5;
				hResizing: #shrinkWrap)! !

!XpfTaskMorph methodsFor: 'testing' stamp: 'mt 3/13/2009 14:50'!
isTaskMorph

	^ true! !

!XpfTaskMorph methodsFor: 'accessing' stamp: 'mfp 3/20/2009 11:21'!
openContextPopupMenu

	| menu |
	menu := MenuMorph new.
	menu addTitle: 'Set Status'.
	menu add: 'Done' target: self model selector: #isDone: argument: true.
	menu addLine.
	menu add: 'Open' target: self model selector: #isDone: argument: false.
	menu popUpInWorld.
! !

!XpfTaskMorph methodsFor: 'event handling' stamp: 'cs 5/13/2009 15:55'!
update: aSymbol

	super update: aSymbol.

	self model isDone
		ifTrue: [self color: self class defaultDoneColor]
		ifFalse: [self color: self class defaultColor]! !

!XpfTaskMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 3/19/2009 14:42'!
wantsToBeDroppedInto: aMorph

	^ aMorph acceptsTasks! !

XpfEntityMorph subclass: #XpfUserStoryMorph
	instanceVariableNames: 'actionsMorph card cancelButton acceptButton deleteButton historyButton actionHalosMorph progressBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryMorph class methodsFor: 'defaults' stamp: 'mfp 3/17/2009 15:34'!
defaultColor
	
	^	Color white.! !

!XpfUserStoryMorph class methodsFor: 'initialize-release' stamp: 'mfp 3/17/2009 16:04'!
forUserStory: anXpfUserStory

	^ self basicNew
		model: anXpfUserStory;
		initialize! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/27/2009 09:22'!
acceptButton

	^ acceptButton! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/26/2009 19:21'!
acceptButton: anObject

	acceptButton := anObject.! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/27/2009 09:41'!
actionHalosMorph

	^ actionHalosMorph! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/27/2009 09:41'!
actionHalosMorph: anObject

	^ actionHalosMorph := anObject! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/23/2009 21:10'!
actionsMorph

	actionsMorph ifNil: [
		actionsMorph := (XpfUserStoryActionsContent forModel: self model).
		self actionsMorph addDependent: self.
		self addDependent: self actionsMorph].
	^ actionsMorph! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'cs 7/21/2009 13:15'!
buildContent

	self
		borderWidth: 0;
		color: Color transparent;
		createMainContent;
		createZoomContent;
		createDetailContentMorph;
		createActionHalosMorph.! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/2/2009 11:41'!
calculateEstimationSumForAllTasks

	self model ifNil: [^ 0].
	^ self model tasks 
		inject: 0 
		into: [:subTotal :task |
			task timeEstimated 
				ifNotNil: [subTotal + task timeEstimated] 
				ifNil: [subTotal]]! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/2/2009 11:41'!
calculateEstimationSumForCompletedTasks

	self model ifNil: [^ 0].
	^ self model tasks 
		inject: 0 
		into: [:subTotal :task |
			(task isDone and: [task timeEstimated notNil])  
				ifTrue: [subTotal + task timeEstimated] 
				ifFalse: [subTotal]]
! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/2/2009 11:41'!
calculateProgressBarValue

	^ self model 
		ifNotNil: [ self calculateEstimationSumForAllTasks = 0.0 
			ifTrue: [ 0.0 ]
			ifFalse: [self calculateEstimationSumForCompletedTasks / self calculateEstimationSumForAllTasks]]! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/27/2009 09:22'!
cancelButton

	^ cancelButton! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/26/2009 19:20'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/30/2009 17:46'!
cardMorph
	^ card! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 7/8/2009 22:12'!
color: aColor
	super color: aColor.! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/26/2009 19:25'!
createAcceptButton

	self acceptButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfAccept;
			actionSelector: #acceptChanges;
			setBalloonText: 'Accept changes').
	^ self acceptButton! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 7/21/2009 08:41'!
createActionHalosMorph

	self createDeleteButton.
	self createHistoryButton.
	self createCancelButton.
	self createAcceptButton.
	
	self actionHalosMorph: (self newColumnFor: {}).
	self addMorphBack: self actionHalosMorph.
	self actionHalosMorph 
		extent: 20 @ self height;
		position: self width @ 0;
		hide.
	
	self actionHalosMorph addMorphBack: self deleteButton.
	self actionHalosMorph addMorphBack: self historyButton.
	
	^ self actionHalosMorph! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/26/2009 19:23'!
createCancelButton

	self cancelButton:(IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfCancel;
			actionSelector: #cancelChanges;
			setBalloonText: 'Cancel changes').
	^ self cancelButton! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/23/2009 22:19'!
createDeleteButton

	self deleteButton: (IconicButton new
		color: Color transparent;
		target: self;
		borderWidth: 0;
		labelGraphic: MenuIcons xpfCancel;
		actionSelector: #deleteStory;
		setBalloonText: 'Show history of this user story').
	^ self deleteButton! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/21/2009 08:31'!
createDetailContentMorph

	| yOffset |
	self assert: self zoomContent notNil description: 'zoomContent must not be nil. it has to be created before detailContent is built'.
	yOffset := self height + self zoomContent height.
	self detailContentMorph: (XpfTasksContent forModel: self model tasks).
	self addMorphBack: self detailContentMorph.
	^ self detailContentMorph 
		position: 0 @ yOffset;
		hide;
		yourself! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/8/2009 17:54'!
createEstimationCircleMorph
	|circle segment radius iterationUnits storyCosts gamma vertices deltaY deltaX offset segmentColor |
	
	radius := 30.
	iterationUnits := 60 * 100.
	storyCosts := self timeEstimated * 100.
	
	circle := CircleMorph new.
	circle extent: (2*radius)@(2*radius);
						 borderWidth: 0;
						 color: Color veryVeryLightGray.

	(storyCosts > 0) ifTrue: [
	gamma := 360 / iterationUnits.
	vertices := OrderedCollection new.
	vertices addAll: {0@0. radius@0}.

	1 to: storyCosts do: [:i |
		deltaY := (gamma*i) degreeSin * radius.
		deltaX := ((radius*radius) - (deltaY*deltaY)) sqrt.
		vertices add: (deltaX rounded * (gamma*i+90) degreeSin sign)@(deltaY rounded).
	].
	segmentColor := Color r: 1.0 g: 0.725 b: 0.482.
	segment := (PolygonMorph vertices: vertices color: segmentColor borderWidth: 0 borderColor: nil).
	
	offset := circle extent - segment extent.
	circle addMorph: segment.
	segment position: offset.
	].
	^ circle.! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/23/2009 21:53'!
createHistoryButton

	self historyButton: (IconicButton new
		color: Color transparent;
		target: self;
		borderWidth: 0;
		labelGraphic: MenuIcons xpfHistory;
		actionSelector: #showHistory;
		setBalloonText: 'Show history of this user story').
	^ self historyButton! !

!XpfUserStoryMorph methodsFor: 'private' stamp: 'bs 6/17/2009 10:42'!
createLayoutContainer
	| container estimationCircle |
	container := Morph new.
	container
		extent: 170 @ 100;
		color: Color transparent;
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	self addMorph: container.
	estimationCircle := self createEstimationCircleMorph.
	estimationCircle center: 140 @ 70.
	self addMorphBack: estimationCircle.
	^ container! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/21/2009 08:26'!
createMainContent
	| content estimationCircle |
	
	card := Morph new.
	card
		color: Color white;
		borderColor: Color black;
		borderWidth: 1;
		extent: (self width @ self height).
	
	content := Morph new.
	content
		color: Color transparent;
		layoutInset: 1;
		layoutPolicy: TableLayout new;
		vResizing: #spaceFill.
		
	card addMorphBack: content.
	estimationCircle := (XpfEstimationCircleMorph nUnits: 60 segmentUnitsComputing: [self timeEstimated]).
	estimationCircle center: (self width - 30 - 1) @ (self height - 30 - 1).
	card addMorphBack: estimationCircle.
	
	self createProgressBar.
	self progressBar extent: 10@118.
	self progressBar position: 0@0.
	
	content addMorphBack: (self newRowFor: {
		(self progressBar).
		(self newColumnFor: {
			(XpfUserStoryTitleContent forModel: self model).
			(self newRowFor: {
				self createEstimateEdit}) listDirection: #rightToLeft
			}) 
			vResizing: #shrinkWrap.
		}).
	
	self addMorphBack: card.
	^ card.! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/8/2009 22:52'!
createProgressBar
	self progressBar: (XpfProgressBarMorph new
			borderWidth: 0;
			color: Color transparent;
			progressColor: Color lightGreen;
			extent: 10@100).
	self updateProgressBar.
	^ self progressBar! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 6/11/2009 17:15'!
createTitleViewFor: aUserStory

	^ (XpfPluggableTextMorph
			on: aUserStory
			getTextSelector: #title)
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			margins: 3@0;
			extent: 170@100! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'cs 7/21/2009 13:16'!
createZoomContent

	self
		zoomContent: (XpfZoomButtonContent forModel: self model);
		addDependent: self zoomContent;
		addMorphBack: self zoomContent.	
	^ self zoomContent
		addDependent: self;
		position: 0 @ self height;
		hide;
		yourself! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/27/2009 09:22'!
deleteButton
	^ deleteButton ! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/23/2009 22:15'!
deleteButton: anObject
	deleteButton := anObject! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/23/2009 22:17'!
deleteStory

	self model delete. self delete! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 6/30/2009 13:54'!
detailContentMorph

	^ self valueOfProperty: #XpfTaskDetails
	! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 6/30/2009 13:54'!
detailContentMorph: morphs

	^ self setProperty: #XpfTaskDetails toValue: morphs.	! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 6/30/2009 16:02'!
detailContentMorphs

	^ {self detailContentMorph}
	! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'bs 6/29/2009 18:09'!
handlesMouseOver: anEvent
	^ true.! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'mt 4/28/2009 19:23'!
hasNewUserStory

	^ self model isKindOf: XpfNewUserStory! !

!XpfUserStoryMorph methodsFor: 'layout' stamp: 'bs 7/21/2009 08:00'!
height
	^ 120! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 7/1/2009 20:14'!
hideHalos
	self actionHalosMorph hide.
	! !

!XpfUserStoryMorph methodsFor: 'zoom' stamp: 'bs 7/21/2009 08:49'!
hideZoomContent
	^ self detailContentMorph visible! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/27/2009 09:23'!
historyButton

	^ historyButton ! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 6/23/2009 21:53'!
historyButton: anObject

	historyButton := anObject! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'bs 6/30/2009 13:36'!
initialize
	
	super initialize.
	self
		cellInset: 0;
		updateColor; 
		updatePosition.! !

!XpfUserStoryMorph methodsFor: 'testing' stamp: 'topa 3/4/2009 00:21'!
isUserStoryMorph

	^ true! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'bs 7/21/2009 08:52'!
mouseEnter: anEvent
	super mouseEnter: anEvent.
	self showsHalos
		ifFalse: [self showHalos].
		
	self showsDetails
		ifFalse: [self zoomContent show]! !

!XpfUserStoryMorph methodsFor: 'event handling' stamp: 'bs 7/21/2009 09:01'!
mouseLeave: anEvent
	super mouseLeave: anEvent.
	self showsHalos 
		ifTrue: [self hideHalos].
		
	self showsDetails 
		ifFalse: [self zoomContent hide]! !

!XpfUserStoryMorph methodsFor: 'private' stamp: 'mig 4/3/2009 13:44'!
openContextPopupMenu

	| menu |
	menu := MenuMorph new.
	menu addTitle: 'Set Color'.
	#(red orange yellow green cyan blue magenta gray white) do: [:currentColor |
		menu
			add: currentColor asString capitalized
			target: self model
			selector: #color:
			argument: currentColor asString].
	menu popUpInWorld.
! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 7/2/2009 11:39'!
progressBar
	^ progressBar! !

!XpfUserStoryMorph methodsFor: 'accessing' stamp: 'bs 7/2/2009 11:39'!
progressBar: anObject
	^ progressBar := anObject! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 7/1/2009 20:15'!
showHalos
	self actionHalosMorph show.! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 6/23/2009 21:56'!
showHistory

	self model repository changed: #showHistory with: self model.! !

!XpfUserStoryMorph methodsFor: 'zoom' stamp: 'bs 7/21/2009 08:49'!
showZoomContent
	^ self detailContentMorph visible! !

!XpfUserStoryMorph methodsFor: 'zoom' stamp: 'bs 7/21/2009 08:49'!
showsDetails
	^ self detailContentMorph visible! !

!XpfUserStoryMorph methodsFor: 'halos' stamp: 'bs 7/1/2009 20:30'!
showsHalos
	^ self actionHalosMorph visible.! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/1/2009 21:05'!
switchToEditMode
	super switchToEditMode.
	self actionHalosMorph 
		addMorphBack: self cancelButton; 
		addMorphBack: self acceptButton.
		
	Transcript cr; show: 'test'.! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/1/2009 21:05'!
switchToViewMode
	super switchToViewMode.
	self actionHalosMorph 
		removeMorph: self cancelButton; 
		removeMorph: self acceptButton.
		
	Transcript cr; show: 'testview'.	! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'bs 7/2/2009 11:42'!
update: aSymbol 

	super update: aSymbol.
	
	aSymbol = #color ifTrue: [ self updateColor ].
	aSymbol = #positionX ifTrue: [self left: self updatedPosition x].
	aSymbol = #positionY ifTrue: [self top: self updatedPosition y].

	self updateProgressBar.! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'bs 6/23/2009 20:52'!
updateColor

	card color: (Color colorFrom: self model color asSymbol) muchLighter.! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'mt 4/28/2009 17:20'!
updateContentModel

	(self model isNil | self submorphs isNil) ifTrue: [^ self].
	self 
		allSubmorphsWith: [:m | m isEntityMorphContent not] 
		do: [:m | m isEntityMorphContent ifTrue: [
			(m isKindOf: XpfTasksContent)	
				ifTrue: [m model: self model tasks]
				ifFalse: [m model: self model]]].! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/8/2009 18:16'!
updateEstimation
	! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'topa 4/22/2009 16:43'!
updatePosition
	
	self position: self updatedPosition.! !

!XpfUserStoryMorph methodsFor: 'content handling' stamp: 'bs 7/2/2009 11:49'!
updateProgressBar

	self progressBar ifNotNil: [
		self progressBar value contents: self calculateProgressBarValue]! !

!XpfUserStoryMorph methodsFor: 'updating' stamp: 'topa 4/22/2009 16:50'!
updatedPosition
	
	^ self gridPoint: 
		((self model positionX / 10000.0) @
		(self model positionY / 10000.0)).! !

!XpfUserStoryMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 3/18/2009 16:58'!
wantsToBeDroppedInto: aMorph

	^ aMorph acceptsUserStories! !

!XpfUserStoryMorph methodsFor: 'layout' stamp: 'bs 7/21/2009 08:01'!
width
	^ 180! !

PanelMorph subclass: #XpfEntityMorphContent
	instanceVariableNames: 'model inEditMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

XpfEntityMorphContent subclass: #XpfActionsContent
	instanceVariableNames: 'editModeButton historyButton acceptButton cancelButton estimationIcon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
acceptButton

	acceptButton ifNil: [
		self acceptButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfAccept;
			actionSelector: #acceptChanges;
			setBalloonText: 'Accept changes')].
	^ acceptButton! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:22'!
acceptButton: anObject

	acceptButton := anObject.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 16:22'!
acceptChanges

	self changed: #accepted.! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
cancelButton

	cancelButton ifNil: [
		self cancelButton:(IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfCancel;
			actionSelector: #cancelChanges;
			setBalloonText: 'Cancel changes')].
	^ cancelButton! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:22'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 16:22'!
cancelChanges

	self changed: #cancelled.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'mt 4/24/2009 15:23'!
createEditModeLayout

	self addMorphBack: self cancelButton.
	self addMorphBack: self acceptButton.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'bs 6/12/2009 13:42'!
createNormalModeLayout
! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
editModeButton

	editModeButton ifNil: [
		self editModeButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfEdit;
			actionSelector: #switchEditMode;
			setBalloonText: 'Toggle edit mode')].
	^ editModeButton! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:37'!
editModeButton: anObject

	editModeButton := anObject! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:38'!
historyButton

	historyButton ifNil: [
		self historyButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfHistory;
			actionSelector: #showHistory;
			setBalloonText: 'Show history of this user story')].
	^ historyButton! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 21:38'!
historyButton: anObject

	historyButton := anObject! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'bs 6/12/2009 13:45'!
initialize

	super initialize.
	self
		createNormalModeLayout;
		vResizing: #spaceFill;
		hResizing: #shrinkWrap;
		changed.! !

!XpfActionsContent methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:09'!
showHistory

	self model repository changed: #showHistory with: self model.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 16:25'!
switchEditMode

	self changed: #enterEditMode.! !

!XpfActionsContent methodsFor: 'as yet unclassified' stamp: 'bs 6/12/2009 13:53'!
toggleEditMode

	super toggleEditMode.
	
	self removeAllMorphs.
	self extent: 0@0.
	
	self inEditMode
		ifFalse: [self createNormalModeLayout]
		ifTrue: [self createEditModeLayout].
		
	self changed.
	! !

XpfActionsContent subclass: #XpfTaskActionsContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskActionsContent class methodsFor: 'as yet unclassified' stamp: 'bs 6/12/2009 13:44'!
defaultExtent

	^ 0@20! !

XpfActionsContent subclass: #XpfUserStoryActionsContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryActionsContent class methodsFor: 'as yet unclassified' stamp: 'bs 6/12/2009 13:43'!
defaultExtent

	^ 0@40! !

!XpfEntityMorphContent class methodsFor: 'as yet unclassified' stamp: 'mfp 3/17/2009 16:48'!
defaultExtent

	self subclassResponsibility.! !

!XpfEntityMorphContent class methodsFor: 'as yet unclassified' stamp: 'mfp 4/30/2009 13:50'!
forModel: anXpfEntity

	^ (self basicNew)
	 	model: anXpfEntity;
		initialize! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 15:30'!
accept! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 16:08'!
cancel! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:26'!
inEditMode

	^ inEditMode! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:26'!
inEditMode: anObject

	inEditMode := anObject.! !

!XpfEntityMorphContent methodsFor: 'initialization' stamp: 'mfp 3/18/2009 15:38'!
initialize

	super initialize.
	self 
		inEditMode: false;
		layoutPolicy: TableLayout new;
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultExtent;
		fillStyle: Color transparent.! !

!XpfEntityMorphContent methodsFor: 'testing' stamp: 'mfp 3/19/2009 16:13'!
isEntityMorphContent

	^ true! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/17/2009 15:09'!
model

	^ model! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mt 4/28/2009 18:33'!
model: anXpfEntity

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfEntity.
	self model ifNotNil: [self model addDependent: self].
	
	self update.! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'SR 4/10/2009 15:58'!
toggleEditMode

	self
		inEditMode: (self inEditMode not);
		update.
	! !

!XpfEntityMorphContent methodsFor: 'accessing' stamp: 'mfp 3/18/2009 15:30'!
update! !

XpfEntityMorphContent subclass: #XpfEstimationContent
	instanceVariableNames: 'estimated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfEstimationContent class methodsFor: 'defaults' stamp: 'cs 4/14/2009 18:31'!
defaultExtent

	^ 40@20! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 13:14'!
estimated

	estimated ifNil: [
		self estimated: (self theme newLabelIn: self label: '').
		self estimated
			hResizing: #shrinkWrap;
			disabledStyle: #plain;
			font: XpfClient sansFont.
		self updateLabel].
	
	^ estimated! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'cs 4/14/2009 18:27'!
estimated: anObject

	estimated := anObject.! !

!XpfEstimationContent methodsFor: 'initialization' stamp: 'mt 4/25/2009 16:56'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		listCentering: #center;
		cellInset: 3;
		layoutInset: 2;
		addMorph: MenuIcons xpfClock asMorph;
		addMorphBack: ((self theme newToolSpacerIn: self) hResizing: #spaceFill; vResizing: #rigid);
		addMorphBack: self estimated;
		update.! !

!XpfEstimationContent methodsFor: 'as yet unclassified' stamp: 'SR 4/18/2009 10:43'!
model: aModel

	super model: aModel.
	self updateLabel! !

!XpfEstimationContent methodsFor: 'accessing' stamp: 'SR 4/18/2009 10:57'!
update: aSymbol

	aSymbol = #timeEstimated ifTrue: [self updateLabel].
	super update: aSymbol.! !

!XpfEstimationContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/16/2009 13:58'!
updateLabel

	self model ifNil: [^self].
	self model timeEstimated ifNil: [^self].
	self estimated contents: (self model timeEstimated asString)", ' hrs'".! !

XpfEntityMorphContent subclass: #XpfProgressEstimationSliderContent
	instanceVariableNames: 'estimationSlider estimationContent progressBar estimationSliderModel isUserStory proxyModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfProgressEstimationSliderContent class methodsFor: 'as yet unclassified' stamp: 'mfp 4/23/2009 15:00'!
withModel: aModel

	^ self new
		model: aModel;
		initializeUserInterface
! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:41'!
accept

	self model timeEstimated: self estimationSliderModel timeEstimated.
	super accept! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:21'!
barOrSliderExtent

	self subclassResponsibility! !

!XpfProgressEstimationSliderContent methodsFor: 'private' stamp: 'topa 4/23/2009 14:25'!
calculateProgressBarValue

	self subclassResponsibility! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:41'!
cancel

	self estimationSliderModel timeEstimated: (self model timeEstimated ifNil: [0.0]).
	super cancel! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:35'!
currentQuantum

	self subclassResponsibility! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'bs 6/16/2009 22:31'!
estimationContent

	estimationContent ifNil: [
		"estimationContent := (XpfEstimationContent forModel: self estimationSliderModel)"
		estimationContent := (UITheme current
				newTextEntryIn: self
				for: self estimationSliderModel
				get: #timeEstimated
				set: #timeEstimated:
				class: LargePositiveInteger
				getEnabled: #isEnabled
				help: '') maxLength: 2. ].
	^ estimationContent! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:42'!
estimationContent: anObject

	estimationContent := anObject.! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mfp 4/21/2009 16:23'!
estimationSlider

	estimationSlider ifNil: [self estimationSlider:
		((self theme newSliderIn: self
			for: self estimationSliderModel
			getValue: #timeEstimated  
			setValue:  #timeEstimated:
			min: 0.5  
			max: self maxEstimation  
			quantum: self currentQuantum  
			getEnabled: nil  
			help: 'Drag slider to adjust estimated time required')
			height: self barOrSliderExtent y;
			width: self barOrSliderExtent x;
			vResizing: #rigid;
			hResizing: #rigid)].
	^ estimationSlider! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mfp 4/16/2009 11:16'!
estimationSlider: anObject
	
	estimationSlider := anObject.! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 12:26'!
estimationSliderModel

	estimationSliderModel ifNil: [
		self estimationSliderModel: XpfProgressEstimationSliderModel new].
	^ estimationSliderModel! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:37'!
estimationSliderModel: anObject

	estimationSliderModel := anObject.! !

!XpfProgressEstimationSliderContent methodsFor: 'initialization' stamp: 'mt 4/25/2009 17:32'!
initializeUserInterface

	self
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		cellInset: 14;
		updateUserInterface;
		update.! !

!XpfProgressEstimationSliderContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/23/2009 13:39'!
isTask

	^ self isUserStory not! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:34'!
maxEstimation

	self subclassResponsibility! !

!XpfProgressEstimationSliderContent methodsFor: 'initialization' stamp: 'mt 5/14/2009 12:25'!
model: anXpfUserStoryOrTaskEntity
	
	super model: anXpfUserStoryOrTaskEntity.
	self model ifNotNilDo: [:m |
		self estimationSliderModel
			timeEstimated: (m timeEstimated ifNil: [0.0])].
	! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 5/15/2009 19:25'!
progressBar

	progressBar ifNil: [self progressBar:
		(ProgressBarMorph new
			borderWidth: 1;
			color: (Color r: 0.5 g: 0.5 b: 0.5 alpha: 0.7);
			progressColor: Color lightGreen;
			extent: self barOrSliderExtent).
		self updateProgressBar].
	^ progressBar! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'SR 4/17/2009 11:17'!
progressBar: anObject

	progressBar := anObject.! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 18:51'!
toggleEditMode

	super toggleEditMode.
	self updateUserInterface.
! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 13:52'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #timeEstimated ifTrue: [self estimationSliderModel timeEstimated: (self model timeEstimated ifNil: [0.0])].
	self updateProgressBar.! !

!XpfProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 14:44'!
updateProgressBar

	self progressBar value contents: self calculateProgressBarValue.	! !

!XpfProgressEstimationSliderContent methodsFor: 'as yet unclassified' stamp: 'mt 4/24/2009 18:16'!
updateUserInterface

	self
		removeAllMorphs;
		addMorph: (self inEditMode 
			ifTrue: [self estimationSlider]
			ifFalse: [self progressBar]);
		addMorphBack:	self estimationContent.! !

XpfProgressEstimationSliderContent subclass: #XpfTaskProgressEstimationSliderContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

XpfTaskProgressEstimationSliderContent subclass: #XpfTaskProgressContentForWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskProgressContentForWidget methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 12:30'!
barOrSliderExtent

	^  95 @ 10! !

!XpfTaskProgressEstimationSliderContent class methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2009 16:12'!
defaultExtent

	^ 150@20! !

!XpfTaskProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 4/25/2009 17:30'!
barOrSliderExtent

	^  68 @ 10! !

!XpfTaskProgressEstimationSliderContent methodsFor: 'private' stamp: 'topa 4/23/2009 14:24'!
calculateProgressBarValue

	^ self model 
		ifNil: [0.0]
		ifNotNil: [(self model timeEstimated isNil not and: [self model timeActual isNil not] and: [self model timeEstimated > 0.0])
			ifFalse: [0.0]
			ifTrue: [self model timeActual / self model timeEstimated]]! !

!XpfTaskProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:27'!
currentQuantum

	^ 0.5! !

!XpfTaskProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:34'!
maxEstimation

	^ 20.0! !

!XpfTaskProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 5/15/2009 19:19'!
updateProgressBar

	super updateProgressBar.
	self model ifNotNilDo: [:m |
		self progressBar assureExtension
			balloonText: ('Actual time: {1}' format: {((m timeActual ifNil: [0.0]) * 10) truncated / 10 asFloat}).
		(m timeActual notNil & m timeEstimated notNil
		and: [m timeActual > m timeEstimated])
			ifTrue: [self progressBar
				borderWidth: 2;
				borderColor: Color red]
			ifFalse: [self progressBar
				borderWidth: 1;
				borderColor: Color black]].! !

XpfProgressEstimationSliderContent subclass: #XpfUserStoryProgressEstimationSliderContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryProgressEstimationSliderContent class methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2009 16:12'!
defaultExtent

	^ 140@20! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mt 4/25/2009 17:29'!
barOrSliderExtent

	^ 103 @ 10! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:25'!
calculateEstimationSumForAllTasks

	self model ifNil: [^ 0].
	^ self model tasks 
		inject: 0 
		into: [:subTotal :task |
			task timeEstimated 
				ifNotNil: [subTotal + task timeEstimated] 
				ifNil: [subTotal]]! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:26'!
calculateEstimationSumForCompletedTasks

	self model ifNil: [^ 0].
	^ self model tasks 
		inject: 0 
		into: [:subTotal :task |
			(task isDone and: [task timeEstimated notNil])  
				ifTrue: [subTotal + task timeEstimated] 
				ifFalse: [subTotal]]
! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'private' stamp: 'mfp 4/23/2009 14:57'!
calculateProgressBarValue

	^ self model 
		ifNotNil: [ self calculateEstimationSumForAllTasks = 0.0 
			ifTrue: [ 0.0 ]
			ifFalse: [self calculateEstimationSumForCompletedTasks / self calculateEstimationSumForAllTasks]]! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:27'!
currentQuantum

	^ 1.0! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 14:34'!
maxEstimation

	^ 60.0! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mfp 4/23/2009 14:54'!
model: anXpfUserStory

	super model: anXpfUserStory.
	self model tasks do: [:task | task addDependent: self].
	self model tasks addDependent: self.! !

!XpfUserStoryProgressEstimationSliderContent methodsFor: 'accessing' stamp: 'mfp 4/23/2009 14:50'!
update: aSymbol with: anObject

	super update: aSymbol with: anObject.
	aSymbol = #tasksAdded ifTrue: [anObject addDependent: self].
	aSymbol = #tasksRemoved ifTrue: [anObject removeDependent: self]
! !

XpfEntityMorphContent subclass: #XpfTaskDeveloperContent
	instanceVariableNames: 'responsibleDeveloperButton responsibleDeveloperLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskDeveloperContent class methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 18:26'!
defaultExtent

	^ 100 @25! !

!XpfTaskDeveloperContent class methodsFor: 'as yet unclassified' stamp: 'cs 5/7/2009 15:13'!
forModel: anXpfTask

	^ (super forModel: anXpfTask)
		update: #responsibleDeveloper! !

!XpfTaskDeveloperContent methodsFor: 'initialization' stamp: 'mt 5/14/2009 12:38'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		layoutInset: 0;
		cellInset: 0;
		addMorphBack: self responsibleDeveloperButton;
		addMorphBack: (UITheme current newRowIn: self for: {self responsibleDeveloperLabel}).! !

!XpfTaskDeveloperContent methodsFor: 'model actions' stamp: 'mt 5/14/2009 10:45'!
responsibleDeveloper
	
	^ self model responsibleDeveloper
		ifNil: ['(nobody)']
		ifNotNilDo: [:dev | dev userName]! !

!XpfTaskDeveloperContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 10:05'!
responsibleDeveloperButton

	responsibleDeveloperButton ifNil: [
		self responsibleDeveloperButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfUser;
			actionSelector: #showDeveloper;
			setBalloonText: 'Show all developers for this task.')].
	^ responsibleDeveloperButton! !

!XpfTaskDeveloperContent methodsFor: 'accessing' stamp: 'cs 5/13/2009 14:20'!
responsibleDeveloperButton: anObject

	responsibleDeveloperButton := anObject.! !

!XpfTaskDeveloperContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 10:42'!
responsibleDeveloperLabel

	responsibleDeveloperLabel ifNil: [
		self responsibleDeveloperLabel: '' asMorph].
	^ responsibleDeveloperLabel! !

!XpfTaskDeveloperContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 10:06'!
responsibleDeveloperLabel: anObject

	responsibleDeveloperLabel := anObject.! !

!XpfTaskDeveloperContent methodsFor: 'model actions' stamp: 'mig 4/15/2009 18:23'!
showDeveloper

	World openModal: (XpfTaskDeveloperDialog new model: self model)! !

!XpfTaskDeveloperContent methodsFor: 'updating' stamp: 'mt 5/14/2009 12:40'!
update: aSymbol
	
	aSymbol = #responsibleDeveloper ifTrue: [
		self responsibleDeveloperLabel
			font: (XpfClient sansFontAt: 9);
			contents: (self responsibleDeveloper truncateWithElipsisTo: 20);
			width: 135].
	super update: aSymbol.! !

XpfEntityMorphContent subclass: #XpfTaskWidgetActionsContent
	instanceVariableNames: 'startStopButton editTimeButton takeResponsibilityButton startTime doneButton reopenButton userStoryArea'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

XpfTaskWidgetActionsContent subclass: #XpfSimpleTaskWidgetActionsContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfSimpleTaskWidgetActionsContent methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 15:42'!
initialize

	super initialize.

	self
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		layoutInset: 5.! !

!XpfSimpleTaskWidgetActionsContent methodsFor: 'as yet unclassified' stamp: 'mt 5/15/2009 15:42'!
initializeUserInterface

	self
		addMorphBack: ('Other Options: ' asMorph
			font: (XpfClient sansFontAt: 9));
		addMorphBack: self takeResponsibilityButton;
		addMorphBack: self startStopButton;
		addMorphBack: self editTimeButton;
		addMorphBack: self doneButton;
		addMorphBack: self reopenButton.! !

!XpfTaskWidgetActionsContent class methodsFor: 'as yet unclassified' stamp: 'topa 4/21/2009 17:53'!
defaultExtent

	^ 50@27! !

!XpfTaskWidgetActionsContent methodsFor: 'testing' stamp: 'mt 5/14/2009 09:51'!
alreadyResponsible

	^ self model notNil
		and: [self model responsibleDeveloper notNil
		and: [self model responsibleDeveloper = self model currentUser]]! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 16:21'!
doneButton

	doneButton ifNil: [
		self doneButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfDone;
			actionSelector: #doneWork;
			setBalloonText: 'Finish this task')].
	^ doneButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 16:06'!
doneButton: aButton

	doneButton := aButton.! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'topa 4/23/2009 17:15'!
doneWork

	self model isDone: true.
	self stopWork.
	! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'mt 5/15/2009 15:38'!
editTime

	| result |
	self model ifNil: [^ self].
	
	result := UITheme current
		textEntryIn: self
		text: 'Enter a new actual', String cr, ' time for this task:'
		title: 'Set actual time'
		entryText: ((self model timeActual ifNil: [0.0]) * 10) truncated / 10 asFloat.
		
	result ifNil: [^ self].
	
	self model timeActual: result asNumber asFloat.! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mt 5/15/2009 15:42'!
editTimeButton

	editTimeButton ifNil: [
		self editTimeButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfClockEdit;
			actionSelector: #editTime;
			setBalloonText: ('Set actual time. This is an alternative way to the start/stop mechanism.' withNoLineLongerThan: 60))].
	^ editTimeButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mt 5/15/2009 15:09'!
editTimeButton: anObject

	editTimeButton := anObject.! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'mt 5/15/2009 16:04'!
estimateTask

	| result |
	self model ifNil: [^ false].
	
	result := UITheme current
		textEntryIn: self
		text: 'You may only be responsible', String cr, ' if you can estimate this task:'
		title: 'Take responsibility'
		entryText: ((self model timeEstimated ifNil: [0.0]) * 10) truncated / 10 asFloat.
		
	result ifNil: [^ false].
	
	self model timeEstimated: result asNumber asFloat.
	^ true.! !

!XpfTaskWidgetActionsContent methodsFor: 'initialization' stamp: 'mt 5/14/2009 15:33'!
initialize

	super initialize.
	self
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		initializeUserInterface.! !

!XpfTaskWidgetActionsContent methodsFor: 'initialization' stamp: 'mt 5/15/2009 15:11'!
initializeUserInterface

	self
		addMorphBack: self userStoryArea;
		addMorphBack: self takeResponsibilityButton;
		addMorphBack: self startStopButton;
		addMorphBack: self editTimeButton;
		addMorphBack: self doneButton;
		addMorphBack: self reopenButton.! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 16:38'!
model: aModel

	super model: aModel.
	self updateAll.! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'topa 4/23/2009 16:34'!
reopen

	self model isDone: false.! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 16:22'!
reopenButton

	reopenButton  ifNil: [
		self reopenButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfPencil;
			actionSelector: #reopen;
			setBalloonText: 'Re-open this task')].
	^ reopenButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 16:17'!
reopenButton: anObject

	reopenButton := anObject.! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 15:11'!
startStopButton

	startStopButton ifNil: [
		self startStopButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfClockPlay;
			actionSelector: #toggleStartStop;
			setBalloonText: 'Start work and choose Co-Developer')].
	^ startStopButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mig 4/15/2009 18:14'!
startStopButton: anObject

	startStopButton := anObject! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'mt 5/14/2009 11:00'!
startWork

	| secondDeveloper |
	secondDeveloper := (World openModal: (XpfDeveloperChooser for: self model)) result.
	secondDeveloper ifNil: [^self].

	self model
		addDeveloper: self model currentUser;
		addDeveloper: secondDeveloper;
		isStarted: true.! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'cs 4/23/2009 14:19'!
stopWork

	self model isStarted: false.! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'mt 5/15/2009 16:02'!
takeResponsibility

	self estimateTask
		ifTrue: [
			self model responsibleDeveloper: self model currentUser.
			self model developers reload].! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mt 5/12/2009 18:46'!
takeResponsibilityButton

	takeResponsibilityButton ifNil: [
		self takeResponsibilityButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfMedal;
			actionSelector: #takeResponsibility;
			setBalloonText: 'Take responsibility')].
	^ takeResponsibilityButton! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mig 4/15/2009 18:14'!
takeResponsibilityButton: anObject

	takeResponsibilityButton := anObject! !

!XpfTaskWidgetActionsContent methodsFor: 'model actions' stamp: 'cs 4/23/2009 14:15'!
toggleStartStop

	self model isStarted
		ifTrue: [self stopWork]
		ifFalse: [self startWork].! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/15/2009 15:20'!
update: aSymbol

	aSymbol = #isDone	ifTrue: [
		self
			updateDoneButton;
			updateReopenButton;
			updateStartStopButton;
			updateEditTimeButton].
	aSymbol = #responsibleDeveloper ifTrue: [
		self
			updateTakeResponsibilityButton;
			updateDoneButton;
			updateStartStopButton;
			updateEditTimeButton].
	aSymbol = #isStarted ifTrue: [
		self
			updateStartStopButton;
			updateEditTimeButton].! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/15/2009 15:17'!
updateAll

	self
		updateTakeResponsibilityButton;
		updateDoneButton;
		updateReopenButton;
		updateStartStopButton;
		updateEditTimeButton;
		updateUserStoryArea.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/14/2009 09:53'!
updateDoneButton

	self doneButton
		visible:
			(self model notNil
				and: [self model isDone not
				and: [self alreadyResponsible]]);
		disableTableLayout:
			self doneButton visible not.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/15/2009 15:15'!
updateEditTimeButton

	self editTimeButton visible:
		(self model notNil
			and: [self model isDone not
			and: [self alreadyResponsible
			and: [self model isStarted not]]]).
	self editTimeButton disableTableLayout: self editTimeButton visible not.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/14/2009 09:54'!
updateReopenButton

	self reopenButton 
		visible:
			(self model notNil
				and: [self model isDone
				and: [self alreadyResponsible]]); 
		disableTableLayout:
			self reopenButton visible not.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/14/2009 09:52'!
updateStartStopButton

	self startStopButton visible:
		(self model notNil
			and: [self model isDone not
			and: [self alreadyResponsible]]).
	self startStopButton visible ifTrue: [
		self startStopButton labelGraphic:
			(self model isStarted
				ifTrue: [MenuIcons xpfClockStop]
				ifFalse: [MenuIcons xpfClockPlay])].
	self startStopButton disableTableLayout: self startStopButton visible not.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'topa 4/23/2009 16:36'!
updateTakeResponsibilityButton

	self takeResponsibilityButton
		visible: self alreadyResponsible not;
		disableTableLayout: self alreadyResponsible.! !

!XpfTaskWidgetActionsContent methodsFor: 'updating' stamp: 'mt 5/14/2009 11:51'!
updateUserStoryArea

	self model ifNil: [^ self].
	
	self userStoryArea
		color: (Color colorFrom: self model userStory color asSymbol) muchLighter.
		
	self userStoryArea assureExtension
		balloonText: ('User Story: "{1}"' format: {self model userStory title withNoLineLongerThan: 40}).! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 11:49'!
userStoryArea

	userStoryArea ifNil: [
		self userStoryArea: (BorderedMorph new
			hResizing: #rigid;
			vResizing: #rigid;
			extent: 21@8;
			borderWidth: 1;
			borderRaised;
			color: Color transparent)].
	^ userStoryArea! !

!XpfTaskWidgetActionsContent methodsFor: 'accessing' stamp: 'mt 5/14/2009 11:38'!
userStoryArea: anObject

	userStoryArea := anObject.! !

XpfEntityMorphContent subclass: #XpfTasksContent
	instanceVariableNames: 'taskList addButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTasksContent class methodsFor: 'defaults' stamp: 'bs 6/29/2009 16:14'!
defaultExtent

	^ 180@220! !

!XpfTasksContent methodsFor: 'initialization' stamp: 'mt 4/24/2009 16:09'!
addButton

	addButton ifNil: [
		self addButton: (IconicButton new
			color: Color transparent;
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons xpfAddTask;
			actionSelector: #addTask;
			setBalloonText: 'Click this button to add a new task.')].
	^ addButton! !

!XpfTasksContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:13'!
addButton: aPluggableButtonMorph

	addButton := aPluggableButtonMorph.! !

!XpfTasksContent methodsFor: 'actions' stamp: 'mt 5/15/2009 15:57'!
addTask

	(self model addNew: (Dictionary newFrom: {'title' -> 'Please enter description for new task'}))
		responsibleDeveloper: self model repository currentUser.! !

!XpfTasksContent methodsFor: 'initialization' stamp: 'bs 7/1/2009 21:24'!
initialize

	super initialize.
	self
		hResizing: #rigid;
		fillStyle: (Color r: 0.8 g: 0.8 b: 0.8 alpha: 0.35);
		layoutInset: 2.
		
	self taskList withScrollBars extent: self extent.
	self addMorphBack: self taskList withScrollBars.
	self addMorphBack:
			(self theme newRowIn: self for: {
				self addButton.
				self theme newToolSpacerIn: self}).
! !

!XpfTasksContent methodsFor: 'accessing' stamp: 'mt 4/28/2009 10:23'!
model: anXpfTasksCollection

	super model: anXpfTasksCollection.
	self taskList model: self model.! !

!XpfTasksContent methodsFor: 'accessing' stamp: 'mt 4/24/2009 16:12'!
taskList

	taskList ifNil: [
		taskList := XpfTaskListMorph new model: self model].
	^ taskList! !

!XpfTasksContent methodsFor: 'accessing' stamp: 'mfp 3/19/2009 16:27'!
taskList: anObject

	taskList := anObject.! !

XpfEntityMorphContent subclass: #XpfTitleContent
	instanceVariableNames: 'titleEdit titleView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

XpfTitleContent subclass: #XpfTaskTitleContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskTitleContent class methodsFor: 'defaults' stamp: 'mt 4/24/2009 14:58'!
defaultExtent

	^ 139@70! !

!XpfTaskTitleContent methodsFor: 'testing' stamp: 'topa 4/17/2009 16:03'!
isXpfTaskTitleContent

	^ true! !

!XpfTitleContent methodsFor: 'form comitting' stamp: 'cs 4/14/2009 18:44'!
accept

	self titleEdit accept.! !

!XpfTitleContent methodsFor: 'form comitting' stamp: 'SR 4/14/2009 21:02'!
cancel

	self titleEdit cancel.! !

!XpfTitleContent methodsFor: 'initialization' stamp: 'mt 4/25/2009 17:32'!
initialize

	super initialize.
	self addMorph: self title.! !

!XpfTitleContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/30/2009 14:39'!
isXpfTaskTitleContent

	^ false! !

!XpfTitleContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/30/2009 14:39'!
isXpfUserStoryTitleContent

	^ false! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'topa 5/25/2009 11:53'!
model: anXpfEntity 
	super model: anXpfEntity.

	"preset title."
	(self titleView) 
		model: anXpfEntity;
		extent: self class defaultExtent.
	self isXpfUserStoryTitleContent 
		ifTrue: [self resizeFontSizeForUserStoryIfNecessary: anXpfEntity].
	(self titleEdit)
		setText: self model title;
		extent: self class defaultExtent

	! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'topa 4/21/2009 17:03'!
modelTitle

	^ self model ifNotNil: [self model title asText]
		! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'topa 4/21/2009 17:13'!
modelTitle: aText

	self model title: (aText ifNotNil: [aText asString])! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'topa 4/23/2009 19:29'!
title

	^ self inEditMode
		ifTrue: [self titleEdit]
		ifFalse: [self titleView]! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'mt 4/24/2009 15:16'!
titleEdit

	titleEdit ifNil: [
		titleEdit := (XpfSaveEditingTextMorph
			on: self
			text: #modelTitle
			accept: #modelTitle:) 
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			borderWidth: 0;
			fillStyle: (Color r: 0.8 g: 0.8 b: 0.8 alpha: 0.35)].
	^ titleEdit! !

!XpfTitleContent methodsFor: 'accessing' stamp: 'bs 6/12/2009 17:54'!
titleView

	titleView ifNil: [
		titleView := (XpfPluggableTextMorph
			on: self model
			getTextSelector: #title)
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			margins: 3@0;
			lock].
	^ titleView! !

!XpfTitleContent methodsFor: 'form comitting' stamp: 'topa 4/22/2009 15:31'!
toggleEditMode

	super toggleEditMode.
	self
		removeAllMorphs;
		addMorph: (self title font: XpfClient sansFont).! !

!XpfTitleContent methodsFor: 'form comitting' stamp: 'mt 4/28/2009 10:40'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #title ifTrue: [
		self titleEdit update: #modelTitle].! !

XpfTitleContent subclass: #XpfUserStoryTitleContent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryTitleContent class methodsFor: 'defaults' stamp: 'bs 6/23/2009 13:29'!
defaultExtent

	^ 170@90! !

!XpfUserStoryTitleContent methodsFor: 'testing' stamp: 'topa 4/17/2009 16:03'!
isXpfUserStoryTitleContent

	^ true! !

!XpfUserStoryTitleContent methodsFor: 'accessing' stamp: 'mfp 5/6/2009 12:08'!
resizeFontSizeForUserStoryIfNecessary: anXpfEntity 

	| textLength |
	textLength := anXpfEntity title size.
	
	"In the following line, truncateWithElipsisTo: will be added in the future"
	textLength > 210 ifTrue:  [ self titleView beAllFont: (XpfClient sansFontAt: 8); font: (XpfClient sansFontAt: 8) ].	
	(textLength > 165 and: [ textLength <= 210 ]) ifTrue:  [ self titleView beAllFont: (XpfClient sansFontAt: 8); font: (XpfClient sansFontAt: 8) ].	
	(textLength > 150 and: [ textLength <= 165 ]) ifTrue: [ self titleView beAllFont: (XpfClient sansFontAt: 9); font: (XpfClient sansFontAt: 9)].
	(textLength > 130 and: [ textLength <= 150 ]) ifTrue: [ self titleView beAllFont: (XpfClient sansFontAt: 10); font: (XpfClient sansFontAt: 10) ]! !

!XpfUserStoryTitleContent methodsFor: 'as yet unclassified' stamp: 'mfp 4/30/2009 15:22'!
titleView

	| tempTitleView |
	tempTitleView := super titleView.
	
"	self resizeFontSizeForUserStoryIfNecessary: self model ofTitleView: tempTitleView. "
	
	^ tempTitleView 
! !

XpfEntityMorphContent subclass: #XpfZoomButtonContent
	instanceVariableNames: 'zoomButton inZoomMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfZoomButtonContent class methodsFor: 'as yet unclassified' stamp: 'mt 4/25/2009 17:05'!
defaultExtent
	
	^ 16@16! !

!XpfZoomButtonContent class methodsFor: 'as yet unclassified' stamp: 'mt 4/25/2009 17:17'!
downArrowFrom

	^ ScrollBar arrowOfDirection: #bottom size: 16 color: Color lightGray
! !

!XpfZoomButtonContent class methodsFor: 'as yet unclassified' stamp: 'mt 4/25/2009 17:17'!
rightArrowFrom

	^ ScrollBar arrowOfDirection: #right size: 16 color: Color lightGray
! !

!XpfZoomButtonContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 15:27'!
inZoomMode

	^ inZoomMode! !

!XpfZoomButtonContent methodsFor: 'accessing' stamp: 'SR 4/14/2009 15:27'!
inZoomMode: anObject

	inZoomMode := anObject! !

!XpfZoomButtonContent methodsFor: 'initialization' stamp: 'mt 4/26/2009 10:30'!
initialize

	super initialize.	
	self
		addMorph: self zoomButton;
		listCentering: #center;
		listDirection: #topToBottom;
		vResizing: #shrinkWrap;
		hResizing: #rigid;
		update.! !

!XpfZoomButtonContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 15:31'!
toggleZoom

	self changed: #toggleZoom.! !

!XpfZoomButtonContent methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 15:42'!
update: aSymbol
	
	aSymbol = #zoomOut ifTrue: [self zoomButton labelGraphic: self class rightArrowFrom].
	aSymbol = #zoomIn ifTrue: [self zoomButton labelGraphic: self class downArrowFrom].
	super update: aSymbol.! !

!XpfZoomButtonContent methodsFor: 'accessing' stamp: 'topa 3/23/2009 11:07'!
zoomButton

	zoomButton ifNil: [
		zoomButton :=  IconicButton new
	 		color: Color transparent;
		 	target: self;
		 	borderWidth: 0;
			labelGraphic: self class rightArrowFrom;
			actionSelector: #toggleZoom;
			setBalloonText: 'zoom' translated].
	^ zoomButton! !

!XpfZoomButtonContent methodsFor: 'accessing' stamp: 'topa 4/17/2009 16:03'!
zoomButton: anObject

	zoomButton := anObject.! !

PanelMorph subclass: #XpfHistoryEntryMorph
	instanceVariableNames: 'model entityTypeField timeField entityTitleField actionField detailField userField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfHistoryEntryMorph class methodsFor: 'as yet unclassified' stamp: 'cs 4/7/2009 14:22'!
forEntry: anXpfHistoryEntryModel

	^ self basicNew
		model: anXpfHistoryEntryModel;
		initialize! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:30'!
actionField

	actionField ifNil: [
		self actionField:
			(self model entry action asMorph
			font: XpfClient sansFont;
			emphasis: 1;
			hResizing: #rigid;
			width: 65;
			lock)].
	^ actionField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:57'!
actionField: anObject

	actionField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:30'!
detailField

	detailField ifNil: [
		self detailField:
			(self detailsText asMorph
			font: XpfClient sansFont;
			hResizing: #spaceFill;
			autoFitOnOff;
			wrapFlag: false;
			lock)].
	^ detailField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
detailField: anObject

	detailField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'cs 4/17/2009 17:09'!
detailsText

	self model entry action = #added ifTrue: [^ self detailsTextAdded].
	self model entry action = #changed ifTrue: [^ self detailsTextChanged].
	^ '' asText! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'mt 4/28/2009 16:58'!
detailsTextAdded

	^ self model new asText
		"addAttribute: TextEmphasis underlined;"
		append: ' to ';
		append: self model entry property capitalized asText allBold;
		yourself! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'mt 4/28/2009 16:56'!
detailsTextChanged

	| text oldValue newValue  |
	oldValue := '''{1}''' format: {self model old}.
	newValue := '''{1}''' format: {self model new}.
	
	text := (self model entry property) asText allBold.
	
	oldValue ifNotNil: [text
		append: ' from ';
		append: (oldValue asText addAttribute: TextEmphasis italic; yourself)].
	
	text
		append: ' to ';
		append: (newValue asText addAttribute: TextEmphasis italic; yourself);
		yourself.
	^ text! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/29/2009 11:37'!
entityTitleField

	entityTitleField ifNil: [self entityTitleField: 
		((XpfPluggableTextMorph
			on: self model entity
			getTextSelector: #title)
			"emphasis: 4(self model entity isDeleted ifTrue: [20] ifFalse: [4]);"
			hResizing: #rigid;
			isTruncatedWithEllipsis: true;
			width: 120;
			lock)].
	^ entityTitleField ! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
entityTitleField: anObject

	entityTitleField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:43'!
entityTypeField

	entityTypeField ifNil: [
		self entityTypeField:
			(self model entityType asString capitalized asMorph
			font: XpfClient sansFont;
			color: Color darkGray;
			hResizing: #rigid;
			width: 70;
			lock)].
	^ entityTypeField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
entityTypeField: anObject

	entityTypeField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'initialization' stamp: 'cs 4/8/2009 11:54'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color white;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 8;
		initializeFields.! !

!XpfHistoryEntryMorph methodsFor: 'initialization' stamp: 'cs 4/17/2009 16:41'!
initializeFields

	self addMorphBack: self timeField.
	self model entityType = #individual ifFalse: [
	self addMorphBack: self entityTypeField;
		  addMorphBack: self entityTitleField].
	self addMorphBack: self actionField;
		  addMorphBack: self detailField.
	self model entry user ifNotNil: [
	self addMorphBack: self userField].! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:57'!
model

	^ model! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:57'!
model: anObject

	model := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'mt 4/29/2009 11:46'!
timeField

	timeField ifNil: [
		self timeField:
			(self model entry timestamp printRelativeTimeStamp asMorph
			font: XpfClient sansFont;
			emphasis: 2;
			hResizing: #rigid;
			width: 180;
			lock)].
	^ timeField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:58'!
timeField: anObject

	timeField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:40'!
userField

	userField ifNil: [
		self userField:
			(self userText asMorph
				font: XpfClient sansFont;
				color: Color darkGray;
				hResizing: #rigid;
				width: 120;
				lock)].
	^ userField! !

!XpfHistoryEntryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:48'!
userField: anObject

	userField := anObject.! !

!XpfHistoryEntryMorph methodsFor: 'details' stamp: 'mt 4/22/2009 16:06'!
userText

	^ ('by {1} --' format: {self model entry user asString}) asText
		addAttribute: TextEmphasis underlined;
		yourself! !

PanelMorph subclass: #XpfHistoryMorph
	instanceVariableNames: 'model table checkboxBar projectCheckbox userStoriesCheckbox tasksCheckbox individualCheckbox individualLabel client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfHistoryMorph class methodsFor: 'as yet unclassified' stamp: 'cs 4/7/2009 11:03'!
forProject: anXpfProject

	^ self basicNew
		model: (XpfHistoryModel new project: anXpfProject);
		initialize! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:26'!
checkboxBar

	checkboxBar ifNil: [self checkboxBar:
		(UITheme current newRowIn: self for: {
			'Show history for: ' asMorph font: XpfClient sansFont.
			self projectCheckbox.
			self userStoriesCheckbox.
			self tasksCheckbox.
			self individualCheckbox.
			self individualLabel})].
	
	^ checkboxBar! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:36'!
checkboxBar: anObject

	checkboxBar := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:19'!
client

	^ client! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:19'!
client: anObject

	client := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:29'!
individualCheckbox

	individualCheckbox ifNil: [self individualCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showIndividual
		setSelected: #showIndividual:
		getEnabled: #enableIndividual
		label: ''
		help: 'Check this box to see history details of a specific entity')].
	^ individualCheckbox! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 14:06'!
individualCheckbox: anIndividualCheckbox

	individualCheckbox := anIndividualCheckbox.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 16:06'!
individualLabel

	individualLabel ifNil: [self individualLabel:
		((XpfPluggableTextMorph
			on: self model
			getTextSelector: #individualTitle)
			hResizing: #spaceFill;
			isTruncatedWithEllipsis: true;
			lock)].
	^ individualLabel! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 19:16'!
individualLabel: anObject

	individualLabel := anObject.! !

!XpfHistoryMorph methodsFor: 'initialization' stamp: 'cs 4/7/2009 11:39'!
initialize

	super initialize.
	self
		visible: false;
		disableTableLayout: true;
		height: 100;
		vResizing: #rigid;
		hResizing: #spaceFill;
		changeTableLayout;
		addMorph: self table;
		addMorph: self checkboxBar.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:11'!
model

	^ model! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:14'!
model: anObject

	self model ifNotNil: [self model removeDependent: self].
	model := anObject.
	self model ifNotNil: [self model addDependent: self].! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:27'!
projectCheckbox

	projectCheckbox ifNil: [self projectCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showProject
		setSelected: #showProject:
		getEnabled: #enableGlobal
		label: 'Project'  
		help: 'Check this box to see history details on project level')].
	projectCheckbox labelMorph font: XpfClient sansFont.
	^ projectCheckbox
	  ! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 10:55'!
projectCheckbox: anObject

	projectCheckbox := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:51'!
table

	table ifNil: [self table:
		((UITheme current 
			newMorphListIn: self
			for: self model
			list: #entriesAsMorphs
			getSelected: nil
			setSelected: nil
			getEnabled: nil
			help: 'Shows the project history')
			height: 80;
			vResizing: #rigid;
			hResizing: #spaceFill)].
	^ table! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/7/2009 10:55'!
table: anObject

	table := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:28'!
tasksCheckbox

	tasksCheckbox ifNil: [self tasksCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showTasks
		setSelected: #showTasks:
		getEnabled: #enableGlobal
		label: 'Tasks'
		help: 'Check this box to see history details on task level')].
	tasksCheckbox labelMorph font: XpfClient sansFont.
	^ tasksCheckbox! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:29'!
tasksCheckbox: anObject

	tasksCheckbox := anObject.! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:22'!
update: aSymbol

	super update: aSymbol.
	(aSymbol = #showIndividual
		and: [self client notNil]
		and: [self visible not])
		ifTrue: [self client toggleHistory].! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'topa 4/20/2009 15:28'!
userStoriesCheckbox

	userStoriesCheckbox ifNil: [self userStoriesCheckbox: 
		(UITheme current newCheckboxIn: self
		for: self model
		getSelected: #showUserStories
		setSelected: #showUserStories:
		getEnabled: #enableGlobal
		label: 'User Stories'  
		help: 'Check this box to see history details on User Story level')].
	userStoriesCheckbox labelMorph font: XpfClient sansFont.
	^ userStoriesCheckbox! !

!XpfHistoryMorph methodsFor: 'accessing' stamp: 'cs 4/8/2009 11:29'!
userStoriesCheckbox: anObject

	userStoriesCheckbox := anObject.! !

PanelMorph subclass: #XpfIterationSidebarMorph
	instanceVariableNames: 'model selectedTitles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/7/2009 20:44'!
click: anXpfIteration with: anEvent from: anExpanderTitleMorph

	anEvent redButtonChanged ifTrue: [
		self selectIteration: anXpfIteration with: anEvent from: anExpanderTitleMorph.
		anEvent wasHandled: true].
	anEvent yellowButtonChanged ifTrue: [
		self openContextPopupMenu: anXpfIteration with: anExpanderTitleMorph..
		anEvent wasHandled: true].! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/12/2009 21:27'!
editIdealTime: anXpfIteration with: anExpanderTitleMorph

	| answer |
	answer := ((UITheme current) textEntryIn: self text: 'Enter ideal time:' title: 'XPF-Client' entryText: anXpfIteration timeIdeal).
	answer ifNotNil: [anXpfIteration timeIdeal: answer].! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/7/2009 20:43'!
editName: anXpfIteration with: anExpanderTitleMorph

	| answer |
	answer := ((UITheme current) textEntryIn: self text: 'Enter iteration name:' title: 'XPF-Client' entryText: anXpfIteration title).
	answer ifNotNil: [
		anXpfIteration title: answer.
		anExpanderTitleMorph titleText: anXpfIteration title].! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mfp 5/6/2009 16:10'!
fill

	self model iterations do: [:iteration | |expander|
			expander := (UITheme current
				newExpanderIn: self
				label: (iteration title ifNil: [''])
				forAll: {XpfIterationTreeMorph for: iteration}).
			expander titleMorph on: #mouseUp send: #click:with:from: to: self withValue: iteration.
			self addMorph: expander.
			expander titleMorph addDependent: self.
			expander titleMorph labelMorph beAllFont: XpfClient sansFont.
			iteration isXpfFutureIteration ifTrue: [expander titleMorph labelMorph: MenuIcons xpfOpenStories asMorph].

			iteration isXpfFutureIteration
				ifTrue: [self selectIteration: iteration with: nil from: expander titleMorph]].
	
	self submorphs size > 1 ifTrue: [ | expander tree |
		expander := self submorphs second expanded: true.
		tree := expander submorphs detect: [:m | m ~= expander titleMorph].
		self selectIteration: tree model iteration with: nil from: expander titleMorph].! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:19'!
initialize

	super initialize.
	
	self
		selectedTitles: Set new;
		layoutPolicy: TableLayout new;
		hResizing: #rigid;
		vResizing: #spaceFill;
		extent: 200@700.! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mfp 3/26/2009 12:47'!
model

	^ model! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 11:30'!
model: anXpfProject

	self model ifNotNil: [
		self model removeDependent: self.
		self model iterations removeDependent: self].
	model := anXpfProject.
	self model ifNotNil: [
		self model addDependent: self.
		self model iterations addDependent: self.
		self fill.].! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'SR 4/20/2009 10:35'!
openContextPopupMenu: anXpfIteration with: anExpanderTitleMorph
	
	| menu |
	menu := MenuMorph new.
	menu addTitle: 'Iteration'.
	menu add: 'Edit name' target: self selector: #editName:with: argumentList: (Array with:anXpfIteration with: anExpanderTitleMorph).
	menu add: 'Edit ideal time' target: self selector: #editIdealTime:with: argumentList: (Array with:anXpfIteration with: anExpanderTitleMorph).
	menu add: 'Remove' target: self selector: #removeIteration:with: argumentList: (Array with:anXpfIteration with: anExpanderTitleMorph).
	menu popUpInWorld.! !

!XpfIterationSidebarMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 11:52'!
removeAllIterations

	self
		changed: #iterationDeselectAll;
		removeAllMorphs;
		selectedTitles: Set new.! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'mt 4/25/2009 14:59'!
removeIteration: anXpfIteration

	anXpfIteration isXpfFutureIteration ifFalse: [
		((UITheme current) proceedIn: self text: 'Are you sure?' title: 'Proceed') ifTrue: [
			self model removeIteration: anXpfIteration.
		].
	]! !

!XpfIterationSidebarMorph methodsFor: 'event handling' stamp: 'mt 4/25/2009 15:01'!
removeIteration: anXpfIteration with: anExpanderTitleMorph

	anXpfIteration isXpfFutureIteration ifFalse: [
		((UITheme current) proceedIn: self text: 'Are you sure?' title: 'Proceed') ifTrue: [
			(self selectedTitles includes: anExpanderTitleMorph) ifTrue: [
					self selectedTitles remove: anExpanderTitleMorph.
					self changed: #iterationDeselected with: anXpfIteration].
			self model removeIteration: anXpfIteration.
		].
	]! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 20:32'!
selectIteration: anXpfIteration with: evt from: anExpanderTitleMorph 

	(self selectedTitles includes: anExpanderTitleMorph)
		ifTrue: [
			self selectedTitles remove: anExpanderTitleMorph.
			self changed: #iterationDeselected with: anXpfIteration]
		ifFalse: [
			self selectedTitles add: anExpanderTitleMorph.
			self changed: #iterationSelected with: anXpfIteration].
	self updateHighlight.! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:18'!
selectedTitles

	^ selectedTitles! !

!XpfIterationSidebarMorph methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:17'!
selectedTitles: anObject

	selectedTitles := anObject! !

!XpfIterationSidebarMorph methodsFor: 'updating' stamp: 'mt 4/28/2009 11:47'!
update: aSymbol

	super update: aSymbol.
	self updateHighlight.

	aSymbol = #iterations | aSymbol = #iterationsLoaded ifTrue: [
		self model iterations reloadDepth: 2.
		self			
			removeAllIterations;
			fill].! !

!XpfIterationSidebarMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 19:24'!
updateHighlight
	
	self submorphsDo: [:morph | 
		(morph isKindOf: ExpanderMorph) ifTrue: [
			morph titleMorph fillStyle:
				(UITheme current expanderTitleNormalFillStyleFor: morph titleMorph)]].

	self selectedTitles do: [:morph | morph fillStyle: (morph fillStyle mixed: 3/4 with: Color green)].! !

PanelMorph subclass: #XpfTaskbarExtension
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Taskbar'!

XpfTaskbarExtension class
	instanceVariableNames: 'instance'!

XpfTaskbarExtension class
	instanceVariableNames: 'instance'!

!XpfTaskbarExtension class methodsFor: 'setup' stamp: 'bs 6/5/2009 16:52'!
install
	"XpfTaskbarExtension install"
	self uninstall.
	instance := self new install.! !

!XpfTaskbarExtension class methodsFor: 'accessing' stamp: 'cs 5/26/2009 15:38'!
instance

	^ instance! !

!XpfTaskbarExtension class methodsFor: 'accessing' stamp: 'cs 5/26/2009 15:38'!
instance: anObject

	instance := anObject.! !

!XpfTaskbarExtension class methodsFor: 'setup' stamp: 'cs 5/26/2009 15:52'!
uninstall

	instance ifNotNil: [instance uninstall].! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'cs 5/26/2009 18:15'!
buttonForChangePassword

	^ self
		newButtonLabel: 'Change Password'
		icon: MenuIcons xpfPassword asMorph
		action: #openChangePassword! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'cs 5/26/2009 15:47'!
buttonForClient

	^ self
		newButtonLabel: 'Client'
		icon: MenuIcons flagBlueIcon asMorph
		action: #openClient! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'cs 5/26/2009 15:47'!
buttonForDeveloperListWidget

	^ self
		newButtonLabel: 'Developer List'
		icon: MenuIcons xpfScreenIndicatedShared asMorph
		action: #openDeveloperListWidget! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'cs 5/28/2009 12:08'!
buttonForLogout

	^ self
		newButtonLabel: 'Logout'
		icon: MenuIcons xpfLogout asMorph
		action: #logout! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'cs 5/26/2009 15:47'!
buttonForTaskWidget

	^ self
		newButtonLabel: 'Task Widget'
		icon: MenuIcons noteIcon asMorph
		action: #openTaskWidget! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'cs 5/26/2009 15:47'!
buttonForUserStoryWidget

	^ self
		newButtonLabel: 'US Widget'
		icon: MenuIcons pageWhiteTextIcon asMorph
		action: #openUserStoryWidget! !

!XpfTaskbarExtension methodsFor: 'accessing' stamp: 'cs 5/26/2009 15:37'!
buttonState

	^ true! !

!XpfTaskbarExtension methodsFor: 'accessing' stamp: 'cs 5/28/2009 12:11'!
connection

	^ connection! !

!XpfTaskbarExtension methodsFor: 'accessing' stamp: 'cs 5/28/2009 12:11'!
connection: anObject

	connection := anObject.! !

!XpfTaskbarExtension methodsFor: 'initialization' stamp: 'SR 7/22/2009 11:22'!
initialize

	super initialize.
	self
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 8;
		connection: XpfLoginProcessor new;
		initializeButtons.! !

!XpfTaskbarExtension methodsFor: 'initialization' stamp: 'cs 5/28/2009 12:28'!
initializeButtons

	self
		removeAllMorphs;
		addMorphBack: self buttonForClient;
		addMorphBack: self buttonForTaskWidget;
		addMorphBack: self buttonForUserStoryWidget;
		addMorphBack: self buttonForDeveloperListWidget;
		addMorphBack: self separator;
		addMorphBack: self buttonForChangePassword;
		addMorphBack: self buttonForLogout;
		addMorphBack: self spacer.! !

!XpfTaskbarExtension methodsFor: 'taskbar' stamp: 'cs 5/26/2009 16:09'!
install

	self taskbar addMorphFront: self.
	self changed: #buttonState.! !

!XpfTaskbarExtension methodsFor: 'connection' stamp: 'SR 7/22/2009 11:22'!
logout

	ActiveHand ifNotNil: [ActiveHand resetLoginAndPassword].! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'cs 5/26/2009 16:09'!
newButtonLabel: aString icon: aMorph action: aSymbol

	| lm lab button |
	lab := (UITheme current buttonLabelForText: aString).
	lm := UITheme current
		newRowIn: self
		for: {aMorph. lab}.
	lm cellInset: 2.
	button := UITheme current
		newButtonIn: self
		for: self
		getState: #buttonState
		action: aSymbol
		arguments: #()
		getEnabled: nil
		label: aMorph
		help: aString.
	button
		useRoundedCorners;
		onColor: Color gray
		offColor: Color gray;
		hResizing: #spaceFill.
	lab color: Color white.
	^ button! !

!XpfTaskbarExtension methodsFor: 'actions' stamp: 'cs 5/28/2009 12:12'!
openChangePassword

	| dialog |
	dialog := XpfChangePasswordDialog new.
	dialog model user: self connection user.
	World openModal: dialog.! !

!XpfTaskbarExtension methodsFor: 'actions' stamp: 'cs 5/28/2009 12:12'!
openClient

	XpfClient openProject: self connection project.! !

!XpfTaskbarExtension methodsFor: 'actions' stamp: 'cs 5/28/2009 12:12'!
openDeveloperListWidget

	XpfDeveloperListWidget openProject: self connection project.! !

!XpfTaskbarExtension methodsFor: 'actions' stamp: 'cs 5/28/2009 12:12'!
openTaskWidget

	XpfTaskListWidget openProject: self connection project.! !

!XpfTaskbarExtension methodsFor: 'actions' stamp: 'cs 5/28/2009 12:12'!
openUserStoryWidget

	XpfUserStoryListWidget openProject: self connection project.! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'cs 5/28/2009 12:32'!
separator

	^ (UITheme current newVerticalSeparatorIn: self)
		borderColor: Color lightGray;
		hResizing: #rigid;
		width: 2;
		yourself! !

!XpfTaskbarExtension methodsFor: 'user-interface' stamp: 'cs 5/26/2009 15:28'!
spacer

	^ (UITheme current newToolSpacerIn: self)
		hResizing: #rigid;
		width: 10;
		yourself! !

!XpfTaskbarExtension methodsFor: 'taskbar' stamp: 'cs 5/26/2009 15:43'!
taskbar

	^ World
		submorphThat: [:m | m isTaskbar]
		ifNone: [Error signal: 'Could not find a taskbar.']! !

!XpfTaskbarExtension methodsFor: 'taskbar' stamp: 'cs 5/26/2009 15:47'!
uninstall

	self delete.! !

!Object methodsFor: '*xpf-client' stamp: 'topa 4/20/2009 17:19'!
isValueBarWrapper

	^ false! !

Object subclass: #SSHTunnel
	instanceVariableNames: 'process server user localPort remotePort isLocalTunnel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Rfb'!

SSHTunnel class
	instanceVariableNames: 'tunnelList'!

SSHTunnel class
	instanceVariableNames: 'tunnelList'!

!SSHTunnel class methodsFor: 'initialization' stamp: 'SR 5/6/2009 10:58'!
initialize

	super initialize.
	self tunnelList: OrderedCollection new.
	
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.
! !

!SSHTunnel class methodsFor: 'initialization' stamp: 'SR 5/6/2009 11:00'!
shutDown: aboutToQuit 

	self tunnelList do: [:each |
		each process isRunning ifTrue: [each process terminate]].
	super shutDown: aboutToQuit.! !

!SSHTunnel class methodsFor: 'initialization' stamp: 'SR 5/6/2009 10:58'!
startUp: aboutToQuit 

	self tunnelList: OrderedCollection new.
	super startUp: aboutToQuit.! !

!SSHTunnel class methodsFor: 'accessing' stamp: 'SR 5/6/2009 10:54'!
tunnelList

	^ tunnelList! !

!SSHTunnel class methodsFor: 'accessing' stamp: 'SR 5/6/2009 10:54'!
tunnelList: anObject

	tunnelList := anObject! !

!SSHTunnel methodsFor: 'as yet unclassified' stamp: 'mig 4/28/2009 10:35'!
execute

	| command |
	command := self generateExecutableString , self generateOptionsString.
	self process: (OSProcess command: command).
	self waitUntilProcessIsRunning.! !

!SSHTunnel methodsFor: 'private' stamp: 'mig 4/27/2009 13:35'!
generateExecutableString

	^ OSProcess isWindows 
		ifTrue: [ 'plink_silent.exe -batch ' ]
		ifFalse: [ 'ssh -o StrictHostKeyChecking=no ' ]! !

!SSHTunnel methodsFor: 'private' stamp: 'mig 4/28/2009 10:32'!
generateOptionsString

	^ '{1}@{2} -i "{3}/{1}_{2}.{4}" {5} -N'
		format: {self user.
			self server.
			FileDirectory dirPathFor: (SmalltalkImage current imageName).
			self keyFileEnding.
			self generateTunnelOptionsString.
			}.! !

!SSHTunnel methodsFor: 'private' stamp: 'SR 4/27/2009 14:25'!
generateTunnelOptionsString

	^ (self isLocalTunnel
			ifTrue: ['-L {1}:localhost:{2}']
			ifFalse: ['-R {2}:localhost:{1}']) format: {self localPort. self remotePort}.! !

!SSHTunnel methodsFor: 'initialize-release' stamp: 'SR 5/6/2009 10:59'!
initialize

	super initialize.
	self
		server: 'bp2008h1srv';
		user: 'vnc';
		isLocalTunnel: false.
	self class tunnelList add: self.! !

!SSHTunnel methodsFor: 'accessing' stamp: 'mig 4/27/2009 13:29'!
isLocalTunnel

	^ isLocalTunnel! !

!SSHTunnel methodsFor: 'accessing' stamp: 'mig 4/27/2009 13:29'!
isLocalTunnel: anObject

	isLocalTunnel := anObject! !

!SSHTunnel methodsFor: 'private' stamp: 'SR 4/27/2009 13:18'!
keyFileEnding

	^ OSProcess isWindows
		ifTrue: ['ppk']
		ifFalse: ['rsa']! !

!SSHTunnel methodsFor: 'accessing' stamp: 'mig 4/27/2009 13:29'!
localPort

	^ localPort! !

!SSHTunnel methodsFor: 'accessing' stamp: 'mig 4/27/2009 13:29'!
localPort: anObject

	localPort := anObject! !

!SSHTunnel methodsFor: 'accessing' stamp: 'SR 4/27/2009 13:08'!
process

	^ process! !

!SSHTunnel methodsFor: 'accessing' stamp: 'SR 4/27/2009 13:08'!
process: anObject

	process := anObject! !

!SSHTunnel methodsFor: 'accessing' stamp: 'mig 4/27/2009 13:29'!
remotePort

	^ remotePort! !

!SSHTunnel methodsFor: 'accessing' stamp: 'mig 4/27/2009 13:29'!
remotePort: anObject

	remotePort := anObject! !

!SSHTunnel methodsFor: 'accessing' stamp: 'SR 4/27/2009 13:13'!
server

	^ server! !

!SSHTunnel methodsFor: 'accessing' stamp: 'SR 4/27/2009 13:13'!
server: anObject

	server := anObject! !

!SSHTunnel methodsFor: 'as yet unclassified' stamp: 'SR 4/27/2009 13:08'!
terminate

	self process terminate.! !

!SSHTunnel methodsFor: 'accessing' stamp: 'SR 4/27/2009 13:13'!
user

	^ user! !

!SSHTunnel methodsFor: 'accessing' stamp: 'SR 4/27/2009 13:13'!
user: anObject

	user := anObject! !

!SSHTunnel methodsFor: 'as yet unclassified' stamp: 'mig 4/28/2009 10:17'!
waitUntilProcessIsRunning

	self process ifNil: [self error: 'could not establish SSH tunnel'].
	
	[self process isNotYetRunning] whileTrue: [
			(Delay forMilliseconds: 50) wait].
	
	(Delay forMilliseconds: 100) wait.
	
	self process isComplete ifTrue: [
		self error: 'could not establish SSH tunnel'].! !

Object subclass: #XpfAdminToolModel
	instanceVariableNames: 'projects currentProjectIndex users currentUserIndex currentProjectCandidateIndex currentProjectDeveloperIndex reposistory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfAdminToolModel class methodsFor: 'as yet unclassified' stamp: 'mt 3/16/2009 11:29'!
newWithRepository: aRepository

	^ self new repository: aRepository! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'mt 4/16/2009 17:20'!
addDeveloperToProject

	self currentProject developers add: 
		(self currentProjectCandidates at: self currentProjectCandidateIndex).
			
	self currentProjectCandidateIndex: 0.
			
	self
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidateIndex;
		changed: #allProjectCandidateNames;
		changed: #hasCurrentProjectCandidates.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/16/2009 14:17'!
addProject
	| newProject |
	newProject := reposistory 
				addProject: (Dictionary newFrom: {  ('title' -> 'New Project')}).
	projects := nil.
	self
		changed: #allProjectTitles;
		changed: #hasProjects;
		currentProjectIndex: (self indexOfProject: newProject);
		changed: #hasCurrentProject! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/16/2009 14:17'!
addUser
	| newUser |
	newUser := reposistory 
				addUser: (Dictionary newFrom: { 
								('userName' -> 'New User').
								('login' -> 'new.user@email.de').
								('password' -> nil)}).
	users := nil.
	self
		changed: #allUserNames;
		changed: #hasUsers;
		currentUserIndex: (self indexOfUser: newUser);
		changed: #hasCurrentUser;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 10:50'!
allProjectCandidateNames

	^ self currentProjectCandidates collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:48'!
allProjectDeveloperNames

	^ self currentProjectDevelopers collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/3/2009 17:04'!
allProjectTitles

	^ self projects collect: [:project | project title]! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 10:20'!
allUserNames

	^ self users collect: [:user | user userName]! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'mt 3/6/2009 13:40'!
changePassword: aDialog

	| newPassword |
	newPassword := UITheme current 
		textEntryIn: aDialog
		text: ('Enter new password for ''{1}''' format: {self currentUserName})
		title: 'Change Password'
		entryText: ''.
				
	newPassword ifNil: [^ self].
	
	self currentUserPassword: newPassword! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:36'!
currentProject

	^ self projects at: self currentProjectIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:48'!
currentProjectCandidateIndex

	^ currentProjectCandidateIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/6/2009 16:38'!
currentProjectCandidateIndex: anObject

	currentProjectCandidateIndex := anObject.
	self
		changed: #currentProjectCandidateIndex;
		changed: #hasCurrentProjectCandidateIndex.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:49'!
currentProjectCandidates

	self hasCurrentProject ifFalse: [^ #()].
	
	^ self users reject: [:user | 
		self currentProject developers anySatisfy: [:dev | dev id = user id]]! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:48'!
currentProjectDeveloperIndex

	^ currentProjectDeveloperIndex! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:45'!
currentProjectDeveloperIndex: anObject

	currentProjectDeveloperIndex := anObject.
	self changed: #currentProjectDeveloperIndex.
	self changed: #hasCurrentProjectDeveloperIndex.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:49'!
currentProjectDevelopers

	self hasCurrentProject ifFalse: [^ #()].
	^ self currentProject developers ! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'topa 3/4/2009 00:23'!
currentProjectIndex

	^ currentProjectIndex! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 16:34'!
currentProjectIndex: anObject

	currentProjectIndex := anObject.
	self
		changed: #hasCurrentProject;
		changed: #currentProjectIndex;
		changed: #currentProjectTitle;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 16:22'!
currentProjectTitle

	^ self hasCurrentProject
		ifTrue: [self allProjectTitles at: self currentProjectIndex]
		ifFalse: []! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 15:50'!
currentProjectTitle: aString

	self currentProject title: aString.
	self
		changed: #currentProjectTitle;
		changed: #allProjectTitles.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 15:37'!
currentUser

	^ self users at: self currentUserIndex! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 12:59'!
currentUserIndex
	^ currentUserIndex! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/6/2009 16:34'!
currentUserIndex: anObject

	currentUserIndex := anObject.
	self
		changed: #hasCurrentUser;
		changed: #currentUserIndex;
		changed: #currentUserName;
		changed: #currentUserLogin.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 16:04'!
currentUserLogin

	^ self hasCurrentUser
		ifTrue: [self currentUser login]
		ifFalse: []! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 6/3/2009 15:56'!
currentUserLogin: aString

	| oldLogin |
	oldLogin := (self users at: self currentUserIndex) login.
	(self users at: self currentUserIndex) login: aString.
	(self repository isRestProxy and: [self repository login = oldLogin])
		ifTrue: [self repository login: aString].
	self changed: #currentUserLogin.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/4/2009 13:36'!
currentUserName

	^ self allUserNames at: self currentUserIndex ifAbsent: []! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/12/2009 12:34'!
currentUserName: aString

	self currentUser userName: aString.
	
	self flag: #temporary. projects := nil.
	
	self
		changed: #currentUserName;
		changed: #allUserNames;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/31/2009 15:58'!
currentUserPassword: aString

	(self users at: self currentUserIndex) password: aString.
	self repository login = self currentUserLogin
		ifTrue: [self repository password: aString].
	self changed: #currentUserPassword.! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'cs 3/9/2009 15:42'!
deleteDeveloper

	self currentProject developers remove: 
		(self currentProjectDevelopers at: self currentProjectDeveloperIndex).
			
	self currentProjectDeveloperIndex: (self currentProjectDeveloperIndex > self currentProject developers size 
			ifTrue: [self currentProject developers size] 
			ifFalse: [self currentProjectDeveloperIndex]).
			
	self
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidateIndex;
		changed: #allProjectCandidateNames;
		changed: #hasCurrentProjectCandidates.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 16:00'!
deleteProject

	self currentProject delete.
	projects := nil. "invalidate local projects"
	self
		changed: #allProjectTitles;
		changed: #hasProjects;
		currentProjectIndex: (self currentProjectIndex > self projects size 
			ifTrue: [self projects size] 
			ifFalse: [self currentProjectIndex]);
		changed: #hasCurrentProject.! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 16:01'!
deleteUser

	self currentUser delete.
	users := nil. "invalidate local users"
	self
		changed: #allUserNames;
		changed: #hasUsers;
		currentUserIndex: (self currentUserIndex > self users size 
			ifTrue: [self users size] 
			ifFalse: [self currentUserIndex]);
		changed: #hasCurrentUser;
		changed: #allProjectCandidateNames;
		changed: #allProjectDeveloperNames;
		changed: #hasCurrentProjectCandidates;
		changed: #hasCurrentProjectDevelopers.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/5/2009 13:35'!
hasCurrentProject

	^ self currentProjectIndex notNil and: 
		[(self currentProjectIndex > 0) & (self currentProjectIndex <= self projects size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/12/2009 10:50'!
hasCurrentProjectCandidateIndex

	^ self currentProjectCandidateIndex notNil and: 
		[(self currentProjectCandidateIndex > 0) & (self currentProjectCandidateIndex <= self currentProjectCandidates size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:38'!
hasCurrentProjectCandidates

	^ self currentProjectCandidates isEmpty not! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 16:01'!
hasCurrentProjectDeveloperIndex

	^ self hasCurrentProject and:
		[self currentProjectDeveloperIndex notNil and: 
		[(self currentProjectDeveloperIndex > 0) &
		(self currentProjectDeveloperIndex <= self currentProject developers size)]]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/6/2009 15:38'!
hasCurrentProjectDevelopers

	^ self currentProjectDevelopers isEmpty not! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/5/2009 13:49'!
hasCurrentUser

	^ self currentUserIndex notNil and: 
		[(self currentUserIndex > 0) & (self currentUserIndex <= self users size)]! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'mt 3/5/2009 14:05'!
hasProjects

	^ self projects isEmpty not! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'mt 3/5/2009 14:05'!
hasUsers

	^ self users isEmpty not! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 3/9/2009 10:30'!
indexOfProject: aProject
	"returns the index of the specified project in the displayed list of projects"

	^ self projects indexOf: (self projects detect: [:each | each id = aProject id])! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 3/9/2009 10:28'!
indexOfUser: aUser
	"returns the index of the specified user in the displayed list of users"

	^ self users indexOf: (self users detect: [:each | each id = aUser id])! !

!XpfAdminToolModel methodsFor: 'initialization' stamp: 'mt 3/6/2009 16:20'!
initialize

	super initialize.
	self
		currentProjectIndex: 0;
		currentUserIndex: 0;
		currentProjectCandidateIndex: 0;
		currentProjectDeveloperIndex: 0.! !

!XpfAdminToolModel methodsFor: 'projects' stamp: 'cs 6/3/2009 15:50'!
projects

	^ projects ifNil: 
		[projects := reposistory projects asOrderedCollection
			sortBy: [:first :second | first title < second title]]! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/16/2009 14:17'!
repository

	^ reposistory! !

!XpfAdminToolModel methodsFor: 'accessing' stamp: 'mt 3/16/2009 14:17'!
repository: anObject

	reposistory := anObject.! !

!XpfAdminToolModel methodsFor: 'updating' stamp: 'cs 6/3/2009 16:00'!
updateUser: someEntries 

	self currentUser deferCommit: [
		someEntries	do: [:entry | entry accept]].! !

!XpfAdminToolModel methodsFor: 'users' stamp: 'cs 6/3/2009 15:52'!
users

	^ users ifNil: 
		[users := reposistory users asOrderedCollection
			sortBy: [:first :second | first userName < second userName]]! !

Object subclass: #XpfChangePasswordModel
	instanceVariableNames: 'newPassword newPasswordRepeat user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'cs 5/28/2009 12:24'!
accept

	(self newPassword = self newPasswordRepeat) ifTrue: [
		self user password: self newPassword.
		XpfLoginModel defaultPassword: self newPassword.
		(self user respondsTo: #repository) ifFalse: [^ self].
		(self user login = self user repository login)
			ifTrue: [self user repository password: self newPassword]].! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:50'!
newPassword

	^ newPassword! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:50'!
newPassword: anObject

	newPassword := anObject.! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:45'!
newPasswordRepeat

	^ newPasswordRepeat! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:45'!
newPasswordRepeat: anObject

	newPasswordRepeat := anObject.! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:46'!
user

	^ user! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:46'!
user: anObject

	user := anObject.! !

Object subclass: #XpfDeveloperChooserModel
	instanceVariableNames: 'developerList selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfDeveloperChooserModel methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 17:58'!
developer

	^ self selectionIndex = 0
		ifTrue: [nil]
		ifFalse: [self developerList at: self selectionIndex]! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'cs 4/23/2009 15:06'!
developerList

	^ developerList! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:11'!
developerList: anObject

	developerList := anObject.
	self changed: #list.
	self developerList ifNotEmpty: [self selectionIndex: 1].! !

!XpfDeveloperChooserModel methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 18:10'!
initialize

	super initialize.
	self selectionIndex: 0.! !

!XpfDeveloperChooserModel methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 17:57'!
list

	self developerList ifNil: [^ #()].
	^(self developerList collect: [:each | each userName]).! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:56'!
selectionIndex

	^ selectionIndex! !

!XpfDeveloperChooserModel methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:56'!
selectionIndex: anObject

	selectionIndex := anObject.
	self changed: #selectionIndex.! !

Object subclass: #XpfDeveloperListModel
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfDeveloperListModel methodsFor: 'accessing' stamp: 'mt 4/27/2009 14:48'!
developers

	self project ifNil: [^ #()].
	^ ((self project developers
		sortBy: [:dev1 :dev2 | dev1 userName asLowercase <= dev2 userName asLowercase])
		reject: [:dev | dev = dev repository currentUser])
		collect: [:developer | XpfDeveloperListEntryMorph forUser: developer]! !

!XpfDeveloperListModel methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:49'!
project

	^ project! !

!XpfDeveloperListModel methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:58'!
project: anObject

	project := anObject.
	self changed: #developers.! !

Object subclass: #XpfHistoryEntryModel
	instanceVariableNames: 'entity entry entityType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfHistoryEntryModel methodsFor: 'as yet unclassified' stamp: 'cs 4/7/2009 14:38'!
asMorph

	^ XpfHistoryEntryMorph forEntry: self! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entity

	^ entity! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entity: anObject

	entity := anObject.! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 16:20'!
entityType

	^ entityType! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 16:20'!
entityType: anObject

	entityType := anObject.! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entry

	^ entry! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:24'!
entry: anObject

	entry := anObject.! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'mt 4/28/2009 16:57'!
new

	^ (self entry newVal ifNil: [self entry newRef]) asString withoutLineEndingsTruncatedTo: 20! !

!XpfHistoryEntryModel methodsFor: 'accessing' stamp: 'mt 4/28/2009 16:57'!
old

	^ (self entry oldVal ifNil: [self entry oldRef]) asString withoutLineEndingsTruncatedTo: 20! !

Object subclass: #XpfHistoryModel
	instanceVariableNames: 'project showProject showTasks showUserStories individualEntity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 14:16'!
enableGlobal

	^ self individualEntity isNil! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 14:13'!
enableIndividual

	^ self individualEntity notNil! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/29/2009 13:47'!
entries
	
	| result |
	result := OrderedCollection new.
	self showProject ifTrue: [result addAll: self projectEntries].
	self showUserStories ifTrue: [result addAll: self userStoryEntries].
	self showTasks ifTrue: [result addAll: self taskEntries].
	self showIndividual ifTrue: [result addAll: self individualEntries].
	^ result reversed sortBy: [:first :second | first entry timestamp > second entry timestamp]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 14:31'!
entriesAsMorphs
	
	^ self entries collect: [:entry | entry asMorph]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 14:10'!
individualEntity

	^ individualEntity! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'mt 4/28/2009 13:40'!
individualEntity: entity

	self individualEntity ifNotNil: [self individualEntity removeDependent: self].
	individualEntity := entity.
	self individualEntity ifNotNil: [self individualEntity addDependent: self].
	
	self
		changed: #enableGlobal;
		changed: #enableIndividual;
		changed: #showIndividual;
		changed: #showProject;
		changed: #showTasks;
		changed: #showUserStories;
		changed: #entriesAsMorphs;
		changed: #individualTitle.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 6/11/2009 14:52'!
individualEntries
	
	(individualEntity isRestProxy and: [individualEntity history isLoaded not]) ifTrue:
		[individualEntity history reloadDepth: 3].
	^ individualEntity history collect: [:each |
			XpfHistoryEntryModel new
				entity: individualEntity;
				entry: each;
				entityType: #individual]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 19:19'!
individualTitle

	^ self enableIndividual
		ifTrue: [self individualEntity asString]
		ifFalse: ['']! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/7/2009 11:03'!
project

	^ project! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/29/2009 10:34'!
project: anObject

	self project isRestProxy ifTrue: [self project repository removeDependent: self].
	self project ifNotNil: [self project removeDependent: self].
	project := anObject.
	self project ifNotNil: [self project addDependent: self].
	self project isRestProxy ifTrue: [self project repository addDependent: self].! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 6/11/2009 14:52'!
projectEntries
	
	(project isRestProxy and: [project history isLoaded not]) ifTrue:
		[project history reloadDepth: 3].
	^ project history collect: [:each |
			XpfHistoryEntryModel new
				entity: project;
				entry: each;
				entityType: #project]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 14:10'!
showIndividual

	^ self individualEntity notNil! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 19:21'!
showIndividual: anObject

	"if the checkbox is clicked, then the individual view will be deselected"
	self
		individualEntity: nil;
		changed: #enableGlobal;
		changed: #showIndividual;
		changed: #entriesAsMorphs;
		changed: #individualTitle.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/29/2009 10:38'!
showProject

	showProject ifNil: [showProject := false].
	^ showProject and: [self enableGlobal]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/29/2009 10:49'!
showProject: anObject

	showProject := anObject.
	self showProject
		ifTrue: [self project history addDependent: self]
		ifFalse: [self project history removeDependent: self].
	self
		changed: #showProject;
		changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'mt 4/22/2009 14:45'!
showTasks

	showTasks ifNil: [showTasks := false].
	^ showTasks and: [self enableGlobal]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/17/2009 19:22'!
showTasks: anObject

	showTasks := anObject.
	self
		changed: #showTasks;
		changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'mt 4/22/2009 14:45'!
showUserStories

	showUserStories ifNil: [showUserStories := false].
	^ showUserStories and: [self enableGlobal]! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 4/29/2009 11:17'!
showUserStories: anObject

	showUserStories := anObject.
	self showUserStories
		ifTrue: [project iterations do: [:iteration | iteration history addDependent: self]]
		ifFalse: [project iterations do: [:iteration | iteration history removeDependent: self]].

	self
		changed: #showUserStories;
		changed: #entriesAsMorphs.! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 6/11/2009 14:51'!
taskEntries
	
	| allTasks allStories |
	allStories := project iterations
		inject: OrderedCollection new
		into: [:all :it | all addAll: it userStories. all]
		displayingProgress: 'Collecting all userstories...'.
	
	allTasks := allStories
		inject: OrderedCollection new
		into: [:all :us | all addAll: us tasks. all]
		displayingProgress: 'Collecting all tasks...'. "This may take a while if not loaded."
		
	^ allTasks
		inject: OrderedCollection new
		into: [:old :eachTask |
			(eachTask isRestProxy and: [eachTask history isLoaded not])
				ifTrue: [eachTask history reloadDepth: 3].
			old addAll: (eachTask history
				collect: [:eachEntry |
					XpfHistoryEntryModel new
					entity: eachTask;
					entry: eachEntry;
					entityType: #task]). old]
		displayingProgress: 'Collecting all userstories...'.! !

!XpfHistoryModel methodsFor: 'updating' stamp: 'cs 4/29/2009 10:49'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #historyLoaded
		ifTrue: [self changed: #entriesAsMorphs].
	aSymbol = #title ifTrue: [self changed: #individualTitle].! !

!XpfHistoryModel methodsFor: 'updating' stamp: 'cs 4/17/2009 16:22'!
update: aSymbol with: argument

	super update: aSymbol with: argument.
	aSymbol = #showHistory
		ifTrue: [self individualEntity: argument].! !

!XpfHistoryModel methodsFor: 'accessing' stamp: 'cs 6/11/2009 14:52'!
userStoryEntries
	
	| allStories |
	allStories := project iterations
		inject: OrderedCollection new
		into: [:all :it | all addAll: it userStories. all].
	
	^ allStories
		inject: OrderedCollection new
		into: [:old :eachUserStory |
			(eachUserStory isRestProxy and: [eachUserStory history isLoaded not])
				ifTrue: [eachUserStory history reloadDepth: 3].
			old addAll:
				(eachUserStory history collect: [:eachEntry |
					XpfHistoryEntryModel new
					entity: eachUserStory;
					entry: eachEntry;
					entityType: #userStory]). old]
		displayingProgress: 'Collecting all userstories...'.! !

Object subclass: #XpfIterationListModel
	instanceVariableNames: 'project selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:49'!
initialize

	super initialize.
	self selectionIndex: 0.! !

!XpfIterationListModel methodsFor: 'as yet unclassified' stamp: 'cs 4/20/2009 17:07'!
iteration

	^ self selectionIndex = 0
		ifTrue: [nil]
		ifFalse: [self project iterations reversed at: self selectionIndex]! !

!XpfIterationListModel methodsFor: 'as yet unclassified' stamp: 'cs 4/20/2009 17:07'!
list

	self project  ifNil: [^ #()].
	^ (self project iterations collect: [:each | each title]) reversed.! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:36'!
project

	^ project! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:48'!
project: anObject

	project := anObject.
	self project ifNotNil: [self project addDependent: self].
	self changed: #list.	! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:47'!
selectionIndex

	^ selectionIndex! !

!XpfIterationListModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:47'!
selectionIndex: anObject

	selectionIndex := anObject.
	self changed: #selectionIndex.! !

Object subclass: #XpfIterationTreeModel
	instanceVariableNames: 'iteration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfIterationTreeModel methodsFor: 'accessing' stamp: 'mt 4/1/2009 11:36'!
iteration

	^ iteration! !

!XpfIterationTreeModel methodsFor: 'accessing' stamp: 'mfp 4/29/2009 17:17'!
iteration: anXpfIteration

	self iteration ifNotNil: [self iteration userStories removeDependent: self].
	iteration := anXpfIteration.
	self iteration ifNotNil: [self iteration userStories addDependent: self].! !

!XpfIterationTreeModel methodsFor: 'accessing' stamp: 'SR 4/10/2009 12:49'!
rootItems

	| temp |
	temp :=  self iteration userStories collect: [:us | (XpfUserStoryItemWrapper with: nil model: us)].
	temp isEmpty
		ifTrue: [^ {ListItemWrapper with: ''}]
		ifFalse: [^ temp].! !

!XpfIterationTreeModel methodsFor: 'as yet unclassified' stamp: 'mfp 4/29/2009 17:15'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #userStoriesLoaded
		ifTrue: [self changed: #rootItems].! !

Object subclass: #XpfLoginModel
	instanceVariableNames: 'server login password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

XpfLoginModel class
	instanceVariableNames: 'defaultServer defaultUser defaultPassword'!

XpfLoginModel class
	instanceVariableNames: 'defaultServer defaultUser defaultPassword'!

!XpfLoginModel class methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:35'!
defaultPort

	^ '8082'! !

!XpfLoginModel class methodsFor: 'accessing' stamp: 'topa 5/4/2009 09:49'!
defaultServer

	^ defaultServer ifNil: ['xpforums.hpi.uni-potsdam.de']! !

!XpfLoginModel class methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:29'!
defaultServer: anObject

	defaultServer := anObject.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'SR 7/1/2009 14:06'!
connectString

	self storeDefaults.
	^ RestProxyRepository
		url: 'http://', self server, ':', self class defaultPort, '/'! !

!XpfLoginModel methodsFor: 'initialization' stamp: 'SR 7/1/2009 19:37'!
initialize

	super initialize.
	self loadData.! !

!XpfLoginModel methodsFor: 'initialization' stamp: 'SR 7/1/2009 19:43'!
loadData

	self
		server: self class defaultServer;
		login: ActiveHand login;
		password: ActiveHand password! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:53'!
login

	^ login! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:53'!
login: anObject

	login := anObject.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:53'!
password

	^ password! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:54'!
password: anObject

	password := anObject.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:33'!
server

	^ server! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:34'!
server: aString

	server := aString.! !

!XpfLoginModel methodsFor: 'accessing' stamp: 'SR 7/1/2009 19:43'!
storeDefaults

	self class defaultServer: self server.
	ActiveHand login: self login password: self password.! !

Object subclass: #XpfLoginModelForHand
	instanceVariableNames: 'login password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfLoginModelForHand methodsFor: 'initialization' stamp: 'SR 7/1/2009 12:38'!
initialize

	super initialize.
	self
		login: '';
		password: ''.! !

!XpfLoginModelForHand methodsFor: 'as yet unclassified' stamp: 'SR 7/1/2009 12:50'!
loadDataFromHand: aHand

	self
		login: aHand login;
		password: aHand password.! !

!XpfLoginModelForHand methodsFor: 'accessing' stamp: 'SR 7/1/2009 12:34'!
login

	^ login! !

!XpfLoginModelForHand methodsFor: 'accessing' stamp: 'SR 7/1/2009 12:50'!
login: anObject

	login := anObject.
	self changed: #login.! !

!XpfLoginModelForHand methodsFor: 'accessing' stamp: 'SR 7/1/2009 12:34'!
password

	^ password! !

!XpfLoginModelForHand methodsFor: 'accessing' stamp: 'SR 7/1/2009 12:50'!
password: anObject

	password := anObject.
	self changed: #password.! !

!XpfLoginModelForHand methodsFor: 'as yet unclassified' stamp: 'SR 7/1/2009 13:54'!
storeDataToHand: aHand

	aHand login: self login password: self password! !

Object subclass: #XpfLoginProcessor
	instanceVariableNames: 'connectionString repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfLoginProcessor class methodsFor: 'as yet unclassified' stamp: 'mig 7/22/2009 11:27'!
initialize

	super initialize.
	Preferences addTextPreference: #xpfServer category: #xpf default: 'http://xpforums.hpi.uni-potsdam.de:8082/' balloonHelp: 'Server name or address for ProjectTalk'.! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'mig 7/22/2009 11:29'!
connectionString

	^ Preferences valueOfPreference: #xpfServer! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'mt 6/11/2009 14:23'!
project

	| projectChooser selectedProject |
	self user projects isEmpty ifTrue: [
		UITheme current alertIn: World text: 'You are not a member of any project.' title: 'Error'.
		XpfClientOpenError signal].
	selectedProject := (self user projects size = 1)
		ifTrue: [selectedProject := self user projects first]
		ifFalse: [
			projectChooser := XpfProjectChooser new
			passwordChangeDialog: XpfChangePasswordDialog new.		
			projectChooser passwordChangeDialog model user: self user.
			projectChooser model projects: self user projects.	
			(World openModal: projectChooser) result ].
		
	^ selectedProject ifNil: [XpfClientOpenError signal]! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'cs 5/26/2009 16:42'!
repository

	repository ifNil: [
		self repository: (XpfProxyRepository fromString: self connectionString)].
	^ repository! !

!XpfLoginProcessor methodsFor: 'accessing' stamp: 'cs 5/26/2009 16:41'!
repository: anObject

	repository := anObject.! !

!XpfLoginProcessor methodsFor: 'reseting' stamp: 'SR 7/22/2009 11:19'!
reset

	self
		repository: nil.! !

!XpfLoginProcessor methodsFor: 'private' stamp: 'SR 7/22/2009 11:25'!
user

	| userResponse |
	userResponse := [RestSocket get: self connectionString , '/info']
		on: RestConnectionLostError
		do: [UITheme current
				alertIn: World
				text: 'Could not connect to the server.'
				title: 'Connection failed'.
			self connectionString: nil.
			XpfClientOpenError signal].
	userResponse isOk ifFalse: [
		userResponse isUnauthorized ifTrue: [
			UITheme current
				alertIn: World
				text: 'You are not authorized to access any resource on the server.'
				title: 'Connection failed'.
			XpfClientOpenError signal]
			ifFalse: [RestProxyRepository errorForCode: userResponse responseCode]].
	^ (self repository getObject: userResponse content)! !

Object subclass: #XpfNewUserStory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:18'!
color

	^ 'white'! !

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:16'!
positionX

	^ 0! !

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:16'!
positionY

	^ 0! !

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:17'!
tasks

	^ #()! !

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:17'!
timeEstimated

	^ 0.0! !

!XpfNewUserStory methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 19:15'!
title

	^ 'Drop me into iteration'! !

Object subclass: #XpfProgressEstimationSliderModel
	instanceVariableNames: 'timeEstimated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfProgressEstimationSliderModel methodsFor: 'accessing' stamp: 'bs 6/16/2009 22:31'!
isEnabled
	^true! !

!XpfProgressEstimationSliderModel methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:36'!
timeEstimated

	^ timeEstimated! !

!XpfProgressEstimationSliderModel methodsFor: 'accessing' stamp: 'mig 4/17/2009 18:39'!
timeEstimated: anObject

	timeEstimated := anObject.
	self changed: #timeEstimated.! !

Object subclass: #XpfProjectChooserModel
	instanceVariableNames: 'projects projectsModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Models'!

!XpfProjectChooserModel methodsFor: 'initialization' stamp: 'SR 3/10/2009 13:58'!
initialize
	
	super initialize.
	
	projects := OrderedCollection new.
	projectsModel := ListModel new.! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'SR 3/10/2009 14:04'!
project

	^ (self projectsModel selectionIndex = 0)
		ifTrue: [nil]
		ifFalse: [self projects at: self projectsModel selectionIndex]! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'SR 3/10/2009 11:45'!
projects
	^ projects! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'mfp 3/19/2009 11:19'!
projects: anObject

	projects := anObject.
	projectsModel list: (self projects collect: [:e | e title]).
	projectsModel list ifNotEmpty: [projectsModel selectionIndex: 1]. 
	self changed.! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'SR 3/10/2009 13:58'!
projectsModel
	^ projectsModel! !

Object subclass: #XpfWidgetFilter
	instanceVariableNames: 'name filterBlock result nextFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

XpfWidgetFilter subclass: #XpfTaskWidgetFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfTaskWidgetFilter methodsFor: 'results' stamp: 'cs 5/13/2009 18:43'!
morphFor: task 

	^ XpfTaskListEntryMorph for: task! !

!XpfWidgetFilter methodsFor: 'results' stamp: 'cs 5/15/2009 13:06'!
createMorphListIn: aMorph

	aMorph addMorphBack: (('-- {1} ({2}) --' format: {self name. self result size}) asText asMorph lock).
	self result do: [:each | | widgetMorph |
		widgetMorph := (self morphFor: each).
		aMorph addMorphBack: widgetMorph.
		widgetMorph addDependent: aMorph].
	self nextFilter ifNotNilDo: [:filter | filter createMorphListIn: aMorph]! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:05'!
filterBlock

	^ filterBlock! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:05'!
filterBlock: anObject

	filterBlock := anObject.! !

!XpfWidgetFilter methodsFor: 'initialization' stamp: 'cs 5/13/2009 18:08'!
initialize

	super initialize.
	self
		result: OrderedCollection new;
		filterBlock: [:a| true].! !

!XpfWidgetFilter methodsFor: 'results' stamp: 'cs 5/13/2009 18:40'!
morphFor: anObject
	
	self subclassResponsibility.! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:08'!
name

	^ name! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:08'!
name: anObject

	name := anObject.! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:06'!
nextFilter

	^ nextFilter! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:50'!
nextFilter: anObject

	self nextFilter
		ifNil: [nextFilter := anObject]
		ifNotNilDo: [:filter | filter nextFilter: anObject].! !

!XpfWidgetFilter methodsFor: 'processing' stamp: 'cs 5/13/2009 20:07'!
process: anObject

	(self filterBlock value: anObject)
		ifTrue: [self result add: anObject]
		ifFalse: [self nextFilter ifNotNilDo: [:filter | filter process: anObject]].! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:05'!
result

	^ result! !

!XpfWidgetFilter methodsFor: 'accessing' stamp: 'cs 5/13/2009 18:05'!
result: anObject

	result := anObject.! !

!ListItemWrapper methodsFor: '*Xpf-Client' stamp: 'SR 4/7/2009 16:04'!
hasXpfModel

	^ false! !

ListItemWrapper subclass: #XpfEntityItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfEntityItemWrapper class methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 13:14'!
with: anObject model: aModel

	| result |
	result := super with: anObject model: aModel.
	aModel addDependent: result.
	^ result! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mig 4/19/2009 22:30'!
asString

	^ (model title ifNil: ['(no title)']) asString truncateWithElipsisTo: 25! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mig 4/19/2009 22:29'!
balloonText

	^ (model title ifNil: ['(no title)']) asString withNoLineLongerThan: 25! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:50'!
contents

	^ {self createTimeEstimatedItem.
		self createTimeActualItem}! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 15:17'!
createTimeActualItem

	^ (XpfValueBarWrapper with: nil model: self model)
		getValueSelector: #timeActual;
		preferredColor: ((self model timeEstimated isNil | self model timeActual isNil)
			ifTrue: [Color black]
			ifFalse: [ | diff |
				((diff := self model timeEstimated - self model timeActual) abs < 2)
				ifTrue: [Color green muchDarker]
				ifFalse: [	diff > 0
					ifTrue: [Color orange]
					ifFalse: [Color red]]]);
		prefix: 'Actual Time:'! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 17:09'!
createTimeEstimatedItem

	^ (XpfValueBarWrapper with: nil model: self model)
		getValueSelector: #timeEstimated;
		preferredColor: (self model timeEstimated isNil
			ifNil: [Color black]
			ifNotNil: [Color blue]);
		prefix: 'Estimated Time:'! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:33'!
hasXpfModel

	^ true! !

!XpfEntityItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 14:29'!
update: aSymbol

	super update: aSymbol.
	self changed: #rootItems.! !

XpfEntityItemWrapper subclass: #XpfUserStoryItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfUserStoryItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:53'!
contents

	^ super contents asOrderedCollection
		add: self createTasksItem;
		yourself! !

!XpfUserStoryItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:48'!
createTasksItem

	^ XpfTaskListItemWrapper with: nil model: self model tasks! !

ListItemWrapper subclass: #XpfTaskListItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfTaskListItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 17:02'!
asString

	^ 'Tasks'! !

!XpfTaskListItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:48'!
contents

	^ self model collect: [:task |
		XpfEntityItemWrapper with: nil model: task]! !

!XpfTaskListItemWrapper methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:04'!
hasXpfModel

	^ true! !

ListItemWrapper subclass: #XpfValueBarWrapper
	instanceVariableNames: 'getValueSelector preferredColor prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfValueBarWrapper class methodsFor: 'as yet unclassified' stamp: 'mt 3/25/2009 16:05'!
max

	^ 25! !

!XpfValueBarWrapper methodsFor: 'converting' stamp: 'mt 3/25/2009 17:11'!
asString

	| value |
	
	value := self model perform: self getValueSelector.
	
	value ifNil: [^ '(not set)'].
	^ (String new: ((10 * value) / self class max) ceiling) collect: [:e | $+]! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:33'!
balloonText

	^ '{1} {2}' format: {self prefix. self model perform: self getValueSelector}! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'topa 4/17/2009 15:11'!
getValueSelector

	^ getValueSelector! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'topa 4/17/2009 15:11'!
getValueSelector: anObject

	getValueSelector := anObject.! !

!XpfValueBarWrapper methodsFor: 'testing' stamp: 'topa 4/20/2009 17:18'!
isValueBarWrapper

	^ true! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:21'!
preferredColor

	^ preferredColor! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'mt 3/25/2009 16:22'!
preferredColor: anObject

	preferredColor := anObject.! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'topa 4/17/2009 15:11'!
prefix

	^ prefix! !

!XpfValueBarWrapper methodsFor: 'accessing' stamp: 'topa 4/17/2009 15:11'!
prefix: anObject

	prefix := anObject.! !

!Number class methodsFor: '*xpf-client-override' stamp: 'mig 4/21/2009 11:30'!
readExponent: baseValue base: base from: aStream
	"Complete creation of a number, reading exponent from aStream. Answer the
	number, or nil if parsing fails.
	<number>(e|d|q)<exponent>>"

	| sign exp value |
	('edqEDQ' includes: aStream next) ifFalse: [^ nil].
	sign := ((aStream peek) == $-)
		ifTrue: [aStream next. -1]
		ifFalse: [1].
	(aStream peek) == $+ ifTrue: [aStream next].
	(aStream atEnd or: [(aStream peek digitValue between: 0 and: 9) not])
		ifTrue: [^ nil]. "Avoid throwing an error"
	exp := (Integer readFrom: aStream base: 10) * sign.
	value := baseValue * (base raisedTo: exp).
	^ value
! !

IndentingListItemMorph subclass: #XpfIndentingListItemMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfIndentingListItemMorph methodsFor: 'as yet unclassified' stamp: 'topa 4/20/2009 17:25'!
initWithContents: anObject prior: priorMorph forList: hostList indentLevel: newLevel

	| fontToUse |
	"We use our own font. Else, do the super doings, thus copied"
	fontToUse := anObject isValueBarWrapper
		ifTrue: [XpfClient monoFont]
		ifFalse: [XpfClient sansFontAt: 10].
	container := hostList.
	complexContents := anObject.
	self initWithContents: anObject asString font: fontToUse emphasis: nil.
	indentLevel := 0.
	isExpanded := false.
 	nextSibling := firstChild := nil.
	priorMorph ifNotNil: [
		priorMorph nextSibling: self.
	].
	indentLevel := newLevel.
	icon := anObject icon.
	self extent: self minWidth @ self minHeight! !

!XpfIndentingListItemMorph methodsFor: 'as yet unclassified' stamp: 'cs 5/18/2009 16:15'!
isFirstItem

	^ owner notNil and: [owner submorphs first == self]! !

!Date methodsFor: '*xpf-client' stamp: 'mt 4/29/2009 11:41'!
printRelativeDate
	"Returns 'Today' or 'Yesterday' or 'MM-DD-YYYY' as String for the date."
	
	self = Date today ifTrue: [^'Today'].
	self = Date yesterday ifTrue: [^'Yesterday'].
	
	^(self printFormat: #(1 2 3 $- 1 1 2))! !

!PluggableTextFieldMorph methodsFor: '*xpf-client-override' stamp: 'SR 7/1/2009 12:47'!
getText
	"Retrieve the current model text. Set the converter to
	convert between the class of the returned object and string form."

	| newObj |
	getTextSelector ifNil: [^super getText].
	model ifNil: [^ ''].
	
	newObj := model perform: getTextSelector.
	newObj ifNil: [^Text new].
	self converter isNil
		ifTrue: [self convertTo: newObj class].
	^(self converter objectAsString: newObj) shallowCopy! !

PluggableTextFieldMorph subclass: #XpfCardEdit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfCardEdit methodsFor: 'as yet unclassified' stamp: 'bs 6/17/2009 11:28'!
fillStyleToUse
	^ Color transparent! !

BorderedMorph subclass: #XpfListEntryMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:21'!
defaultColor

	self subclassResponsibility! !

!XpfListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:34'!
for: aXpfObject

	^self new model: aXpfObject.! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:22'!
createUserInterface

	self subclassResponsibility! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 13:40'!
delete

	self model ifNotNil: [self model removeDependent: self].
	super delete.! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'mt 5/14/2009 12:35'!
initialize

	super initialize.
	self
		changeTableLayout;
		layoutInset: 0;
		cellInset: 0;
		borderWidth: XpfListWidget defaultBorderWidth;
		borderColor: (Color veryVeryLightGray alpha: 0.5);
		useRoundedCorners;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		color: self class defaultColor.! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:07'!
model

	^model! !

!XpfListEntryMorph methodsFor: 'as yet unclassified' stamp: 'topa 4/21/2009 17:50'!
model: anXpfUserStory

	self model ifNotNil: [self model removeDependent: self].
	model := anXpfUserStory.
	self model ifNotNil: [
		self 
			removeAllMorphs;
			createUserInterface.
		self model addDependent: self].! !

XpfListEntryMorph subclass: #XpfTaskListEntryMorph
	instanceVariableNames: 'actionsMorph titleContent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskListEntryMorph class methodsFor: 'contants' stamp: 'cs 5/13/2009 15:56'!
defaultColor

	^ XpfTaskMorph defaultColor! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mig 4/15/2009 18:09'!
actionsMorph

	^ actionsMorph ifNil: [
		actionsMorph := XpfTaskWidgetActionsContent forModel: self model].! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mig 4/15/2009 18:08'!
actionsMorph: anObject

	actionsMorph := anObject! !

!XpfTaskListEntryMorph methodsFor: 'initialization' stamp: 'mt 5/14/2009 12:32'!
createUserInterface

	self
		addMorph: ((self theme newRowIn: self for: {
			self titleContent.
			self actionsMorph})
				cellInset: 0;
				hResizing: #shrinkWrap);
		addMorphBack: ((XpfTaskDeveloperContent forModel: self model)
			hResizing: #rigid;
			extent: 160@10);
		addMorphBack: ((XpfTaskProgressContentForWidget withModel: self model)
			hResizing: #rigid;
			extent: 160@10);			
		updateStartedBorder.! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 11:52'!
model: myModel

	super model: myModel.
	self
		updateColor;
		updateStartedBorder.! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 10:47'!
titleContent

	titleContent ifNil: [self titleContent:
		(XpfTaskTitleContent forModel: self model)].
	^ titleContent! !

!XpfTaskListEntryMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 10:47'!
titleContent: anObject

	titleContent := anObject.! !

!XpfTaskListEntryMorph methodsFor: 'updating' stamp: 'mt 5/14/2009 13:44'!
update: aSymbol

	aSymbol = #isStarted ifTrue: [self updateStartedBorder].
	aSymbol = #isDone ifTrue: [self updateColor].
	
	(#(isDone responsibleDeveloper developers) includes: aSymbol)
		ifTrue: [self changed: #requestSorting].
	
	super update: aSymbol.! !

!XpfTaskListEntryMorph methodsFor: 'updating' stamp: 'cs 5/13/2009 15:56'!
updateColor

	self color:
		(self model isDone 
			ifTrue: [XpfTaskMorph defaultDoneColor]
			ifFalse: [XpfTaskMorph defaultColor]).! !

!XpfTaskListEntryMorph methodsFor: 'updating' stamp: 'SR 4/28/2009 18:38'!
updateStartedBorder

	self model isStarted 
		ifTrue: [
			self borderWidth: 2.
			self borderColor: Color red]
		ifFalse: [
			self borderWidth: 0.
			self borderColor: Color black].! !

XpfListEntryMorph subclass: #XpfUserStoryListEntryMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfUserStoryListEntryMorph class methodsFor: 'as yet unclassified' stamp: 'topa 4/21/2009 18:08'!
defaultColor

	^ Color lightYellow alpha: 0.85! !

!XpfUserStoryListEntryMorph methodsFor: 'as yet unclassified' stamp: 'topa 4/23/2009 14:25'!
createUserInterface

	self
		addMorph: ((XpfUserStoryTitleContent forModel: self model) width: XpfListWidget defaultWidth);
		addMorphBack: (XpfUserStoryProgressEstimationSliderContent withModel: self model).! !

BorderedMorph subclass: #XpfWidget
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

XpfWidget subclass: #XpfDeveloperListWidget
	instanceVariableNames: 'shareButton devList devListModel serverTunnel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfDeveloperListWidget class methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 14:29'!
defaultHeight

	^ 250! !

!XpfDeveloperListWidget class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:37'!
defaultWidth

	^ 250! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'mt 5/5/2009 11:09'!
createVncServerTunnelToHub: hubPort
	
	serverTunnel := SSHTunnel new 
				isLocalTunnel: false; 
				localPort: 5900;
				remotePort: hubPort;
				server: self model repository url authority.
	serverTunnel execute.
	
	(0 to: 10) 
		do: [:ignore | (Delay forMilliseconds: 600) wait]
		displayingProgress: 'Giving SSH connection some time...'. ! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 18:21'!
destroyVncServerTunnelToHub
	
	serverTunnel ifNotNil: [
		serverTunnel terminate.
		serverTunnel := nil].! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'cs 5/5/2009 10:34'!
devList

	devList ifNil: [self devList: 
		((self theme newMorphListIn: self  
		for: self devListModel
		list: #developers
		getSelected: nil
		setSelected: nil
		getEnabled: nil 
		help: 'See online status and screen share availability of co-developers' )
		hResizing: #rigid;
		vResizing: #rigid;
		extent: self class defaultExtent;
		layoutInset: 2)].
	^ devList! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:01'!
devList: anObject
	devList := anObject! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:50'!
devListModel

	devListModel ifNil: [devListModel := XpfDeveloperListModel new].
	^ devListModel! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:48'!
devListModel: anObject

	devListModel := anObject.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 17:56'!
doShareOrUnshare

	self isSharing ifTrue: [self unshare] ifFalse: [self share]! !

!XpfDeveloperListWidget methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 15:05'!
initializeUserInterface

	self
		addMorphBack: self devList;
		addMorphBack: self shareButton.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 17:48'!
isSharing

	^ RFBServer server isNil not! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:51'!
model: anXpfProject.

	super model: anXpfProject.
	self devListModel project: anXpfProject.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 18:18'!
registerHubPortForCurrentUser: hubPort
	
	| response userProxy |
	response := RestSocket get: self xpfServerUrl , '/info'.
	userProxy := (XpfProxyRepository fromString: self xpfServerUrl) getObject: response content.
	userProxy sharingPort: hubPort.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 18:14'!
requestAvailableHubPort

	| response |
	response := (RestSocket get: self xpfServerUrl, '/rfb').
	response isOk ifFalse: [self error: response content].
	^ response content asInteger.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'mt 5/5/2009 11:08'!
resetHubPortForCurrentUser

	self model repository currentUser sharingPort: nil.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 18:19'!
share
	
	| hubPort |
	hubPort := self requestAvailableHubPort.
	self createVncServerTunnelToHub: hubPort.
	RFBServer start: 0.
	self registerHubPortForCurrentUser: hubPort.
	self changed: #shareLabel.! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'bs 4/27/2009 17:06'!
shareButton

	shareButton ifNil: [self shareButton:
		(self theme
			newButtonIn: self
			for: self
			getState: nil
			action: #doShareOrUnshare
			arguments: nil
			getEnabled: nil
			getLabel: #shareLabel
			help: '')].
	^ shareButton! !

!XpfDeveloperListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 12:01'!
shareButton: anObject
	shareButton := anObject! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 17:48'!
shareLabel

	^ self isSharing
		ifFalse: ['Share']
		ifTrue: ['Unshare']! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'bs 4/27/2009 18:22'!
unshare
	
	| |

	self resetHubPortForCurrentUser.
	RFBServer stop.
	self destroyVncServerTunnelToHub.
	self changed: #shareLabel.! !

!XpfDeveloperListWidget methodsFor: 'model' stamp: 'mt 5/5/2009 11:07'!
xpfServerUrl

	^ self model repository url asString! !

XpfWidget subclass: #XpfListWidget
	instanceVariableNames: 'iterationList elementList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfListWidget class methodsFor: 'constants' stamp: 'SR 4/10/2009 19:25'!
elementListClass

	self subclassResponsibility! !

!XpfListWidget methodsFor: 'accessing' stamp: 'cs 4/14/2009 17:17'!
elementList

	elementList ifNil: [self elementList: self class elementListClass new].
	^ elementList! !

!XpfListWidget methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:14'!
elementList: anObject

	elementList := anObject! !

!XpfListWidget methodsFor: 'initialization' stamp: 'mt 5/12/2009 17:24'!
initializeUserInterface

	self
		addMorphBack: self iterationList;
		addMorphBack: self seperator;
		addMorphBack: self elementList withScrollBars.! !

!XpfListWidget methodsFor: 'accessing' stamp: 'mt 5/12/2009 18:09'!
iterationList

	iterationList ifNil: [
		self iterationList: (self theme
							newDropListIn: self
							for: (XpfIterationListModel new project: self model)
							list: #list
							getSelected: #selectionIndex
							setSelected: #selectionIndex:
							getEnabled: nil
							useIndex: true
							help: '').
		self iterationList
			hResizing: #rigid;
			extent: self class defaultWidth @ 20.
		self iterationList model addDependent: self.].
	^ iterationList! !

!XpfListWidget methodsFor: 'accessing' stamp: 'SR 4/10/2009 19:14'!
iterationList: anObject

	iterationList := anObject! !

!XpfListWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 11:55'!
model: aXpfProject

	super model: aXpfProject.
	self iterationList model project: self model.
	self model iterations size > 1
		ifTrue: [self iterationList listSelectionIndex: 2]
		ifFalse: [self iterationList listSelectionIndex: 1].

	self layoutChanged.! !

!XpfListWidget methodsFor: 'as yet unclassified' stamp: 'mig 4/15/2009 17:37'!
seperator

	^ SeparatorMorph new height: 2.! !

!XpfListWidget methodsFor: 'updating' stamp: 'cs 4/14/2009 17:29'!
update: aSymbol

	aSymbol = #selectionIndex ifTrue: [| newIteration |
		newIteration := self iterationList model iteration.
		self elementList model: newIteration].
	^ super update: aSymbol.! !

XpfListWidget subclass: #XpfTaskListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskListWidget class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 22:01'!
elementListClass

	^ XpfTaskListMorph2! !

XpfListWidget subclass: #XpfUserStoryListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfUserStoryListWidget class methodsFor: 'as yet unclassified' stamp: 'mt 5/12/2009 18:30'!
defaultWidth 

	^ 200! !

!XpfUserStoryListWidget class methodsFor: 'as yet unclassified' stamp: 'SR 4/11/2009 21:56'!
elementListClass

	^ XpfUserStoryListMorph! !

!XpfWidget class methodsFor: 'constants' stamp: 'mt 4/27/2009 11:57'!
defaultBorderWidth

	^ 3! !

!XpfWidget class methodsFor: 'constants' stamp: 'mt 5/12/2009 17:56'!
defaultExtent

	^ self defaultWidth @ self defaultHeight! !

!XpfWidget class methodsFor: 'constants' stamp: 'mt 4/27/2009 14:29'!
defaultHeight

	^ 500! !

!XpfWidget class methodsFor: 'constants' stamp: 'mt 5/12/2009 17:58'!
defaultWidth 

	^ 180! !

!XpfWidget class methodsFor: 'instance creation' stamp: 'cs 5/27/2009 11:15'!
open
	
	[^ self openProject: XpfLoginProcessor new project]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfWidget class methodsFor: 'instance creation' stamp: 'cs 6/12/2009 16:00'!
openProject: project
		
	| instance |
	[#(model open) do: [:step |
		World displayWorldSafely.
		step = #model ifTrue: [instance := self new model: project].
		step = #open ifTrue: [instance openInHand]] displayingProgress: 'Opening widget...'.

	^ instance]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfWidget methodsFor: 'as yet unclassified' stamp: 'cs 4/27/2009 17:09'!
delete

	self model ifNotNil: [self model repository stopUpdating].
	^ super delete! !

!XpfWidget methodsFor: 'initialization' stamp: 'mt 5/12/2009 17:18'!
initialize

	super initialize.
	self
		changeTableLayout;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		borderWidth: 0;
		fillStyle: (Color r: 0.8 g: 0.8 b: 0.8 alpha: 0.5);
		layoutInset: 5;
		cellInset: 5;
		useRoundedCorners;
		initializeUserInterface.! !

!XpfWidget methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 12:52'!
initializeUserInterface

	self subclassResponsibility.! !

!XpfWidget methodsFor: 'accessing' stamp: 'mt 4/27/2009 11:55'!
model

	^ model! !

!XpfWidget methodsFor: 'accessing' stamp: 'SR 4/28/2009 17:16'!
model: anObject

	self model ifNotNil: [self model removeDependent: self].
	model := anObject.
	anObject repository startUpdating.
	self model ifNotNil: [self model addDependent: self].! !

Error subclass: #XpfClientOpenError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

PluggableDialogWindow subclass: #XpfDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

XpfDialog subclass: #XpfAdminTool
	instanceVariableNames: 'projectList userList projectTitleEntry userNameEntry userLoginEntry saveProjectButton saveUserButton projectAddButton userAddButton projectDeleteButton userDeleteButton userPasswordButton projectDeveloperList projectUserDropList projectAddDeveloperButton projectDeleteDeveloperButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-AdminTool'!

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 10:21'!
createProjectAddButtonFor: myModel 

	self projectAddButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #addProject
		arguments: nil
		getEnabled: nil
		label: 'Add Project'
		help: 'Add new project').
	^ self projectAddButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 16:37'!
createProjectAddDeveloperButtonFor: myModel 

	self projectAddDeveloperButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #addDeveloperToProject
		arguments: nil
		getEnabled: #hasCurrentProjectCandidateIndex
		label: 'Add'
		help: 'Add the candidate as developer to this project.').
	^ self projectAddDeveloperButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 13:15'!
createProjectDeleteButtonFor: myModel 

	self projectDeleteButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #deleteProject
		arguments: nil
		getEnabled: #hasProjects
		label: 'Delete Project'
		help: 'Delete project').
	^ self projectDeleteButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'cs 3/9/2009 15:29'!
createProjectDeleteDeveloperButtonFor: myModel 

	self projectDeleteDeveloperButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #deleteDeveloper
		arguments: nil
		getEnabled: #hasCurrentProjectDeveloperIndex
		label: 'Remove'
		help: 'Remove the selected developer from the current project. The user remains in the database.').
	^ self projectDeleteDeveloperButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 15:48'!
createProjectDeveloperListFor: aModel

	self projectDeveloperList: (UITheme current
		newListIn: self
		for: aModel
		list: #allProjectDeveloperNames
		selected: #currentProjectDeveloperIndex
		changeSelected: #currentProjectDeveloperIndex:
		getEnabled: nil
		help: 'Shows all developers of this project.').
	^ self projectDeveloperList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:21'!
createProjectListFor: aModel

	self projectList: (UITheme current
		newListIn: self
		for: aModel
		list: #allProjectTitles
		selected: #currentProjectIndex
		changeSelected: #currentProjectIndex:
		getEnabled: nil
		help: 'Shows all projects.').
	^ self projectList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:20'!
createProjectTitleEntryFor: myModel

	self projectTitleEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentProjectTitle
		set: #currentProjectTitle:
		class: String
		getEnabled: #hasCurrentProject
		help: 'Enter a short descriptive title for this project.') maxLength: 100).
	^ self projectTitleEntry minWidth: 200! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 15:49'!
createProjectUserDropListFor: aModel

	self projectUserDropList: (UITheme current
		newDropListIn: self
		for: aModel
		list: #allProjectCandidateNames
		getSelected: #currentProjectCandidateIndex
		setSelected: #currentProjectCandidateIndex:
		getEnabled: #hasCurrentProjectCandidates
		useIndex: true
		help: 'All available users for this project').
	^ self projectUserDropList! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'cs 3/9/2009 15:39'!
createProjectsTabFor: myModel 

	| col row |
	col := self createCol: { 
		self createRow: {self createLabel: 'Title:'. self createProjectTitleEntryFor: myModel}.
		self createRow: {self createHFiller. self createSaveProjectButton}.
		self createHSeparator.
		self createRow: {
			self createLabel: 'Developers:'.
			self createHFiller.
			self createProjectDeleteDeveloperButtonFor: myModel}.
		self createProjectDeveloperListFor: myModel.
		self createRow: {
			self createLabel: 'Candidate:'. 
			self createProjectUserDropListFor: myModel. 
			self createProjectAddDeveloperButtonFor: myModel}}.
		
	row := self createRow: {
		self createCol: {
			self createProjectListFor: myModel. 
			self createRow: {
				self createProjectAddButtonFor: myModel. 
				self createProjectDeleteButtonFor: myModel. 
				self createHFiller}}.
		self createVSeparator.
		col}.
	row vResizing: #spaceFill.
	^ row! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mig 3/13/2009 16:02'!
createQuitButton

	^ UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Quit'
		help: 'Close the admin tool'! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 13:30'!
createSaveProjectButton

	self saveProjectButton: (UITheme current 
		newButtonIn: self
		for: self projectTitleEntry
		getState: nil
		action: #accept
		arguments: nil
		getEnabled: #enabled
		label: 'Save'
		help: 'Save changed project title').
	^ self saveProjectButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:35'!
createSaveUserButtonFor: myModel

	self saveUserButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #updateUser:
		arguments: {{self userNameEntry. self userLoginEntry}}
		getEnabled: #hasCurrentUser
		label: 'Save'
		help: 'Save changed user data').
	^ self saveUserButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 11:00'!
createUserAddButtonFor: myModel 

	self userAddButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #addUser
		arguments: nil
		getEnabled: nil
		label: 'Add User'
		help: 'Add new user').
	^ self userAddButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:05'!
createUserDeleteButtonFor: myModel 

	self userDeleteButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #deleteUser
		arguments: nil
		getEnabled: #hasUsers
		label: 'Delete User'
		help: 'Delete User').
	^ self userDeleteButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:23'!
createUserListFor: aModel

	self userList: (UITheme current
		newListIn: self
		for: aModel
		list: #allUserNames
		selected: #currentUserIndex
		changeSelected: #currentUserIndex:
		getEnabled: nil
		help: 'Shows all users.').
	^ self userList minHeight: 150! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:03'!
createUserLoginEntryFor: myModel

	self userLoginEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentUserLogin
		set: #currentUserLogin:
		class: String
		getEnabled: #hasCurrentUser
		help: 'Enter a valid email address') maxLength: 100).
	^ self userLoginEntry! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/5/2009 14:23'!
createUserNameEntryFor: myModel

	self userNameEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #currentUserName
		set: #currentUserName:
		class: String
		getEnabled: #hasCurrentUser
		help: 'Enter the name of the user.') maxLength: 100).
	^ self userNameEntry minWidth: 200! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 13:35'!
createUserPasswordButtonFor: myModel 

	self userPasswordButton: (UITheme current 
		newButtonIn: self
		for: myModel
		getState: nil
		action: #changePassword:
		arguments: {self}
		getEnabled: #hasCurrentUser
		label: 'Change Password...'
		help: 'Change the current password').
	^ self userPasswordButton! !

!XpfAdminTool methodsFor: 'user interface' stamp: 'mt 3/6/2009 13:36'!
createUsersTabFor: myModel

	| col row |
	col := self createCol: { 
		self createRow: {
			self createLabel: 'Name:'. 
			self createUserNameEntryFor: myModel}.
		self createRow: {
			self createLabel: 'Login/E-Mail:'. 
			self createUserLoginEntryFor: myModel}.
		self createRow: {
			self createUserPasswordButtonFor: myModel.
			self createHFiller. 
			self createSaveUserButtonFor: myModel}}.
		
	row := self createRow: {
		self createCol: {
			self createUserListFor: myModel. 
			self createRow: {
				self createUserAddButtonFor: myModel. 
				self createUserDeleteButtonFor: myModel. 
				self createHFiller}}.
		self createVSeparator.
		col}.
	
	row vResizing: #spaceFill.
	^ row! !

!XpfAdminTool methodsFor: 'submorphs-add/remove' stamp: 'cs 6/3/2009 15:54'!
delete

	self model repository isRestProxy ifTrue: [
		self model repository stopUpdating].
	super delete.! !

!XpfAdminTool methodsFor: 'initialization' stamp: 'mt 3/6/2009 14:26'!
initializeUserInterface: myModel

	^ UITheme current
		newTabGroupIn: self for: {
			'Projects' -> (self createProjectsTabFor: myModel). 
			'Users' -> (self createUsersTabFor: myModel)}! !

!XpfAdminTool methodsFor: 'initialization' stamp: 'cs 6/3/2009 15:52'!
initializeWith: aRepository 

	| myModel |
	myModel := XpfAdminToolModel newWithRepository: aRepository.
	self
		buttons: {  (self createQuitButton)};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Project Management'.
	aRepository isRestProxy ifTrue: [aRepository startUpdating].! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 09:46'!
projectAddButton
	^ projectAddButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 09:46'!
projectAddButton: anObject
	projectAddButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectAddDeveloperButton
	^ projectAddDeveloperButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectAddDeveloperButton: anObject
	projectAddDeveloperButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:36'!
projectDeleteButton
	^ projectDeleteButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:36'!
projectDeleteButton: anObject
	projectDeleteButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:25'!
projectDeleteDeveloperButton
	
	^ projectDeleteDeveloperButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'cs 3/9/2009 15:24'!
projectDeleteDeveloperButton: anObject

	projectDeleteDeveloperButton := anObject.! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectDeveloperList
	^ projectDeveloperList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectDeveloperList: anObject
	projectDeveloperList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:00'!
projectList

	^ projectList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'topa 3/4/2009 00:00'!
projectList: anObject

	projectList := anObject.! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:05'!
projectTitleEntry
	^ projectTitleEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:05'!
projectTitleEntry: anObject
	projectTitleEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectUserDropList
	^ projectUserDropList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 15:01'!
projectUserDropList: anObject
	projectUserDropList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveProjectButton
	^ saveProjectButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveProjectButton: anObject
	saveProjectButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveUserButton
	^ saveUserButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:31'!
saveUserButton: anObject
	saveUserButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:02'!
userAddButton
	^ userAddButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 11:02'!
userAddButton: anObject
	userAddButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 13:48'!
userDeleteButton
	^ userDeleteButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/5/2009 13:48'!
userDeleteButton: anObject
	userDeleteButton := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:57'!
userList
	^ userList! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 12:57'!
userList: anObject
	userList := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:44'!
userLoginEntry
	^ userLoginEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:44'!
userLoginEntry: anObject
	userLoginEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:30'!
userNameEntry
	^ userNameEntry! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:30'!
userNameEntry: anObject
	userNameEntry := anObject! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 13:32'!
userPasswordButton
	^ userPasswordButton! !

!XpfAdminTool methodsFor: 'accessing' stamp: 'mt 3/6/2009 13:32'!
userPasswordButton: anObject
	userPasswordButton := anObject! !

XpfDialog subclass: #XpfChangePasswordDialog
	instanceVariableNames: 'okButton cancelButton oldPasswordEntry newPasswordEntry newPasswordRepeatEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 12:03'!
cancelButton

	cancelButton ifNil: [
		cancelButton := UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Cancel'
		help: 'Abandons your new password and closes the window'].
	^ cancelButton! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:56'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 16:12'!
createNewPasswordEntryFor: anXpfChangePasswordModel

	self newPasswordEntry: ((UITheme current 
		newTextEntryIn: self
		for: anXpfChangePasswordModel 
		get: #newPassword
		set: #newPassword:
		class: String
		getEnabled: nil
		help: 'Enter new password')
		minWidth: 50;
		maxLength: 100).
	self newPasswordEntry textMorph font: (StrikeFont passwordFontSize: 12).
	^ self newPasswordEntry! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 16:12'!
createNewPasswordRepeatEntryFor: anXpfChangePasswordModel

	self newPasswordRepeatEntry: ((UITheme current 
		newTextEntryIn: self
		for: anXpfChangePasswordModel 
		get: #newPasswordRepeat
		set: #newPasswordRepeat:
		class: String
		getEnabled: nil
		help: 'Repeat new password')
		minWidth: 50;
		maxLength: 100).
	self newPasswordRepeatEntry textMorph font: (StrikeFont passwordFontSize: 12).
	^ self newPasswordRepeatEntry! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 14:57'!
initialize

	| myModel |
	super initialize.
	myModel := XpfChangePasswordModel new.
	self
		buttons: {self okButton. self cancelButton};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Change Password'.! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 5/4/2009 12:57'!
initializeUserInterface: anXpfChangePasswordModel

	^ self createCol: {
		self newLabel: 'Please DO NOT use an existing password.'.
		self newLabel: 'Your credentials will be transmitted in plain text.'.
		self createRow: {
			self createLabel: 'New:'.
			self createNewPasswordEntryFor: anXpfChangePasswordModel}.
		self createRow: {
			self createLabel: 'Confirm:'.
			self createNewPasswordRepeatEntryFor: anXpfChangePasswordModel}}! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:56'!
newPasswordEntry

	^ newPasswordEntry! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:56'!
newPasswordEntry: anObject

	newPasswordEntry := anObject.! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:39'!
newPasswordRepeatEntry

	^ newPasswordRepeatEntry! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:39'!
newPasswordRepeatEntry: anObject

	newPasswordRepeatEntry := anObject.! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 14:47'!
ok

	self newPasswordEntry accept.
	self newPasswordRepeatEntry accept.
	self model accept.
	super ok.! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 12:02'!
okButton

	okButton ifNil: [
		okButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Ok'
			help: 'Saves your new password'.
		okButton isDefault: true].
	^ okButton! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:57'!
okButton: anObject

	okButton := anObject.! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:57'!
oldPasswordEntry: anObject

	oldPasswordEntry := anObject.! !

XpfDialog subclass: #XpfDeveloperChooser
	instanceVariableNames: 'okButton cancelButton developerDropList result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfDeveloperChooser class methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 18:09'!
for: aXpfTask

	^self new model: aXpfTask! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
cancelButton

	cancelButton ifNil: [
		cancelButton := UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Cancel'
		help: 'Close window'].
	^ cancelButton! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfDeveloperChooser methodsFor: 'user interface helper' stamp: 'SR 4/12/2009 17:36'!
createDeveloperDropList: myModel

	self developerDropList: (UITheme current 
		newDropListIn: self
		for: myModel projectsModel
		list: #list
		getSelected: #selectionIndex
		setSelected: #selectionIndex:
		getEnabled: nil
		useIndex: true
		help: 'Enter project id').
	self developerDropList minWidth: 200.
	^ self projectDropList! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:02'!
developerDropList

	developerDropList ifNil: [
		self developerDropList: (UITheme current 
			newDropListIn: self
			for: XpfDeveloperChooserModel new
			list: #list
			getSelected: #selectionIndex
			setSelected: #selectionIndex:
			getEnabled: nil
			useIndex: true
			help: 'Enter developer').
		self developerDropList minWidth: 200].
	^ developerDropList! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:38'!
developerDropList: anObject

	developerDropList := anObject.! !

!XpfDeveloperChooser methodsFor: 'initialization' stamp: 'SR 4/12/2009 17:53'!
initialize

	| |
	super initialize.
	self
		buttons: {self okButton. self cancelButton};
		contentMorph: self initializeUserInterface;
		addGrips;
		title: 'Specify Co-Developer'.! !

!XpfDeveloperChooser methodsFor: 'initialization' stamp: 'SR 4/12/2009 17:40'!
initializeUserInterface

	^ self createCol: {
		self createRow: {
			self createLabel: 'Developer:'.	self developerDropList}}! !

!XpfDeveloperChooser methodsFor: 'actions' stamp: 'topa 4/23/2009 16:59'!
model: anXpfTask

	super model: anXpfTask.
	self developerDropList model developerList: 
		(anXpfTask userStory iteration project developers reject: [:d | d = anXpfTask responsibleDeveloper]).! !

!XpfDeveloperChooser methodsFor: 'actions' stamp: 'SR 4/12/2009 18:11'!
ok

	self result: self developerDropList model developer.
	
	^ super ok! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:38'!
okButton

	okButton ifNil: [
		okButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Ok'
			help: 'Confirm Developer'.
		okButton isDefault: true].
	^ okButton! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
okButton: anObject

	okButton := anObject.! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
result

	^ result! !

!XpfDeveloperChooser methodsFor: 'accessing' stamp: 'SR 4/12/2009 17:35'!
result: anObject

	result := anObject.! !

!XpfDialog class methodsFor: 'user interface' stamp: 'cs 5/27/2009 11:15'!
open

	[^ self new
		initializeWith: XpfLoginProcessor new repository;
		openInWorld]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:25'!
createCol: someElements

	^ UITheme current newColumnIn: self for: someElements! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:25'!
createHFiller

	^ (UITheme current newToolSpacerIn: self) hResizing: #spaceFill! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createHSeparator

	^ UITheme current newSeparatorIn: self! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createLabel: aString

	^ UITheme current
		newLabelIn: self
		label: aString! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createRow: someElements

	^ UITheme current newRowIn: self for: someElements! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createVFiller

	^ (UITheme current newToolSpacerIn: self) vResizing: #spaceFill! !

!XpfDialog methodsFor: 'user interface helper' stamp: 'mt 3/6/2009 10:26'!
createVSeparator

	^ (UITheme current newSeparatorIn: self) hResizing: #rigid; vResizing: #spaceFill! !

!XpfDialog methodsFor: 'initialization' stamp: 'topa 3/6/2009 14:53'!
initializeUserInterface: aModel

	self subclassResponsibility.! !

XpfDialog subclass: #XpfLogin
	instanceVariableNames: 'loginEntry passwordEntry connectButton cancelButton result serverEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfLogin methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:27'!
cancelButton

	cancelButton ifNil: [
		cancelButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #cancel
			arguments: nil
			getEnabled: nil
			label: 'Cancel'
			help: 'Close login window'].
	^ cancelButton! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:50'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfLogin methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:33'!
connectButton

	connectButton ifNil: [
		connectButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Connect'
			help: 'Try to connect to server'.
		connectButton isDefault: true].
	^ connectButton! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:50'!
connectButton: anObject

	connectButton := anObject.! !

!XpfLogin methodsFor: 'user interface' stamp: 'topa 3/6/2009 14:51'!
createLoginEntryFor: myModel

	self loginEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #login
		set: #login:
		class: String
		getEnabled: nil
		help: 'Enter login') maxLength: 100).
	^ self loginEntry! !

!XpfLogin methodsFor: 'user interface' stamp: 'topa 3/6/2009 14:51'!
createPasswordEntryFor: myModel

	self passwordEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #password
		set: #password:
		class: String
		getEnabled: nil
		help: 'Enter password') maxLength: 100).
	self passwordEntry textMorph font: (StrikeFont passwordFontSize: 12).
	^ self passwordEntry! !

!XpfLogin methodsFor: 'user interface' stamp: 'topa 5/4/2009 09:55'!
createServerEntryFor: myModel

	self serverEntry: ((UITheme current 
		newTextEntryIn: self
		for: myModel
		get: #server
		set: #server:
		class: String
		getEnabled: nil
		help: 'Enter the hostname of the server.') maxLength: 100).
	^ self serverEntry minWidth: 250! !

!XpfLogin methodsFor: 'initialization' stamp: 'SR 3/19/2009 19:29'!
initialize

	| myModel |
	super initialize.
	
	myModel := XpfLoginModel new.
	self
		buttons: {self connectButton. self cancelButton};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Login'.! !

!XpfLogin methodsFor: 'initialization' stamp: 'topa 4/3/2009 16:38'!
initializeUserInterface: myModel

	^ self createCol: {
		self createRow: {
			self createLabel: 'Server:'.
			self createServerEntryFor: myModel.}.
		self createHSeparator.
		self createRow: {
			self createLabel: 'Login:'.
			self createLoginEntryFor: myModel}.
		self createRow: {
			self createLabel: 'Password:'.
			self createPasswordEntryFor: myModel}}! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:51'!
loginEntry

	^ loginEntry! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:51'!
loginEntry: anObject

	loginEntry := anObject! !

!XpfLogin methodsFor: 'initialization' stamp: 'topa 4/3/2009 16:38'!
ok

	self serverEntry accept.
	self loginEntry accept.
	self passwordEntry accept.
			
	self result: self model connectString.
	^ super ok! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
passwordEntry

	^ passwordEntry! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
passwordEntry: anObject

	passwordEntry := anObject.! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
result

	^ result! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 3/6/2009 14:52'!
result: anObject

	result := anObject.! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:36'!
serverEntry

	^ serverEntry! !

!XpfLogin methodsFor: 'accessing' stamp: 'topa 4/3/2009 16:36'!
serverEntry: anObject

	serverEntry := anObject.! !

XpfDialog subclass: #XpfProjectChooser
	instanceVariableNames: 'okButton cancelButton changePasswordButton projectDropList result passwordChangeDialog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfProjectChooser methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:32'!
cancelButton

	cancelButton ifNil: [
		cancelButton := UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Cancel'
		help: 'Close window'].
	^ cancelButton! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'topa 3/6/2009 17:42'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:11'!
changePasswordButton

	changePasswordButton ifNil: [
		changePasswordButton := UITheme current 
			newButtonIn: self
			for: [self openModal: self passwordChangeDialog]
			getState: nil
			action: #value
			arguments: nil
			getEnabled: nil
			label: 'Change Password'
			help: 'Change your password'].
	^ changePasswordButton! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:07'!
changePasswordButton: anObject

	changePasswordButton := anObject.! !

!XpfProjectChooser methodsFor: 'user interface helper' stamp: 'SR 3/10/2009 14:01'!
createProjectDropList: myModel

	self projectDropList: (UITheme current 
		newDropListIn: self
		for: myModel projectsModel
		list: #list
		getSelected: #selectionIndex
		setSelected: #selectionIndex:
		getEnabled: nil
		useIndex: true
		help: 'Enter project id').
	self projectDropList minWidth: 200.
	^ self projectDropList! !

!XpfProjectChooser methodsFor: 'initialization' stamp: 'mt 3/31/2009 13:12'!
initialize

	| myModel |
	super initialize.
	
	myModel := XpfProjectChooserModel new.
	
	self
		buttons: {self okButton. self cancelButton. self changePasswordButton};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Specify Project'.! !

!XpfProjectChooser methodsFor: 'initialization' stamp: 'SR 3/10/2009 13:54'!
initializeUserInterface: myModel

	^ self createCol: {
		self createRow: {
			self createLabel: 'Project:'.	self createProjectDropList: myModel}}! !

!XpfProjectChooser methodsFor: 'actions' stamp: 'SR 3/10/2009 14:00'!
ok

	self result: self model project.
	
	^ super ok! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'SR 3/19/2009 19:33'!
okButton

	okButton ifNil: [
		okButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Ok'
			help: 'Confirm Project Id'.
		okButton isDefault: true].
	^ okButton! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'topa 3/6/2009 17:42'!
okButton: anObject

	okButton := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:06'!
passwordChangeDialog

	^ passwordChangeDialog! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:06'!
passwordChangeDialog: anObject

	passwordChangeDialog := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'SR 3/10/2009 13:49'!
projectDropList

	^ projectDropList! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'SR 3/10/2009 13:49'!
projectDropList: anObject

	projectDropList := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'topa 3/6/2009 17:46'!
result

	^ result! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'topa 3/6/2009 17:46'!
result: anObject

	result := anObject.! !

XpfDialog subclass: #XpfTaskDeveloperDialog
	instanceVariableNames: 'okButton developerList responsibleDeveloper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:44'!
developerList

	developerList ifNil: [
		self developerList: (self theme 
				newListIn: self
				for: XpfDeveloperChooserModel new
				list: #list
				selected: nil
				changeSelected: nil
				getEnabled: nil
				help: 'Participating developer').
		].
	^ developerList! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:44'!
developerList: anObject

	developerList := anObject! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'cs 4/23/2009 15:09'!
initialize

	super initialize.
	self
		buttons: {self okButton};
		contentMorph: self initializeUserInterface;
		addGrips;
		title: 'Developers of this Task'.! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:26'!
initializeUserInterface

	^ self createCol: {
		self createRow: {self createLabel: 'Responsible Developer:'. self responsibleDeveloper}.
		self createLabel: 'Developers:'.
		self developerList}! !

!XpfTaskDeveloperDialog methodsFor: 'as yet unclassified' stamp: 'cs 4/23/2009 15:07'!
model: aXpfTask

	super model: aXpfTask.
	self responsibleDeveloper contents: (aXpfTask responsibleDeveloper isNil
		ifTrue: ['(not set)'] 
		ifFalse: [self model responsibleDeveloper userName]).
	self developerList model developerList: aXpfTask developers.! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:00'!
okButton

	okButton ifNil: [
		okButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Ok'
			help: 'Confirm Developer'.
		okButton isDefault: true].
	^ okButton! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 19:00'!
okButton: anObject

	okButton := anObject! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:45'!
responsibleDeveloper

	responsibleDeveloper ifNil: [
		self responsibleDeveloper: (self createLabel: '(not set)')].
	^ responsibleDeveloper! !

!XpfTaskDeveloperDialog methodsFor: 'accessing' stamp: 'SR 4/12/2009 18:45'!
responsibleDeveloper: anObject

	responsibleDeveloper := anObject! !

XpfDialog subclass: #XpfUserPasswordForHand
	instanceVariableNames: 'loginEntry passwordEntry saveButton cancelButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfUserPasswordForHand class methodsFor: 'as yet unclassified' stamp: 'SR 7/1/2009 11:58'!
open

	self new openInWorld! !

!XpfUserPasswordForHand methodsFor: 'accessing' stamp: 'SR 7/1/2009 11:44'!
cancelButton

	cancelButton ifNil: [
		cancelButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #cancel
			arguments: nil
			getEnabled: nil
			label: 'Cancel'
			help: 'Close login window'].
	^ cancelButton! !

!XpfUserPasswordForHand methodsFor: 'accessing' stamp: 'SR 7/1/2009 11:44'!
cancelButton: anObject

	cancelButton := anObject.! !

!XpfUserPasswordForHand methodsFor: 'user interface' stamp: 'SR 7/1/2009 12:41'!
createLoginEntry

	self loginEntry: ((UITheme current 
		newTextEntryIn: self
		for: self model
		get: #login
		set: #login:
		class: String
		getEnabled: nil
		help: 'Enter login') maxLength: 100).
	^ self loginEntry minWidth: 150! !

!XpfUserPasswordForHand methodsFor: 'user interface' stamp: 'SR 7/1/2009 12:41'!
createPasswordEntry

	self passwordEntry: ((UITheme current 
		newTextEntryIn: self
		for: self model
		get: #password
		set: #password:
		class: String
		getEnabled: nil
		help: 'Enter password') maxLength: 100).
	self passwordEntry textMorph font: (StrikeFont passwordFontSize: 12).
	^ self passwordEntry! !

!XpfUserPasswordForHand methodsFor: 'initialization' stamp: 'SR 7/1/2009 13:05'!
initialize

	super initialize.
	
	self
		buttons: {self saveButton. self cancelButton};
		contentMorph: (self initializeUserInterface);
		model: XpfLoginModelForHand new;
		addGrips;
		title: 'Login options';
		makeExclusive.
	
	self model loadDataFromHand: self activeHand.! !

!XpfUserPasswordForHand methodsFor: 'initialization' stamp: 'SR 7/1/2009 12:41'!
initializeUserInterface

	^ self createCol: {
		self createRow: {
			self createLabel: 'Login:'.
			self createLoginEntry}.
		self createRow: {
			self createLabel: 'Password:'.
			self createPasswordEntry}}! !

!XpfUserPasswordForHand methodsFor: 'accessing' stamp: 'SR 7/1/2009 11:44'!
loginEntry

	^ loginEntry! !

!XpfUserPasswordForHand methodsFor: 'accessing' stamp: 'SR 7/1/2009 11:44'!
loginEntry: anObject

	loginEntry := anObject! !

!XpfUserPasswordForHand methodsFor: 'as yet unclassified' stamp: 'SR 7/1/2009 12:40'!
model: aModel

	super model: aModel.
	self loginEntry model: self model.
	self passwordEntry model: self model.! !

!XpfUserPasswordForHand methodsFor: 'initialization' stamp: 'SR 7/1/2009 12:51'!
ok

	self loginEntry accept.
	self passwordEntry accept.
	self model storeDataToHand: self activeHand.
	^ super ok! !

!XpfUserPasswordForHand methodsFor: 'accessing' stamp: 'SR 7/1/2009 11:44'!
passwordEntry

	^ passwordEntry! !

!XpfUserPasswordForHand methodsFor: 'accessing' stamp: 'SR 7/1/2009 11:44'!
passwordEntry: anObject

	passwordEntry := anObject.! !

!XpfUserPasswordForHand methodsFor: 'accessing' stamp: 'SR 7/1/2009 11:48'!
saveButton

	saveButton ifNil: [
		saveButton := UITheme current 
			newButtonIn: self
			for: self
			getState: nil
			action: #ok
			arguments: nil
			getEnabled: nil
			label: 'Save'
			help: 'Save settings to hand'.
		saveButton isDefault: true].
	^ saveButton! !

!XpfUserPasswordForHand methodsFor: 'accessing' stamp: 'SR 7/1/2009 11:48'!
saveButton: anObject

	saveButton := anObject.! !

ProgressBarMorph subclass: #XpfProgressBarMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfProgressBarMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 22:49'!
drawOn: aCanvas
	| width height inner origin progressRectangle |
	aCanvas fillRectangle: self bounds fillStyle: self fillStyle borderStyle: self borderStyle.
	inner := self innerBounds.
	(inner height > inner width) 
		ifTrue: [
			height := (inner height * lastValue) truncated min: inner height.
			origin := inner origin x @ (inner bottom - height).
			progressRectangle := origin extent: (inner width @ height)]
		ifFalse: [
			width := (inner width * lastValue) truncated min: inner width.
			progressRectangle := inner origin extent: width @ inner height].
	
	aCanvas fillRectangle: progressRectangle color: progressColor.! !

!TaskbarMorph methodsFor: '*xpf-client-override' stamp: 'mt 4/20/2009 20:41'!
updateTaskButtons
	"Make buttons for the ordered tasks."
	
	|button oldButtons xpfExtension|
	(self submorphs size > 0 and: [self submorphs first isKindOf: PanelMorph])
		ifTrue: [
			xpfExtension := self submorphs first.
			oldButtons := self submorphs allButFirst]
		ifFalse: [oldButtons := self submorphs copy].

	self removeAllMorphs.
	WorldState addDeferredUIMessage: [oldButtons do: [:b | b model: nil] fixTemps]. "release dependency after event handling"
	self orderedTasks do: [:t |
		button := t taskbarButtonFor: self.
		button ifNotNil: [self addMorphBack: button]].
	
	xpfExtension ifNotNil: [self addMorphFront: xpfExtension].! !

!Collection methodsFor: '*xpf-client-projecttalk' stamp: 'mt 4/22/2009 13:47'!
inject: thisValue into: binaryBlock displayingProgress: aString
	"Like inject:into: but displaying the progress of the operation."
	
	| nextValue |
	nextValue := thisValue.
	self do: [:each | nextValue := binaryBlock value: nextValue value: each] displayingProgress: aString.
	^nextValue! !

RestPrefetchProxyRepository subclass: #XpfProxyRepository
	instanceVariableNames: 'updateProcess updateCounter currentUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Proxies'!

!XpfProxyRepository class methodsFor: 'constants' stamp: 'mig 4/3/2009 15:32'!
proxyCollectionClass

	^ XpfProxyCollection! !

!XpfProxyRepository class methodsFor: 'constants' stamp: 'mig 4/3/2009 15:26'!
proxyObjectClass

	^ XpfProxyObject! !

!XpfProxyRepository class methodsFor: 'constants' stamp: 'mig 4/3/2009 10:56'!
reloadInterval
	"reload interval in seconds"
	
	^ 10! !

!XpfProxyRepository methodsFor: 'add-remove' stamp: 'cs 6/3/2009 15:33'!
addProject: aProject 

	^ self projects addNew: aProject! !

!XpfProxyRepository methodsFor: 'add-remove' stamp: 'cs 6/3/2009 15:51'!
addUser: aUser 

	^ self users addNew: aUser! !

!XpfProxyRepository methodsFor: 'updating' stamp: 'mig 4/1/2009 16:51'!
changesUrl
	
	^ (self url asString, '/changes') asUrl! !

!XpfProxyRepository methodsFor: 'accessing' stamp: 'cs 5/26/2009 16:40'!
currentUser

	^ currentUser! !

!XpfProxyRepository methodsFor: 'accessing' stamp: 'mt 4/27/2009 14:37'!
currentUser: anXpfUser
	
	currentUser := anXpfUser.! !

!XpfProxyRepository methodsFor: 'initialization' stamp: 'cs 5/28/2009 12:45'!
initialize

	super initialize.
	self updateCounter: 0.! !

!XpfProxyRepository methodsFor: 'accessing' stamp: 'cs 6/3/2009 15:32'!
projects

	^ self getCollection: '/projects/'! !

!XpfProxyRepository methodsFor: 'private' stamp: 'mig 4/3/2009 10:55'!
pvtUpdateProcess

	^ updateProcess! !

!XpfProxyRepository methodsFor: 'private' stamp: 'mig 4/3/2009 10:54'!
pvtUpdateProcess: anObject

	updateProcess := anObject.! !

!XpfProxyRepository methodsFor: 'updating' stamp: 'mt 5/7/2009 10:51'!
reload
	"Sends the URIs of all loaded proxies to the server and retrieves the updates"

	| response |
	response := RestSocket postDocumentFromUrl: self changesUrl request: '' content: 
		(Json render: (Dictionary newFrom:
			((self cache associations
				reject: [:assoc | assoc value revision isNil])
				select: [:assoc | assoc value needsUpdate]
				thenCollect: [:assoc | assoc key -> assoc value revision]))).
	response isOk
		ifTrue: [
			(Json readFrom: (response content readStream))
				do: [:uri |
					(self cache includesKey: uri) "Check this because the cache will be modified during the iteration."
						ifTrue: [(self cache at: uri) reloadNeeded]]]
		ifFalse: [self inform: response content].! !

!XpfProxyRepository methodsFor: 'initialization' stamp: 'cs 5/28/2009 12:46'!
startUpdating
	
	self pvtUpdateProcess ifNil: [self pvtUpdateProcess: self updater fork].
	self updateCounter: self updateCounter + 1.! !

!XpfProxyRepository methodsFor: 'updating' stamp: 'mt 6/2/2009 14:44'!
stopUpdating

	self updateCounter: self updateCounter - 1.
	(self updateCounter <= 0 & self pvtUpdateProcess notNil) ifTrue: [
		self pvtUpdateProcess terminate.
		self pvtUpdateProcess: nil].! !

!XpfProxyRepository methodsFor: 'accessing' stamp: 'mt 6/2/2009 14:43'!
updateCounter

	^ updateCounter
		ifNil: [updateCounter := 0]! !

!XpfProxyRepository methodsFor: 'accessing' stamp: 'cs 5/28/2009 12:45'!
updateCounter: anObject

	updateCounter := anObject.! !

!XpfProxyRepository methodsFor: 'updating' stamp: 'cs 6/12/2009 16:02'!
updater

	^ [[self reload. (Delay forSeconds: self class reloadInterval) wait]
			repeat]! !

!XpfProxyRepository methodsFor: 'accessing' stamp: 'cs 6/3/2009 15:32'!
users

	^ self getCollection: '/users/'! !

ScrollPane subclass: #XpfScrollPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfScrollPane methodsFor: 'as yet unclassified' stamp: 'SR 4/9/2009 13:57'!
extent: newExtent

	super extent: newExtent.
	self scroller submorphsDo: [:each | each adjustLayoutBounds].
	^self.! !

!XpfScrollPane methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 12:05'!
toggleShow

	self
		visible: self visible not;
		disableTableLayout: self visible not! !

PasteUpMorph subclass: #XpfTaskListMorph
	instanceVariableNames: 'updateIsLocked scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfTaskListMorph methodsFor: 'updating' stamp: 'mt 4/28/2009 13:21'!
acceptDroppingMorph: aMorph event: evt 

	self doWithoutUpdates: [
		(aMorph isTaskMorph and: [self model noneSatisfy: [:a | a id = aMorph model id]])
				ifTrue: [self model add: aMorph model].
		super acceptDroppingMorph: aMorph event: evt].! !

!XpfTaskListMorph methodsFor: 'testing' stamp: 'mfp 3/19/2009 14:41'!
acceptsTasks

	^ true! !

!XpfTaskListMorph methodsFor: 'initialization' stamp: 'mt 5/14/2009 17:34'!
createUserInterface

	submorphs ifNotNilDo: [:s |
		s do: [:m | m
			removeDependent: self;
			delete]].
	
	self model do: [:task | |taskMorph|
		taskMorph := (XpfTaskMorph forTask: task) width: self width - 2.
		taskMorph addDependent: self.
		self addMorphBack: taskMorph].

	2 timesRepeat: [self scrollPane updateScrollbars]. "yep!!"
	
	submorphs ifNotEmpty: [
		self scrollPane scrollToShow: submorphs last bounds].! !

!XpfTaskListMorph methodsFor: 'as yet unclassified' stamp: 'topa 4/22/2009 13:42'!
doWithoutUpdates: aBlock

	self updateIsLocked: true.
	^ aBlock ensure: [self updateIsLocked: false]
	! !

!XpfTaskListMorph methodsFor: 'initialization' stamp: 'mt 5/14/2009 17:08'!
initialize

	super initialize.
	self
		changeTableLayout;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		color: Color transparent;
		borderWidth: 0;
		listDirection: #topToBottom;
		layoutInset: 2;
		cellInset: 2;
		extent: XpfTaskTitleContent defaultExtent + XpfTaskActionsContent defaultExtent * (1@2).! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'SR 4/18/2009 11:12'!
model

	^ model! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 17:29'!
model: anXpfTaskCollection

	self model ifNotNil: [
		self model removeDependent: self].
	model := anXpfTaskCollection.
	self model ifNotNil: [
		self createUserInterface.
		self model addDependent: self]! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 16:29'!
scrollPane

	^ scrollPane ifNil: [scrollPane := GeneralScrollPane new]! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'mt 5/14/2009 16:29'!
scrollPane: anObject

	scrollPane := anObject.! !

!XpfTaskListMorph methodsFor: 'updating' stamp: 'mt 5/14/2009 17:31'!
update: anObject

	self updateIsLocked ifFalse: [
		(anObject = #tasksLoaded) | (anObject = #tasksAdded) ifTrue: [
			self createUserInterface]].
	
	anObject = #zoomIn | (anObject = #zoomOut) ifTrue: [
		2 timesRepeat: [self scrollPane updateScrollbars]. "yep!!"].
	
	super update: anObject.! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'topa 4/22/2009 13:41'!
updateIsLocked

	^ updateIsLocked ifNil: [self updateIsLocked: false. updateIsLocked]! !

!XpfTaskListMorph methodsFor: 'accessing' stamp: 'topa 4/22/2009 13:41'!
updateIsLocked: anObject

	updateIsLocked := anObject.! !

!XpfTaskListMorph methodsFor: 'layout' stamp: 'mt 5/14/2009 16:30'!
withScrollBars

	self scrollPane
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderWidth: 0;
		fillStyle: (Color r: 0.8 g: 0.8 b: 0.8 alpha: 0.35);
		scrollTarget: self.
	^ self scrollPane! !

PasteUpMorph subclass: #XpfUserStoryPoolMorph
	instanceVariableNames: 'userStoryAddMorph deleteMorph titleMorph scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfUserStoryPoolMorph class methodsFor: 'contants' stamp: 'mig 4/17/2009 18:10'!
defaultGridSize

	^ 20@20! !

!XpfUserStoryPoolMorph class methodsFor: 'contants' stamp: 'SR 4/12/2009 21:52'!
defaultMaxTime

	^ 50! !

!XpfUserStoryPoolMorph class methodsFor: 'contants' stamp: 'mt 3/31/2009 15:39'!
for: anXpfIteration

	^ self new model: anXpfIteration! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 4/29/2009 17:51'!
acceptDroppingMorph: aUserStoryMorph event: evt 

	aUserStoryMorph hasNewUserStory 
		ifTrue: [ self acceptNewUserStory: aUserStoryMorph ]
		ifFalse: [
			(self acceptExistentUserStory: aUserStoryMorph)
				ifTrue: [super acceptDroppingMorph: aUserStoryMorph event: evt]]! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 4/29/2009 17:52'!
acceptExistentUserStory: aUserStoryMorph 

	(self isDuplicateMorph: aUserStoryMorph)
		ifTrue: [ aUserStoryMorph delete. ^ self ].
	aUserStoryMorph position: (self gridPoint: aUserStoryMorph position).
	self positionUserStory: aUserStoryMorph model droppedMorph: aUserStoryMorph.
	(self includesUserStory: aUserStoryMorph model)
		ifTrue: [ self moveToNewIteration: aUserStoryMorph. ^ false]
		ifFalse: [^ true]! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 4/29/2009 17:23'!
acceptNewUserStory: anUserStoryMorph 

	| userStory |
	userStory := self model addNewUserStory: XpfUserStoryAddMorph emptyUserStory.
	self positionUserStory: userStory droppedMorph: anUserStoryMorph.
	anUserStoryMorph delete.! !

!XpfUserStoryPoolMorph methodsFor: 'testing' stamp: 'cs 3/10/2009 16:14'!
acceptsUserStories

	^ true! !

!XpfUserStoryPoolMorph methodsFor: 'events-processing' stamp: 'bs 7/10/2009 09:50'!
addNewUserStoryToIteration

	| userStoryData |
	userStoryData := Dictionary newFrom: 
		{'title' -> 'Please enter content for new user story'}.
	^ self model addNewUserStory: userStoryData! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'mt 4/28/2009 11:14'!
addUserStorySubmorph: userStory

	^ self addMorph: (XpfUserStoryMorph forUserStory: userStory)! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:08'!
adjustLayoutBounds
	"Adjust the receivers bounds depending on the resizing strategy imposed"
	| hFit vFit box myExtent extent |
	
	hFit := self hResizing.
	vFit := self vResizing.
	
	(hFit = #rigid and: [vFit = #rigid]) ifTrue: [^self].
	
	box := self layoutBounds.
	myExtent := box extent.
	extent := self submorphBounds corner - box origin.
	
	hFit = #growWrap ifTrue: [
		(extent x > owner owner bounds width)
			ifFalse: [hFit := #spaceFill]
			ifTrue: [hFit := #shrinkWrap]].
	
	vFit = #growWrap ifTrue: [
		(extent y > owner owner bounds height)
			ifFalse: [vFit := #spaceFill]
			ifTrue: [vFit := #shrinkWrap]].
		
	hFit == #shrinkWrap ifTrue:[myExtent := extent x @ myExtent y].
	hFit == #spaceFill ifTrue: [myExtent := owner owner bounds width @ myExtent y].
	
	vFit == #shrinkWrap ifTrue:[myExtent := myExtent x @ extent y].
	vFit == #spaceFill ifTrue: [myExtent := myExtent x @ owner owner bounds height].
	
	"Make sure we don't get smaller than minWidth/minHeight"
	myExtent x < self minWidth ifTrue:[
		myExtent := (myExtent x max: 
			(self minWidth - self bounds width + self layoutBounds width)) @ myExtent y].
	myExtent y < self minHeight ifTrue:[
		myExtent := myExtent x @ (myExtent y max:
			(self minHeight - self bounds height + self layoutBounds height))].
	self layoutBounds: (box origin extent: myExtent).! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:55'!
adjustLeft: aMorph

	^ 0 max: ((aMorph left - self left) * 10000) asInteger! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/9/2009 13:55'!
adjustTop: aMorph

	^ 0 max: ((aMorph top - self top) * 10000) asInteger! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'mt 4/28/2009 11:15'!
buildUserStorySubmorphs

	self model ifNotNil: [
		self model userStories do: [ :userStory| 
			self addUserStorySubmorph: userStory]].! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'topa 3/19/2009 14:41'!
deleteMorph

	^ deleteMorph! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mfp 3/19/2009 18:07'!
deleteMorph: aMorph

	deleteMorph := aMorph.! !

!XpfUserStoryPoolMorph methodsFor: 'events-processing' stamp: 'bs 7/10/2009 09:51'!
doubleClick: anEvent

	| userStory |
	userStory := self addNewUserStoryToIteration.
	self positionUserStory: userStory to: anEvent cursorPoint.! !

!XpfUserStoryPoolMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 21:59'!
generateProgress: value with: aCharacter

	value < 0 ifTrue: [''].
	^ (String new: ((10 * value) / self class defaultMaxTime) ceiling) collect: [:e | aCharacter]! !

!XpfUserStoryPoolMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 22:00'!
generateProgress: value with: aCharacter negWith: aNegCharacter

	^ value < 0
		ifTrue: [(String new: ((10 * (value negated)) / self class defaultMaxTime) ceiling) collect: [:e | aNegCharacter]]
		ifFalse: [(String new: ((10 * value) / self class defaultMaxTime) ceiling) collect: [:e | aCharacter]].! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 4/29/2009 17:36'!
includesUserStory: userStory

	^ self model userStories noneSatisfy: [ :myStory | myStory id = userStory id ]! !

!XpfUserStoryPoolMorph methodsFor: 'initialization' stamp: 'bs 7/8/2009 22:51'!
initialize

	super initialize.

	self
		borderWidth: 0;
		fillStyle: Color veryVeryLightGray;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		enableDragNDrop;
		gridModulus: self class defaultGridSize;
		griddingOnOff;
		addMorph: self titleMorph.
		
	self addMorphBack: (XpfEstimationCircleMorph nUnits: 60 segmentUnitsComputing: [
		(self submorphs select: [:m | m class = XpfUserStoryMorph]) inject: 0 into: [:sum :storyMorph | sum + storyMorph timeEstimated]]).! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 4/29/2009 17:29'!
isDuplicateMorph: aUserStoryMorph

	aUserStoryMorph formerOwner ifNotNilDo: [ :o | 
		(o submorphs anySatisfy: [ :s | s model = aUserStoryMorph model ])
		ifTrue: [ ^ true ]].
	^ false! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 10:51'!
model

	^ model! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 10:50'!
model: aXpfIteration

	self model ifNotNil: [
		self model removeDependent: self.
		self model userStories removeDependent: self].

	model := aXpfIteration.
		
	self model ifNotNil: [
		self
			removeAllMorphsIn: self userStorySubmorphs;
			buildUserStorySubmorphs;
			updateTitle.
		
		self model addDependent: self.
		self model userStories addDependent: self].
! !

!XpfUserStoryPoolMorph methodsFor: 'events-processing' stamp: 'bs 7/9/2009 18:15'!
mouseDown: evt
	
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {nil. #doubleClick:. nil. nil}
		threshold: 5.! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 4/29/2009 17:49'!
moveToNewIteration: aUserStoryMorph 

	self model addUserStory: aUserStoryMorph model.
	aUserStoryMorph delete.! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'mfp 4/29/2009 17:33'!
positionUserStory: userStory droppedMorph: aMorph

	self model deferCommit: 	[
		userStory
			positionX: (self adjustLeft: aMorph);
			positionY: (self adjustTop: aMorph)].! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'bs 7/9/2009 18:43'!
positionUserStory: userStory to: aPoint

	self model deferCommit: 	[
		userStory
			positionX: (aPoint x * 10000);
			positionY: (aPoint y * 10000)].! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'SR 4/10/2009 11:58'!
scrollPane

	^ scrollPane! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'SR 4/10/2009 11:58'!
scrollPane: anObject

	scrollPane := anObject! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mfp 4/29/2009 13:51'!
titleMorph

	titleMorph ifNil: [
		self titleMorph: '' asText asMorph.
		self titleMorph 
			beAllFont: (XpfClient sansFontAt: 18);
			color: Color darkGray;
			lock].
	^ titleMorph! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/3/2009 09:19'!
titleMorph: anObject

	titleMorph := anObject! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'SR 4/10/2009 12:04'!
toggleShow

	self scrollPane isNil
		ifTrue: [self
			visible: self visible not;
			disableTableLayout: self visible not]
		ifFalse: [self scrollPane toggleShow].! !

!XpfUserStoryPoolMorph methodsFor: 'as yet unclassified' stamp: 'mfp 4/29/2009 18:05'!
update: aSymbol

	aSymbol = #title ifTrue: [self updateTitle].
	aSymbol = #timeIdeal ifTrue: [self updateTitle].
	aSymbol = #userStories ifTrue: [self updateTitle].
	aSymbol = #userStoriesLoaded ifTrue: [
		self
			updateTitle;
			updateUserStoryMorphs].
	
	super update: aSymbol.! !

!XpfUserStoryPoolMorph methodsFor: 'as yet unclassified' stamp: 'mfp 4/28/2009 13:30'!
updateTitle

	| iterationTitle idealTime userStoriesTimeActual userStoriesTimeEstimated timeEstimated timeActual |
	iterationTitle := self model title.
	(self model timeIdeal isNil or: [self model isXpfFutureIteration]) ifTrue:
		[self titleMorph contents: ' ', iterationTitle.
		^self].
	idealTime := '(',self model timeIdeal asString,')'.
	
	userStoriesTimeActual := 0.
	userStoriesTimeEstimated := 0.
	self model userStories do: [:us |
		us timeActual ifNotNil: [userStoriesTimeActual := userStoriesTimeActual + us timeActual].
		us timeEstimated ifNotNil: [userStoriesTimeEstimated := userStoriesTimeEstimated + us timeEstimated]].
	
	timeEstimated := (self generateProgress: userStoriesTimeEstimated  with: $+), (self generateProgress: (self model timeIdeal - userStoriesTimeEstimated) with: $- negWith: $#).
	timeActual := (self generateProgress: userStoriesTimeActual  with: $+), (self generateProgress: (self model timeIdeal - userStoriesTimeActual) with: $- negWith: $#).
	
	self titleMorph contents: iterationTitle, idealTime, Character cr asString,timeEstimated, Character cr asString, timeActual.! !

!XpfUserStoryPoolMorph methodsFor: 'as yet unclassified' stamp: 'mig 5/13/2009 16:50'!
updateUserStoryMorphs

	| oldUserStories morphsAtHand |

	morphsAtHand := World hands 
		inject: OrderedCollection new 
		into: [:morphs :hand | 
			morphs, (hand submorphs select: [:m | m isUserStoryMorph and: [m model iteration = self model]])].
	
	oldUserStories := Dictionary newFrom:
		(self userStorySubmorphs, morphsAtHand
			collect: [:morph | morph model -> morph]).
	oldUserStories keys reject: [:story | self model userStories includes: story]
		thenDo: [:story | (oldUserStories at: story) delete].
	self model userStories reject: [:each | oldUserStories keys includes: each]
		thenDo: [:story | self addUserStorySubmorph: story].
! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'topa 3/9/2009 15:34'!
userStoryAddMorph

	^ userStoryAddMorph! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'topa 3/9/2009 15:42'!
userStoryAddMorph: anObject

	userStoryAddMorph := anObject.! !

!XpfUserStoryPoolMorph methodsFor: 'accessing' stamp: 'mt 4/2/2009 15:23'!
userStorySubmorphs

	^ self submorphs select: [:aMorph| aMorph isUserStoryMorph]! !

!XpfUserStoryPoolMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 3/19/2009 17:38'!
wantsDroppedMorph: aMorph event: evt

	^ aMorph isUserStoryMorph! !

!XpfUserStoryPoolMorph methodsFor: 'layout' stamp: 'mfp 4/29/2009 14:34'!
withScrollBars

	self scrollPane ifNil: [
		self scrollPane: XpfScrollPane new.
		(self scrollPane)
			scroller addMorph: self;
			maxCellSize: 1040 @ 1450;
			borderWidth: 0.
		self extent: 960 @ 1400;
			vResizing: #rigid;
			hResizing: #rigid].
	^ self scrollPane! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 4/20/2009 22:14'!
flagBlueContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAIxSURBVDjLpdNdSFNhGAdwKSNy
g6ALC8GLoE8so49VRHVRFFQISlJeREXQBxWSSZDUpNrOTDoxSGvhmokV1TazLeekTBda9rVK
mW5lYq6slgutOI7j1vn3vKc4rCAv3MXDgfPy/73Pc3hOEoCkROq/B6v2GdIWHLnhmK1v7ZtZ
3PIuo9DmOr17iaUkLx1Ud6g2jgqo+JCU4x7Bs5AEe4+EhbYYMsv9iEYGcU+/VEZkYNkew7iJ
nHBrgl4YSeYEJJcIGF8qoKw9Bv8g8GkY8IaBthDgqatCsNGAq4czGbBLBhbv5VWT+EiL2Q9c
fg2YA0DDe+AxBeqDQPvX3+/PdwKmfA0+PDDCuGM6A9JkYP5Byyy1SexgQM5dIJvqpJdCb4DW
z8BDKguhhzxDor1Ig+7afBaG8hFnFDiyp1ZFgxa6JbcR2NoEnCLg2ltqfQBwUzcVhJc1+4c8
/Br0urV/A9OKvJyxQ/qmfQ5so/D2ZoB7CVh7gN4fwP1+wEWjGK/XoKt6C9rOrWeATwHUugEn
3RBjrW9oAI4TdJPCno80RlfsZ27d9+Eslxitcdpk4HbxCgboFEB1JvKk3CfhSjdQTXM7+yRo
rCLUZ8PSposvvMZX0bydtf2Vi9JT4avcjIr9GQxYrQBzC2zmVG2nkGIISyncF2mKLiDOKbQ+
it8JCqy9dGCe3EH8/KMu0j9AqePEyoSAwFNTVkKAHG7i1ykrPCbAfmw5A46OBbjw5y9kz8nx
Z78A90vOcDVd+i0AAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 4/20/2009 22:15'!
flagBlueIcon
	^ Icons
			at: #'flagBlue'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self flagBlueContents readStream) ].! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 4/20/2009 22:15'!
noteContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAGGSURBVDjLxZO/alRBFMZ/c6Mm
omKhBLv4AIJiYekjCFopKSzyCnkGW99BbMTOQhsrBcFKsLCJhRYBNYYsWXNn5s6Z81nMGu+6
26XwFDOHge/PmfkmSOIk1XHCOvWn0ZdXsulPpAFZQbUgG5BlVDOURLWELEJJXLz3JMwTVOP0
tfsLChIEmC2A4OD5g0UHebLLWQl5bAcBJAcC4i9D6FZRiUtGMMOHb9j0PXhGGtruA3hCnpBH
zly+i5d+CUHNgCFPoDIDjcEJeQ8yNCxxYL/2m+U55Yh7mpFE8NhE7GiRwGsi7bzF8meoA8io
6ZC1jfWm7AnVCPLld1DjPna4y/kbm4Djw1emH56h2oN6VFNzIKOOCI6DFCTKj48cvN6m9jtQ
C64yAjcXrjrnoBu/94VbDymTPSZvHs/A6RgsT0gZqC1M/46AJcJKx7mbW8RPL5m+e8HKpeus
XbmNI1AFDHBkmZHzFpO9p3fkJSNLqEQsfgc6uhCQJRgy7qlF2ypXHynMEfy33/gbubc6XKsT
2+MAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 4/20/2009 22:15'!
noteIcon
	^ Icons
			at: #'note'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self noteContents readStream) ].! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 4/20/2009 22:14'!
pageWhiteTextContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAADoSURBVBgZBcExblNBGAbA2cee
gTRBuIKOgiihSZNTcC5LUHAihNJR0kGKCDcYJY6D3/77MdOinTvzAgCw8ysThIvn/VojIyMj
IyPP+bS1sUQIV2s95pBDDvmbP/mdkft83tpYguZq5Jh/OeaYh+yzy8hTHvNlaxNNczm+la9O
Tlar1UdA/+C2A4trRCnD3jS8BB1obq2Gk6GU6QbQAS4BUaYSQAf4bhhKKTFdAzrAOwAxEUAH
+KEM01SY3gM6wBsEAQB0gJ+maZoC3gI6iPYaAIBJsiRmHU0AALOeFC3aK2cWAACUXe7+AwO0
lc9eTHYTAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 4/20/2009 22:16'!
pageWhiteTextIcon
	^ Icons
			at: #'pageWhiteText'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self pageWhiteTextContents readStream) ].! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/15/2009 12:08'!
xpf7LikeFeedback

	^ Icons
		at: #'xpf7LikeFeedback'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpf7LikeFeedbackContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/15/2009 12:07'!
xpf7LikeFeedbackContents

	^ 'R0lGODlhgQAQANUAAAAAAP///+vTLOvRM//qaP/rcv/te//ug//vi//vkf/wlv/xnv/ypf/z
rf/0s+vOSezSSuvTVf/0uv/1w//2zP/41+/OQufBMP/99uvHUOm4M/nWdv/57NyhJ9aXIuuY
Ev///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAACAALAAA
AACBABAAAAb/QJBwSCwaj8ikcslsOp/QqHRKrVqv2KzWCol4IRDLYCA4As5LdFQNYg/PcKva
vQYgN4F8HlOZUChlRHNKdFKFhVNzdlSIeBQSDg0MCwsKCRMcA4KLb4uKcUJwaKBtnqShnJ1u
opugoqmsqp2oQ3iQkpUJCAcHGBetm7SlworEnIepw8rFy6bEs8u0bhAYkZMKuwbaE7/Axt/N
4Mqtx87h58zB46h0FhzW2AcGBfQKGkau5sz75uvCqvli8fv36h87IxYq4EogrwCBhwY6mNFH
EVw6ZEUwZqyIrh+7ZA8oSIrn8CGBAx4EWeQ4cJxGaG0IrpwZbVg7ChMq4JTwUIGEN5TkyJki
1XJVMmRGk35SWq6cQRAPombIoCHSB6BbsmrdmkQDhw9cw4rlqgHs2LNorZhNy7atlCAAOw=='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:37'!
xpfAccept

	^ Icons
		at: #'xpfAccept'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfAcceptContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfAcceptContents

	^ 'R0lGODlhEAAQAMQfAHbDR0twLrPdlpHQaZGYjPn8983muYvSWIPNU3G/RNTtxTZZGn6TbVKC
LJPmV4nkTOz35ajld8LmqV16Rn7VR4DLT4zlUExgPHGLXIvOYKTad4DZSGm4PlJnQv//////
/yH5BAEAAB8ALAAAAAAQABAAAAWE4Cd+Xml6Y0pORMswE6p6mGFIUR41skgbh+ABgag4eL4O
kFisDAwZxwLl6QiGzQHEM3AEqFZmJbNVICxfkjWjgAwUHkECYJmqBQNJYSuf18ECAABafQkJ
D3ZVGhyChoYcHH8+FwcJkJccD2kjHpQPFKAbmh4FMxcNqKhTPSknJiqwsSMhADs='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'topa 4/17/2009 17:32'!
xpfAddIteration

	^ Icons
		at: #'xpfAddIteration'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfAddIterationContents readStream) ].! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'topa 4/17/2009 17:32'!
xpfAddIterationContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0
d2FyZQBBZG9iZSBJbWFnZVJlYWR5ccllPAAAAahJREFUeNqMk79Lw0AUx78X
U/zRioMUUVGci7hUd+Om1LGC2L3+A6VgEXFwEycHuxcEK4LopKCzYIWais6C
WKUKgWpJL5d4lzZNhST64Hgvd+8+933vLsSyLAjbLhaXuRvl45yPRIB/5XvO
0DbJCRhjY1vJZL5SqSSCvMgzTRPOII6CjUIhvZNKHTjfXkYIQa5QWOdh3pmT
ncAwDGLyzYLqZ5Ik2Xndcy6AUggAC1AAvibyPAG0rYAFKBAlUD8FlFIiTjcY
8wfwEkSeN6DZbAGCesDXRZ4fAH+VYLYAuB++sfsBarmA5j8UZO4yOJ46zTbk
7xkOSOPLdB+SAIgrFD3wG+UPFWuLKxP85Dh063cJjgKvEnLlTajag/0ONKYB
up1zCwslF6DrvteovquIKiN2XDNqUJbm4yK+PrlyFWiaJomt/eEw6vU6IpFI
x8fCMTxdPLYaqRBUjsql1r2i1OnBW7XaEwqFMK0o2QEO6fa7C3t43tezRAc+
2SfQ4EcZ1iwvId35mYbm5lZ5EyeZYRz2yPKql6exl6I5+B01+9glZJLGeC9+
BBgAlQAyLU/LNHUAAAAASUVORK5CYII='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 4/24/2009 16:07'!
xpfAddTask

	^ Icons
		at: #'xpfAddTask'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfAddTaskContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 4/24/2009 16:07'!
xpfAddTaskContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAITSURBVDjLpZNNSJRBGMd/s7q5
0ZoWISZSRAgF5VpELFJ0CK9RneokEl1qO3URpFNCXqIO0aFLEF0iiAj6JBB0WYwOoikRJiXU
Yqbsumv7zvu+M/N02BV30YPgc5h5GPh/zMz/USLCVirCFqt+tZGfb8UUFxEJEBMiNkRMgBgf
sT6EGms0YjwINU0Xn6haAmuIHrm0TkEEFFQWQCD3/PJ6B37+N9tFEOeVDxSIOEAhrDGoSAMS
ehtcwRhcMI8pfgLnIxKUdxeA04jTiPPYtucCLixtQGB9wCBOg4QVUDVYI64EYpBgAwdmZals
uUbZwzldIfHAeWUR8289gbMaPTOK8b+DDUAMVheI7W8pKzuNWA/E1byBWg3S4oteibZ0EO86
DzhcMEdx/BkN+3aBlBie1YzMOZY9j6CU489K/tabOxOD9VVMhAuT5D6m2dl9FaUUTkKQEu+/
FZny45w5fYL23R0MT79kbGr0djLV1hyp/u/Gk72E+b/kR+5VwBqxmtdfc3QdSmAjlsTeHqwK
SR7tBri+FmWjUXURdhy/gphmiplX1MUSxFr7WCgsEVVxzh2+AcDNs4842NIJEKvKgSb37j5i
NBJ6BN4XmM1Q+vyUQiFgOpthIpumv+cxQx/6iNU1AGi1mWlMptoG2w80DXR3nqKj9Rgz8+Nk
JtP8+rF8V212nJOptiHgGtAIFIGHYw+y/f8B3ntD1Kp2NbQAAAAASUVORK5CYII='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfCancel

	^ Icons
		at: #'xpfCancel'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCancelContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfCancelContents

	^ 'R0lGODlhEAAQAMQfAOt0dP94eOFjY/a0tP/JyfFfX/yVlf6mppNtbf5qanknJ9dVVeZqat5e
XpiMjGo4OIUvL3pGRthWVuhvb1kaGv39/f1lZdg7O/7Y2F8/P+13d4tcXNRTU2dCQv//////
/yH5BAEAAB8ALAAAAAAQABAAAAV/4Cd+Xml6Y0pGTosgEap6G0YQh6FDskhjGg0AMJkwAjxf
BygkGhmCAAXl6QyGnuLFI4g+qNbixLMNdBNfkpXBLncbial6AC17Gvg4eND1BPB3cHJVBguG
hwsSHHo+GRqKHJGRCQo9JI4WBZoFFpUVMw8QCqMQU58qJCclqKytIQA7'
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfClock

	^ Icons
		at: #'xpfClock'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfClockContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfClockContents

	^ 'R0lGODlhEAAQALMPAOz2/6mjhdrMrMe6kkE4H7OfY7iofJR7PnBgN9Dq/tLT1Ojaw3h/hf7+
/v///////yH5BAEAAA8ALAAAAAAQABAAAAR88MnpqpuYusNPzVLDLeTCNZm4CEM7CMKBSts6
OEhltDl9sBaHorHzPGo3i4IQIBYIlcMi2VgyEgDDs4KYIhqNAAFA1kJxC0ODDGAgEonC9ogQ
GNiJa2DQoxcGAXBwAQIFfQ8NCH8BjFqGMxOJBHJyCF8gRw4Em2eYGh8ZEQA7'
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 5/15/2009 15:08'!
xpfClockEdit

	^ Icons
		at: #'xpfClockEdit'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfClockEditContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 5/15/2009 15:07'!
xpfClockEditContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAANZSURBVDjLVZN7TFNnGIdPTMwS
Y/aHyTJjYkJmIjNT/zCLMS4uoomKRhMTTcjwMoJCWDTGeUFAtmIkoKIoA4QqoJRLrKyzLQ63
qS2ltDtcpOXYQi1SbMFSodALp1fbn+9pgGwneU6+vN/7e75LzmEAMHNPmSWEiDASPcRnQv2/
UO3L+XmWSF6oM7MyZilxfa43fTwyrYK394iLVezXnn8eURPuedT/Kg5qfAM50wHzZTf1s8Tq
hMDVyhR42aMT4cmnmNJnzPZJt/pLtdOo7HWhzuBMIIxvaUZhkG7iPVwR7zec+0C5fmIp43jA
FPqMl92TXRmzuqat0Qq9HY+M79GiGUO1zISKxyY8eDGKloFx1HeqMKTYHQs4Hn+cfLLOQtlk
5m0ts21YvMzSfX8jf101ilbWDpnKhhGHF9NeP6a8c7DYvZD8PYL6LhseyctgbNkSMos/f0XZ
5MRFnK9T3sj9nYNYa4OUVhOeGY8HbyacCNJYwB8H/lA2Y7g5DVZ5MQx1u2Cs+uZYQpBe26++
0MahpsMCM63MR+Pw8zyq6hvgIpEvFIL6WQmcL3PhGWwn2wRmB9ugL9szmRAcuq1xn215hWvN
RrgCEcyEYgjTRJ6oCE0yOe7dyYDbJELYoYBTfQMBToaPY1pwDVnBhOBASYc76z4LUcMA7P4I
SWJweHy4WnYT1eXZmHldiFhAi8DbU3D3nMaQJBOsODPeU3FwbUKw55c2dVq5CkWSfnRaPXhP
h3b4Iuj8pxozXB5iQT34keMI2tPhM+eDq9mH7CuVfYnvQHilXHgo2it6gjP3dCiVWjBFF2Yd
lMPZmzsfPobgux/gfV0Ac1Uqhe9CyCwKvjtd/S1h2lWoxNlaDWrqxDD/dZG2rUHQlomQ/Sg8
tJOhqt1I+7UJQq+QWRQIbD5Zlp1TKuGzfr4I05/5MHbcxjh7GLwtHW7DJQz8tg8/lUhwovgh
L/Qu/gsLA51Ol8JxHKTXdgK+MQyLD+Fl/ip016RCKdqOjLxydGm74906XZx6v/+foL29/QvC
b7VacTVrA8L6SoTZO2CLU9CcmRTf/2NO3/q0ApFCqfRZLBZQb5RYsyhobGxcTgwT4cPbVoRK
jn8dfVGaGn1+c0enMnfDVwur0XwS4SEmiJVC7RNi1+PWy99nOwAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:01'!
xpfClockPlay

	^ Icons
		at: #'xpfClockPlay'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfClockPlayContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:00'!
xpfClockPlayContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0RVh0
U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAANBSURBVDjLXZNrSFNhGMcPQQQRfYv60meJ
oiCtROuDZRcEA6MP3ckwS0tlZVlptnXRqavMaqZ5Ka1Jq1bOmWiXs466mqZzLs0103CmLp27HOdl
af+es2xFL/xe/jzv8/+/vA/nMACYsWpmDiEmjEQTMU+o/wvVFs+e64mAP3XGoWLmEtljzXv7vSMs
XM37bHp1ZEPyK6+WsM+ifa+O4tyGuJHxzjQ79euJpb4AWwWT6tLv/zY1VI3hd9GOD8oQXtowglvN
NhS3DfoQ9DWuB23K1R6nSeLh205+J18LMZex3mPOu41p9qH6aIfuQciPvHd9eGQcgIL7CrmqA3mP
O3DvdQ8Uhn6UvGXxSb11Ztz6eHro+TIzeQOYLwXMhq7C+ebGopWebLYHFfo+qNhedFtdGHHxGHaN
wdznQnldN0rqe/GoUgajIniys3BhK3kDfINILq7KSXlqQmFDL5R0m7BGnU58/jaICdIC/E/gjqYb
cq0F6UoO8aW6K74ZCNveghbtqScm3Kkxo5Nu9vz4Cd7jwe2SUtgoyD05iae1b8B9diJT2Q6hV/D4
A3bmcnaRohVZD42wjXsxOjmDKTo4K5bggaoSKRckqNPpwQ5acEKuh9ArePwB2zNr7LFFeohLDejj
vRQyA6vTjcuyqz4zZ2hHWtMJiOpjkfDmEGLL1BA8/oBt6U+0u66zkJS34K3FiQF6tNXtxQttI3rs
LgxNAymNiSjvzsfVVgkSa2MQmXWrxR8Qduq+OEL8HEl3dZAqzRimgY16AfcMQdpBASfZeJSY81BM
SBpTEK3cjUj55rW+gNAEeRDRseV8FUQFHLKUXTD0OsDTPHiPF0bShyujkd8hwyXDaeR9lCK57hjC
czb8/dbXHpYdiZOWe8LPPMMB2UuIbnJIvtEA0fV6HM9lsU+xG7ntGTjXlIgc40UkaGKwXrxmwh+g
0+nCTCYTXrPcdOixIqw5rsC6JJUPQe+4G4Ws1guQGtIRrz6EkPQgb+Dplb+foNFoFhG8xWKBuqrK
vmpPmmTFrlQtYZ9FG3Fj84Sk6QyOVh5EcGogDmTv2eEfYllZ2QKii5gilv//KwtslIaORuRuQvC5
QEjzM4apb4lQ/wXCx9fe4QKeWQAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:02'!
xpfClockStop

	^ Icons
		at: #'xpfClockStop'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfClockStopContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:00'!
xpfClockStopContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0RVh0
U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAMsSURBVDjLXZNrSBRhFIaHIIIyu1q/+hdY
JBVhJUmE0EWiC0U/ukM/KroRllGR1S4UWVnZTdJMS2ujrbZSK7ruNK5rm+m6bV7WNbfc1F3d2d3Z
cUxH7e18k1k08AyHb87zHuYwwwHgOp9yQwgd4SA+EMPY+b/Q2cSB5zYi9s85FzJxQ4kznRUbvqsB
M6SKjX5b0XJL6muVJ8QB+PdFq4SIfUegqzZNpH4bMUkL8N/ljki2TS09vqfoKN8S+micJ6dbArhS
4ceN6jYNVp8XmlBtnKWEnXpFrt7fTl4lMZTz3uSORhxpoq90S8h6e17vpfJm3HO0wiB8RZapBpfu
1+DmmyYY7N+R986MuqIl/V3e+32+x1Nd5MZyX7K5+fU5w11ludOVM+Ym3LU1w2T2oNErISDJ6JA6
4WqWUPiyEXmlHtx7kgGHIaG7Nie6itxYbRGpN4rPHnzoRI7FAyNNY1cwHEZDSxt+UM2QfwLXShqR
xbtxzChgZ771pLYDdtuQXckfeODEtecu1NJkpfcnZEXB1bx8+Cko0t2Nhy/eQmgI45TxE1gvcwYD
1mQKYoqhCqfvOODvUhHs7kcPPTis0+O26QkOHtfjpdUGZ1jFviwbWC9zBgNWnHoubsu1QZdvR7Os
Ukg/vOEITmSc02TB/gkdvcDHgIo9meVgvcwZDEg+9oBfe8EMfWEl3rnDaKWX9kZUPOPL0CRK8PUB
HgV49DmEfdnvwXqZMxiQdOCWbqnuMfZetyLd6EIHLSyoApF+guoQBUjr1kOeMAFSTAyCRGD8eLSN
G+fRAhL3ZMUTNYuPFiMlW8BpYz3snhBk2oesqHBQzURl9Wp0rlwJadkyhJKT8XXs2L/f+pytGdt3
pBcqCw89wuaMV0i5LCD1ogUpF0qxO9OsTWSiOHMm2uPi0J6UhLrRo/8GWK3WJKfTiTdmoS9xVy5m
7zZg7l6TBqu9NE1ctAhtU6agZfJktCYmoio6+rdcUlISQ8hutxtFxcXijPVp+ri1R3hCHIBvGDMG
vgULNNGbkIBv8fEoi4r6HVBQUBBF1BM9xLT/f2WGc9SoOjaxYuRITbQQ/IgRwV81l9Ohf930iQAA
AABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 13:41'!
xpfDeveloperIsOffline

	^ Icons
		at: #'xpfDeveloperIsOffline'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfDeveloperIsOfflineContent readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 13:41'!
xpfDeveloperIsOfflineContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAACXBIWXMAAAsTAAALEwEAmpwY
AAADG2lDQ1BQaG90b3Nob3AgSUNDIHByb2ZpbGUAAHjaY2BgnuDo4uTKJMDAUFBUUuQe5BgZ
ERmlwH6egY2BmYGBgYGBITG5uMAxIMCHgYGBIS8/L5UBFTAyMHy7xsDIwMDAcFnX0cXJlYE0
wJpcUFTCwMBwgIGBwSgltTiZgYHhCwMDQ3p5SUEJAwNjDAMDg0hSdkEJAwNjAQMDg0h2SJAz
AwNjCwMDE09JakUJAwMDg3N+QWVRZnpGiYKhpaWlgmNKflKqQnBlcUlqbrGCZ15yflFBflFi
SWoKAwMD1A4GBgYGXpf8EgX3xMw8BUNTVQYqg4jIKAUICxE+CDEESC4tKoMHJQODAIMWgx9D
JcMqhgeM0oxRjPMYnzIZMjUwXWLWYG5kvstiwzKPlZk1m/UqmxPbJnYV9pkcAhydnKyczVzM
XG3c3NwTeaR4lvIa8x7iC+Z7xl8tICSwWtBN8JFQo7Ci8GGRdFFe0a1iceKc4lslUiSFJY9K
VUjrSj+RmSMbKicod1a+R8FHkVfxgtIU5SgVJZXXqlvVGtX9NGQ13mru05qonapjrSuk+0rv
iP58gxrDKCNLY0nj3yb3TA+brTDvt6iwTLTysbawUbUVsWOx+2r/3OG24wWnY857Xba6rndb
6b7UY5HnQq8F3gt9Fvsu81vlvz5ga+DeoGPB50NuhT4L+xLBFCkYpRRtHOMWGxWXF9+SMDtx
c9LZ5OepTGly6TYZUZlVWbOy9+Tcy2PKVy/wKSwuml18uORtmUS5S0Vh5byqs9V/a/Xq4usn
NRxr/N1s0JLeOq/teodgp3dXe/fhXoY++/66Cfsm/p/sOKV16onpvDOCZ86a9WiO1tySefsW
cC0MW7R48celDssmLH+40nhV6+qba3XXNa2/udFgU8fmB1uttk3d/mGn765Vezj2pu87fkD9
YOeh10f8jm4+Ln6i9uST095ntpyTPd9+4dOluMunrlpcW3ZD9Gbrra930u/evO/z4MAj08er
nyo+m/lC8GXXa+Y3dW9/vi/98OlTwed3X/O+vfuR//PD7+I/3/5V/f8PAC4MHYugPAkxAAAA
IGNIUk0AAHolAACAgwAA+f8AAIDpAAB1MAAA6mAAADqYAAAXb5JfxUYAAAF2SURBVHjabNG/
S9RxGAfw133O89ILi6OrE/qBmwhGgoI0JRFYgRBEEV0QDQ0F0eJiEf0XbbYUtBVEDSEFQeBS
kbZIUBBmGibpdXee3X0/Df5q6P1sr2d4w/OkovVMl+oX/vRWCqupWmVtNvP43N11T0VMdSbj
O4Z3atcq7bc57618yY+UPpKKpnOrr/YO7BM1RA1kZUx4u9TVU1oILN/JDRQ1BW065HVoWjJs
T/77fQLli3mJIIWGhqhVsOC4uSFaqBZyVgVpaxJRU1pZzUHVLC3UfvzcX/BZ2mstEstOKiv6
JtQJhIcfZDU9MqhfnxPuqTnkuV2TBNpuz8+80S2LtLRETp8JU/XiVQJnGu3n3y1O2o0myHvp
QaPnys1PG4divH/+ab3Y7YhoxhOx3Ht29AWIG3Pr9PDa5TgSh+LhmElGj216avMXDH49eiCx
ouzZYrWwqWFrrzbb5YZTOoVf27pVEY1d6qiERJKpXr+2rf9U/D9/BwA9Z5PtuXkkmQAAAABJ
RU5ErkJggg=='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 13:42'!
xpfDeveloperIsOnline

	^ Icons
		at: #'xpfDeveloperIsOnline'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfDeveloperIsOnlineContent readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 13:43'!
xpfDeveloperIsOnlineContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAACXBIWXMAAAsTAAALEwEAmpwY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'
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'topa 4/23/2009 15:51'!
xpfDone

	^ Icons
		at: #'xpfDone'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfDoneContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'topa 4/23/2009 15:51'!
xpfDoneContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0RVh0
U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAGrSURBVDjLvZPZLkNhFIV75zjvYm7VGFNC
qoZUJ+roKUUpjRuqp61Wq0NKDMelGGqOxBSUIBKXWtWGZxAvobr8lWjChRgSF//dv9be+9trCwAI
/vIE/26gXmviW5bqnb8yUK028qZjPfoPWEj4Ku5HBspgAz941IXZeze8N1bottSo8BTZviVWrEh5
46EO03EXpuJOdG63otJbjBKHkEp/Ml6yNYYzpuezWL4s5VMtT8acCMQcb5XL3eJE8VgBlR7BeMGW
9Z4yT9y1CeyucuhdTGDxfftaBO7G4L+zg91UocxVmCiy51NpiP3n2treUPujL8xhOjYOzZYsQWAN
yRYlU4Y9Br6oHd5bDh0bCpSOixJiWx71YY09J5pM/WEbzFcDmHvwwBu2wnikg+lEj4mwBe5bC5h1
OUqcwpdC60dxegRmR06TyjCF9G9z+qM2uCJmuMJmaNZaUrCSIi6X+jJIBBYtW5Cge7cd7sgoHDfD
aAvKQGAlRZYc6ltJlMxX03UzlaRlBdQrzSCwksLRbOpHUSb7pcsnxCCwngvM2Rm/ugUCi84fycr4
l2t8Bb6iqTxSCgNIAAAAAElFTkSuQmCC'
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfEdit

	^ Icons
		at: #'xpfEdit'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfEditContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfEditContents

	^ 'R0lGODlhEAAQAMQAAGB3lYivyMDf/XiZt+Ts9ajT/Mbh/UlVa/P2+bLY/FRlfu3x9ZzN++Xy
/rTR4ENLXN7v/tTk8Jm/1enx96jL3uDo7ykxQz5FVb2JAP+8Bv/RV6HQ/FSr9qfR+jhllf//
/yH5BAAAAAAALAAAAAAQABAAAAWV4CeOZClGjkNJUhAMsOdJohMRUz4RvNdxntrEQCQKGj6g
QkRBFAXHpAex/EicBijy54FQRddslAspfD8BhBZDLpgPovQRo8l0C50NAf4ZLBp0GRhleXoP
In4RdYN4GxsMFYd9CwkKlgoAAwybFReICAkJeAUDAKYAC54fABEIOzwEFbILDhaImJcHBw8P
FxcWVSbCIiEAOw=='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/14/2009 14:26'!
xpfFeedback

	^ Icons
		at: #'xpfFeedback'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfFeedbackContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/14/2009 14:25'!
xpfFeedbackContents

	^ 'R0lGODlhEAAQAMQAAP/99v/qaOvOSem4M+zSSv/ypf/ug//1w//2zP/xnv/te//zrf/0uv/4
1/nWdufBMP/vkevTVf/rcv/0s//wlv/57OvRM//vi+/OQtaXIuuYEuvTLNyhJ+vHUP//////
/yH5BAEAAB8ALAAAAAAQABAAAAV+4CeOZEl6aKqWHhG9BIFZ1uaNnqN6QHMgCNsn50EwJotC
IkGBHCoWlO6YZEIuBgPggSIAkEoKVkE+cD2YClhsUEjelAEK06hC2pKAXsFBCRBJbHl6AQYZ
N2gIBw2KDHoUDIc4ApQdHQNIGpInOwMVGjcmLAOgoiYepaYsoR8hADs='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:39'!
xpfHistory

	^ Icons
		at: #'xpfHistory'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfHistoryContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'SR 4/14/2009 11:38'!
xpfHistoryContents

	^ 'R0lGODlhDAANAMIEAAAAgICA/4+w1LTR4P///////////////yH5BAEKAAQALAAAAAAMAA0A
AAMhSLq8AaExQIMVeKgXpffcR1DQlW2QqKKdR1oBJmhEuH4JADs='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'cs 5/28/2009 12:20'!
xpfLogin

	^ Icons
		at: #'xpfLogin'
		ifAbsentPut: [Form fromBinaryStream:
			(Base64MimeConverter mimeDecodeToBytes: self xpfLoginContents readStream)]! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'cs 5/28/2009 12:29'!
xpfLoginContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAEuSURBVDjLpZM9SgRBFIRr/EHX
wGVFAxUPYmTgMTyEoblX2NwjGG9i5B0EMTIQFWTBaHTeqyqDHmdX0FlhHzSvO6n+qvp1ZRvL
1AqWrLX5w93VuSXBJkhCKovMrpOJk4vr6lcBidg7PgVMWIYkWATEbv9wc/03AZkwiY/3J7i9
3STcEmxu7yOz6ReQCDFhFTExIRJWgox+gcwot2UUAmY5kzADzkBEL0Er0PUZReUGIhcRNAU5
muI/E1JiZzjF4cEbHp+HyIx+C2otdPgqfTodoP5c/w9BgNn8sPD6sgFzFVu76ieIaGYhMtrw
WiGVPRkLCLJkYJX0vyms8rQLMigWBqMj2IKZsFSWCbGM83xVtjGZTFzXNeL2spv3+fmf/QnC
Ju5HZwCA8XhcVct+5y9H3H2zjxE/HwAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'cs 5/28/2009 12:20'!
xpfLogout

	^ Icons
		at: #'xpfLogout'
		ifAbsentPut: [Form fromBinaryStream:
			(Base64MimeConverter mimeDecodeToBytes: self xpfLogoutContents readStream)]! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'cs 5/28/2009 12:18'!
xpfLogoutContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJHSURBVDjLlZPNi81hFMc/z713
7p1mTCFvNZfGSzLIWNjZKRvFRoqNhRCSYm8xS3+AxRRZ2JAFJWJHSQqTQkbEzYwIM+6Yid/z
nJfH4prLXShOnb6r8/nWOd8Tcs78bz0/f+KMu50y05nK/wy+uHDylbutqS5extvGcxaWqtoG
DA8PZ3dnrs2srQc2Zko41UXLmLdyDW5OfvsUkUgbYGbU63UAQggdmvMzFmzZCgTi7CQmkZwd
EaX0JwDgTnGbTCaE0G4zw80omhPI92lcEtkNkdgJCCHwJX7mZvNaB0A14SaYJlwTrpHsTkoF
lV1nt2c3x5YYo1/vM9A/gKpxdfwyu/v3teCayKq4JEwT5EB2R6WgYmrs2bYbcUNNUVfEhIfF
Yy69uci+1fuRX84mkawFSxd/4nVWUopUVIykwlQxRTJBTIDA4Pp1jBZPuNW4wUAPmCqWIn29
X1k4f5Ku8g9mpKCkakRLVEs1auVuauVuyqHMo8ejNCe+sWPVTkQKXCMmkeZUmUZjETF1tc6o
oly+fgUVw9So1/tRN6YnZji46QghBFKKuAouERNhMlbAHZFE6e7pB+He8MMw+GGI4xtOMf1+
lsl3TQ4NHf19BSlaO1DB9BfMHdX0O0iqSgiBbJkjm491hClJbA1LxCURgpPzXwAHhg63necA
Ii3XngXLcRU0fof8ETMljIyM5LGxMcbHxzvy/6fuXdWgt6+PWncv1e4euqo1ZmabvHs5+jn8
yzufO7hiiZmuNpNBM13rbvVSpbrXJE7/BMkHtU9jFIC/AAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'cs 5/28/2009 12:31'!
xpfMedal

	^ Icons
		at: #'xpfMedal'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfMedalContents readStream)]! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 5/12/2009 18:45'!
xpfMedalContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAIHSURBVDjLfZKxa5NBGMZ/35dE
amtFMkgGpaAVQcTRLp1LoYubi6MOgqiTZOrQxYKjOIh/gIuim5YqdChKl4KbQ0XESoPYaGq+
fHff3fu+DklM2lRfeLg7uOd3z929iZnRL7l9y7hwkbi6isWIiaAhoL2xMj+PvVlj4u1K0veU
Gaphkw0ZNcbuOkasCMOWA4AQsRhR79EYu6AY/87LhwDSfYAiYN7D1BTiPeo94j3iHMn0NNrJ
saL4T4IiLNH+sFhZ2KFy9Qcc8aga0knR3S/oWrO751+A8p332+bSNmfuHmP8PEZKqjlJaKF7
HynGHrZ1wW0Pe5L+L8R3p2YwXjL9qGal42hsQvyNSYaJgyQBCbQ36w0puFK7Zhv73sAk1Dl9
r2blE1j8BZJj4nrKUP8d04yxczdrYY/6yBU0FrOliUtY3MPU9eR7cph20PCTdPwkIWN25BdU
pWppGdMc1PfkBhIH0gYLxILqKEAULIIWg+j902WQCPPE4pA+0ChNCy3MwoHobgBBkaJDyGmO
AoJbl90NkqS0P770Rguk6VHyna90WqyPAMSx3N6831C3C6UxzCImvSQoSXmS6BI+PX/VyDOW
R/oAYOdxckMCS5OXr9cq1bOQGBYzpGiRfdti6+nrRp6xOPfMnhwKAPj8IJkpWtSjY1Yi1eDB
dWi6jHURludedBuoX38Av56vLTwJJBoAAAAASUVORK5CYII='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 5/6/2009 16:09'!
xpfOpenStories

	^ Icons
		at: #'xpfOpenStories'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfOpenStoriesContent readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 5/6/2009 16:09'!
xpfOpenStoriesContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAAK8AAABkCAYAAADwvWACAAAACXBIWXMAAA7EAAAOxAGVKw4b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'! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'cs 5/26/2009 18:10'!
xpfPassword

	^ Icons
		at: #'xpfPassword'
		ifAbsentPut: [Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfPasswordContents readStream)].! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'cs 5/26/2009 18:11'!
xpfPasswordContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAH2SURBVDjLjZNLTxNRGIaJv6ZN
WeBwkZFLQtGAC4l/wKULV+7YILeSYukEUhJoSASVuCI0hpAYDSUQCJBSoAaC0wbBUi4aWphp
O52Zlpa+nnOqCAptJ3k3M3me73LOlAAoyZfDqQdOEvyO89/vRcGZ5HeWmySFYdWHVOQN0vE5
8jrLJMFJ82hewVU4+bMfqdPxP9VBn+A4D88wP59PwFqmsH7UgeTJEMlsTuIyI5uRsDfCMcmt
AtoyhVmOu5kkHZuFsiNA3XuEi+QCdhxluL0D/SvpoO+vhIksiItNiPqqyXgfIL403gjfoTsI
L70gQBdim3VQvz2FFnwOxf8E8kYF0rIVYqcRM70Vgf/Pe/ohwsutOJdcpBpP4Mek+jPEfbWQ
VzkG+7tNcNsqt68tkcLZTIzM6YZ21IbolgHq9j1o+z04nKhHRnlH2p6A32LCvFD55fIYr960
VHgSSqCFVDJBEeugh+zw2jnpc0/5rthuRMBaioWBqrVrFylXOUpankIi0AjJY0DC3wD9oA9r
Anc2bat+n++2UkH8XHaTZfGQlg3QdlsIbIVX4KSPAv+60L+SO/PECmJiI1lYM9SQBR7b3ein
fn6kEMwEIZd5Q48sQQt1Qv/xFqt2Tp5x3B8sBmYC71h926az6njdUR6hMy8O17wqFqb5Bd2o
/0SFzIZrAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'topa 4/23/2009 16:01'!
xpfPencil

	^ Icons
		at: #'xpfPencil'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfPencilContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'topa 4/23/2009 16:21'!
xpfPencilContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0RVh0
U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAFUSURBVDjLrZM/SAJxGIZdWwuDlnCplkAE
m1zkaIiGFFpyMIwGK5KGoK2lphDKkMDg3LLUSIJsSKhIi+684CokOtTiMizCGuzEU5K3vOEgKvtB
De/2Pc8H3x8NAM1fQlx4H9M3pcOWp6TXWmM8A7j0629v1nraiAVC0IrrwATKIgs5xyG5QiE+Z4iQ
doeU2oAsnqCSO1NSTu+D9VhqRLD8nIB8F0Q2MgmJDyipCzjvYJkIfpN2UBLG8MpP4dxvQ3ZzGuyy
BQ2H+AnOOCBd9aL6soh81A5hyYSGWyCFvxUcerqI4S+CvYVOFPMHxLAq8I3qdHVY5LbBhJzEsCrw
utpRFBlUHy6wO2tEYtWAzLELPN2P03kjfj3luqDycV2F8AgefWbEnVqEHa2IznSD6BdsVDNStB0l
fh0FPoQjdx8RrAqGzC0YprSgxzsUMOY2bf37N/6Ud1Vc9yYcH50CAAAAAElFTkSuQmCC'
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 13:23'!
xpfScreenDisconnect

	^ Icons
		at: #'xpfScreenDisconnect'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfScreenDisconnectContent readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 13:21'!
xpfScreenDisconnectContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAMySURBVHjaYvz//z8DPrD6+EeW
X3//SP369Vf6+48/ot9+/lID4rav33/t/fztpz9AALHg07zi6AdOoMa9f/7+tvz1+y/D379/
GFgYfjOI8zEzPPrxx+Pdp+8bAQIIrwHff/7KZWP+b8nPxcTw8/c/hp+/GIFiTAwfv/5k4GBl
ZHj74ZMzQAAx4vLC7J3P2b7+/PNRUoCV4/vPnwxvPv0AGcjw9ccfBl5OZoYbD94yPHz8vhQg
gJhw2Z7qLvnr07fvfQ9efQJq+sXADnTrhy8/GT5+/sbw5dt3hndvvjD8+vj1FkAAYXhh0cG3
cn/vbar7/fs3c11aWmLahBPfP33/Uy0hyMbBy8HE8PzNDwZmJnaGLx+BBnz+9hoggOBeWHbk
HScwoJb9/vjEU5bjJTsrKyvDhQsXFhQXFye6lm+z+fP95y4ZMV5Obh5WYHj8Zrh87B7Dj8/f
5AECCGwA0FYWoI3X2FkZVRn+/2V4fu/CHxXBnyxXr15d8P379xQg5j/xzkzr948fuySk+Tg/
v/3K8OrRm9v//v3SAgggcBh8//FL6vvPP6pcbAwMzIz/GFiF1VgO32f7dYvVbj5Q85xv374d
U/2//c7vz9/c7l989O3lo5cb/vz9oX/jQPkfgAACh8GXb7+kGRj+Ag36z/D07TcGbg5GBk4h
abbfN6/sUVJSYhUTE2NYs2bNAXmWnVY3v1ppAjU+goUZQACBDfj8/bsoMyMDMLT/Aw37wfDq
/W8Gfi4WBhlFFdajlw8x6H+5x/Dz58/jGzdufAdU/g450AECCGzAx8/f1Xg4mRiAehk+ffsJ
8hLDy3e/GDhYmBk4ZYwZtp48/vvPX/0sbNENEEDMr8X82IBpeq+oABvzp68/GNiATgHqY2Bh
YmT4++8vw6P7r4Fx/r/qzNbyg9gMAAgglg+fv3/h42Ji/fvnD8PX7z8ZHj/9yPD5/VeG719+
MPwAJpzvn74e//v372RcCQ4ggFg+fPm2l+k/q8e1N58Znjx59/v31x9Vf3/9ufX3x6/Xf379
evr3359n1/eV/MFlAEAAsXz7/C3o06vf64AJxfnP9188p1cn/mIgAQAEGAAHb6YRb+SXdQAA
AABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 11:41'!
xpfScreenIndicateSharedContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJISURBVHjaTMWxDQAwCAMweJLf
uSUhqdoBdbCctqO7LSmumXlI7j8Ae1XlEUAsDEAAUiglJcPw4dMnBgaggQwQBGb/B1P/4WwQ
LSgowLB9+1YQjwEggOAGfPj4kSFv0lEGYkB3uinDr1+/wGyAAAIbAHISxHgGBhlZOQYeLjYG
WVFuBg52FoYfv/8z/P7zj+H3X6BFQDUnTl1g+P/vP8PPnz/B6gECiAlEgPwDdiYQMDIyMnz7
8YfhxYcfDN9+/gX76A9Q5y+gIT//QNSAxGAuAAggFpgB/2DuAxoAMuTztz8M//7/ZBDgZmVg
YWFmYALa+h9qwL///+AGAAQQ3ABgNED0Ixny/ddfhl+//zFwA73EzMzEwMQIsQOkFmYAQADB
DWBA8gIIgw0BKQZ5CegVRqb/EHGwCxBeAAggsAEgDhMzODgYHj64TzAWmIFeghkAEEBwA9hY
WRg6UgyAUfqfgZWVleHVy5cM3Dx84MB9//4Ng4S4BMP379+hIY/wAkAAwQzoO3Bgvz1SKhMC
4n3S0tLJIP7t27fnAmknoNg7pFS5HqQXIIAYYdGHDPr7+/OBCvysbeyc+PkFGVYsX/wdyG9o
b2/vQlcLEEAoBkyePFkUaMsrVVU1BiFhEYa/fxiBiegPAzc3J8O9uzcZTp06+XXChAk8yAYA
BBALMgeYukxkZWUZPD09wM4EGQ7CTExMDCbGegzv3r3lTk9Pd585c+ZOmB6AAMLwQlNT0xmg
K4zRcyE0Z56eNWuWGbJ6gADCGgakAIAAAwD2s2ImVN243gAAAABJRU5ErkJggg=='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 11:41'!
xpfScreenIndicatedShared

	^ Icons
		at: #'xpfScreenIndicateShared'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfScreenIndicateSharedContent readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 11:41'!
xpfScreenShare

	^ Icons
		at: #'xpfScreenShare'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfScreenShareContent readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 11:38'!
xpfScreenShareContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAK4SURBVHjaTMWxDQAwCAMweJLf
uSUhqdoBdbCctqO7LSmumXlI7j8Ae1XlEUAsDEAAUiglJcPw4dMnBgaggQwQBGb/B1P/4WwQ
LSgowLB9+1YQjwEggOAGfPj4kSFv0lEGYkB3uinDr1+/wGyAAAIbAHISxHgGBhlZOQYeLjYG
WVFuBg52FoYfv/8z/P7zj+H3X6BFQDUnTl1g+P/vP8PPnz/B6gECiAlEgPwDdiYQMDIyMnz7
8YfhxYcfDN9+/gX76A9Q5y+gIT//QNSAxGAuAAggFpgB/2DuAxoAMuTztz8M//7/ZBDgZmVg
YWFmYALa+h9qwL///+AGAAQQ3ABgNED0Ixny/ddfhl+//zFwA73EzMzEwMQIsQOkFmYAQADB
vcCA5AUQBhsCUgzyEtArr/+lMzz7Hc3AyARyGcILAAEEdgGIw8QMNovh4YP7WENeVPsng7yY
JsMnlVaGf0yr4QYABBDcADZWFoaOFANglP5nYGVlZZhxNgno1N8Mv/79AQbgHwYpIVUGTQlz
hs8/vjKU73Fj0PodAjYAIIBgBvQdOLDfHimVCf3h+6Xoqh0PjDpg6vz3FxjI/xmefXzMoCtj
zfDl13eGo99n/ddrmcIPEEBgA8LDw4uRndvf35//48+vCSDND9/eZvgNdMUfoGt+//3N8Onn
ZwYDWVuGL7+/MZ68f+QtQACxIGucPHmyKND2V6qqagxnX/4Axv8fBnE+OaDmv2CXPP/4iEGI
R4Lh3OOjDEfvHnn96w+DG0AAoRgATF0msrKyDJ6eHgwL5uQzLDzeAwyDXwxA1zAoiWgxWCi5
MZx+eIRh761dL4CanZ+1/b8GEECMsBQIA01NTWeArjBGz4UHxWYyGMnbMRy4tffpr39gzTdB
6gECCMMAXECpjvHr33/MXN///VV61fYfHtcAAQYAJ6iM87Uv3U4AAAAASUVORK5CYII='
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 13:17'!
xpfScreenUnShare

	^ Icons
		at: #'xpfScreenUnShare'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfScreenUnShareContent readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mfp 4/27/2009 13:18'!
xpfScreenUnShareContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAKjSURBVHjaTMWxDQAwCAMweJLf
uSUhqdoBdbCctqO7LSmumXlI7j8Ae1XlEUAsDEAAUiglJcPw4dMnBgaggQwQBGb/B1P/4WwQ
LSgowLB9+1YQjwEggOAGfPj4kSFv0lEGYkB3uinDr1+/wGyAAAIbAHISxHgGBhlZOQYeLjYG
WVFuBg52FoYfv/8z/P7zj+H3X6BFQDUnTl1g+P/vP8PPnz/B6gECiAlEgPwDdiYQMDIyMnz7
8YfhxYcfDN9+/gX76A9Q5y+gIT//QNSAxGAuAAggFpgB/2DuAxoAMuTztz8M//7/ZBDgZmVg
YWFmYALa+h9qwL///+AGAAQQ3ABgNED0Ixny/ddfhl+//zFwA73EzMzEwMQIsQOkFmYAQADB
DWBA8gIIgw0BKQZ5CegVRqb/EHGwCxBeAAggsAEgDhMzODgYHj64TzAWmIFeghkAEEBwA9hY
WRg6UgyAUfqfgZWVleHVy5cM3Dx84MB9//4Ng+C9QwzfDi9l+P38IcOLejEGaQ5lsAEAAQQz
oO/Agf32SKlMCIj3SUtLJ4P4TIcWnBbl+mRiFpnJyK6ozfD90i4G/sO7/+12Yc0FCCBGWPQh
g/7+/nygRj9rGzsnfn5BhrtlVv9ds6oYOe8eYGB4eoSBgV+A4Q2LPMO5XYfvAwQQC7LGyZMn
iwJtfqWqqsYgJCzC8AcYti9evGbg/vGJkUNCkYHBqwiulqVBkoH5H6MCQAChGABMXSaysrIM
np4eYK+AXAfCp8UkGb5d2MrAvSmL4ef3FwzfgGo/f2Jm+MvM8AwggDC80NTUdAboCmPkHKjx
8TKDPvNjBnnh3wwsTE8YPr/+w/DgJfPf3z/+1wEEENYwwAaORshVfH33LJ35L6P8X+b/T4G6
prvv+tMGEGAAgiZr9QKg/AwAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:01'!
xpfTakeResponsibility

	^ Icons
		at: #'xpfTakeResponsibility'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfTakeResponsibilityContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mig 4/15/2009 19:07'!
xpfTakeResponsibilityContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABUAAAAQCAMAAADOBMQXAAAABGdBTUEAALGOfPtRkwAAACBjSFJN
AAB6JQAAgIMAAPn/AACA6AAAdTAAAOpgAAA6lwAAF2+XqZnUAAABL1BMVEUAAAD////+/v/w8/nv
8vhRcamxv9hRcqlWdq1cfrS0wtrw8/jv8vdYe7FXea5fg7legbdhhbtghbpkiL5jh71mi8Bskshv
kMFojsNul8xwmc5yms91ntR6pNt5otiApNSHrd6Gq9xzndJ6ptx2oNV5o9l4oth7p9x6pNqHr9+F
rN2DqdmBp9aGrd2IsN95msSNtOOSueiNsd2RtOCRtN6dwOqcu+H+//8ARAAAPQAEVwALYQQecBg3
ijEUawsYaxAddhMdbxYkgBoldh40hSxcrlVhslpks11mtF9qt2JsuGRvuWdyvGotiiI0lCk8ni9D
pzU8jTJ1vWx7wHKBw3lJrjpOtD9SuUN5vm9/wnWFxXqIx3yKyH+NyoGPy4SSzIaUzYma0Y+Xzov+
/v7///+4j0A3AAAAZXRSTlP/////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////ABlo0oMAAADRSURBVBjTY0gxUlfWUJFRkpbST4EDBi1DOBBHiKojgChCVJYRDkQQoqqMXGZ6
mgqK2jrykmCTnUCicozGplBgADbZwQ4oKsaoBwLh4WGhAf5+vk4OgS5WKQysEmrM3Cw84YlJ8bHR
IcFB3p7uzhYMKSmqjGwm6mEJcTFRkRE+Xh5urjaWQFE5Rl1DQ6h2O2t7W0fLFKCoGCOKmy0sU0Ci
rBIobrZMAYuCTAYDc6ZkRiGIL0CEHCNMmFEAISqGMIEdIcoqISosyM/Jy8fBygoWBQDqrkpzV06O
hgAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 5/14/2009 10:02'!
xpfUser

	^ Icons
		at: #'xpfUser'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfUserContents readStream) ].
! !

!MenuIcons class methodsFor: '*Xpf-Client' stamp: 'mt 5/14/2009 10:02'!
xpfUserContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJ3SURBVDjLpZNtSNNRFIcNKunF
1rZWBMJqKaSiX9RP1dClsjldA42slW0q5oxZiuHrlqllLayoaJa2jbm1Lc3QUZpKFmmaTMsa
Rp+kMgjBheSmTL2//kqMBJlFHx44XM7vOfdyuH4A/P6HFQ9zo7cpa/mM6RvCrVDzaVDy6C5J
JKv6rwSnIhlFd0R0Up/GwF2KWyl01CTSkM/dQoQRzAurCjRCGnRUUE2FaoSL0HExiYVzsQwc
j6RNrSqo4W5Gh6Yc4+1qDDTkIy+GhYK4nTgdz0H2PrrHUJzs71NQn86enPn+CVN9GnzruoYR
63mMPbkC59gQzDl7pt7rc9f7FNyUhPY6Bx9gwt4E9zszhWWpdg6ZcS8j3O7zCTuEpnXB+3MN
ZkUUZu0NmHE8XsL91oSWwiiEc3MeseLrN6woYCWa/Zl8ozyQ3w3Hl2lYy0SwlCUvsVi/Gv2J
wITnYPDun2Hy6jYuEzAF1jUBCVYpO6kXo+NuGMeBAgcgfwNkvgBOPgUqXgKvP7rBFvRhE1cr
p8Vq1noFYSlacVyqGk0D86gbART9BDk9BFnPCNJbCY5aCFL1Cyhtp0RWAp74MsKSrkq9guHy
vfMTtmLc1togpZoyqYmyNoITzVTYRJCiXYBIQ3CwFqi83o3JDhX6C0M8XsGIMoQ4OyuRlq1D
dZcLkmbgGDX1iIEKNxAcbgTEOqC4ZRaJ6Ub86K7CYFEo8Qo+GBQlQyXBczLZpbloaQ9k1NUz
/kD2myBBKxRZpa5hVcQslalatoUxizxAVVrN3CW21bFj9F858Q9dnIRmDyeuybM71uxmH9BN
BB1q6zybV7H9s1Ue4PM3/gu/AEbfqfWy2twsAAAAAElFTkSuQmCC'! !

SimpleHierarchicalListMorph subclass: #XpfIterationTreeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfIterationTreeMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 14:53'!
for: anXpfIteration

	| result |
	result := self
		on: (XpfIterationTreeModel new iteration: anXpfIteration)
		list: #rootItems
		selected: nil
		changeSelected: nil
		menu: nil
		keystroke: nil.
	^ result model addDependent: result expandRoots
! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:06'!
backupExpandedState

	| backup |
	backup := Dictionary new.
	scroller submorphsDo: [:m |
		m complexContents hasXpfModel ifTrue: [
			backup at: m complexContents model restUri put: m isExpanded]].
	^ backup.! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:49'!
collapseAll
	"Expand all of the roots!!"
	
	self roots do: [:m |
		self collapseAll: m].
	self adjustSubmorphPositions! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:50'!
collapseAll: aMorph
	| allChildren |
	aMorph isExpanded ifTrue: [aMorph toggleExpandedState].
	allChildren _ OrderedCollection new: 10.
	aMorph recursiveAddTo: allChildren.
	allChildren do: [:each | 
		(each canExpand and: [each isExpanded])
			ifTrue: [self collapseAll: each]].
! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'topa 4/20/2009 17:12'!
indentingItemClass

	^ XpfIndentingListItemMorph! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/1/2009 10:27'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 16:52'!
restoreExpandedState: aDictionary

	scroller submorphsDo: [:m |
		m complexContents hasXpfModel ifTrue: [
			(aDictionary includesKey: m complexContents model restUri)
				ifTrue: [
					m isExpanded = (aDictionary at: m complexContents model restUri) ifFalse: [m toggleExpandedState]]]].! !

!XpfIterationTreeMorph methodsFor: 'as yet unclassified' stamp: 'mfp 4/29/2009 17:12'!
update: aSymbol

	aSymbol = #userStories ifTrue: [ | backup |
		backup := self backupExpandedState.
		self
			list: self getList;
			collapseAll;
			expandRoots;
			restoreExpandedState: backup;
			adjustSubmorphPositions].
	super update: aSymbol.! !

ImageMorph subclass: #XpfDeleteMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfDeleteMorph methodsFor: 'layout' stamp: 'SR 4/17/2009 16:37'!
acceptDroppingMorph: aMorph event: evt 

	(aMorph isUserStoryMorph or: [aMorph isTaskMorph])
		ifTrue: [aMorph model delete. aMorph delete].
! !

!XpfDeleteMorph methodsFor: 'testing' stamp: 'mfp 3/19/2009 17:05'!
acceptsTasks

	^ true! !

!XpfDeleteMorph methodsFor: 'testing' stamp: 'topa 3/11/2009 15:46'!
acceptsUserStories

	^ true! !

!XpfDeleteMorph methodsFor: 'initialization' stamp: 'topa 3/19/2009 14:38'!
initialize

	super initialize.
	self image: TrashCanMorph initializeTrashPic.! !

!XpfDeleteMorph methodsFor: 'accessing' stamp: 'topa 3/19/2009 14:38'!
model

	^ model! !

!XpfDeleteMorph methodsFor: 'accessing' stamp: 'topa 3/19/2009 14:38'!
model: anObject

	model := anObject.! !

!XpfDeleteMorph methodsFor: 'dropping/grabbing' stamp: 'mfp 3/19/2009 17:07'!
wantsDroppedMorph: aMorph event: evt

	^ aMorph isUserStoryMorph | aMorph isTaskMorph! !

ImageMorph subclass: #XpfPluggableImageMorph
	instanceVariableNames: 'model selector formOn formOff'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Helpers'!

!XpfPluggableImageMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 13:29'!
formOn: formOn formOff: formOff model: model getOnOffSelector: selector

	^ self new
		formOn: formOn;
		formOff: formOff;
		selector: selector;
		model: model! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:23'!
formOff

	^ formOff! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
formOff: anObject

	formOff := anObject.! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
formOn

	^ formOn! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
formOn: anObject

	formOn := anObject.! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
model

	^ model! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:28'!
model: anObject

	model ifNotNil: [model removeDependent: self].
	model := anObject.
	model ifNotNil: [
		model addDependent: self.
		self updateImage].! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
selector

	^ selector! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
selector: anObject

	selector := anObject.! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:26'!
update: aSymbol

	super update: aSymbol.
	aSymbol = self selector ifTrue: [self updateImage].! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:27'!
updateImage

	(self model perform: self selector)
		ifTrue: [self image: self formOn]
		ifFalse: [self image: self formOff].! !

ImageMorph subclass: #XpfUserStoryAddMorph
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

XpfUserStoryAddMorph class
	instanceVariableNames: 'icon'!

!XpfUserStoryAddMorph commentStamp: 'topa 3/9/2009 15:16' prior: 0!
I am a Morph that should behave somehow like a Button, yet are embeddable into
a PasteUpMorph.!

XpfUserStoryAddMorph class
	instanceVariableNames: 'icon'!

!XpfUserStoryAddMorph class methodsFor: 'defaults' stamp: 'mfp 4/28/2009 10:46'!
emptyUserStory

	^ Dictionary newFrom:	{'title' -> 'Please enter content for new user story'}! !

!XpfUserStoryAddMorph class methodsFor: 'initialize-release' stamp: 'cs 3/11/2009 17:57'!
forProjects: anXpfProject

	^ self new model: anXpfProject! !

!XpfUserStoryAddMorph class methodsFor: 'as yet unclassified' stamp: 'topa 4/20/2009 17:53'!
icon

	^ icon ifNil: [icon := Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self iconContent readStream) ]! !

!XpfUserStoryAddMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/20/2009 22:41'!
icon: anIcon

	icon := anIcon.! !

!XpfUserStoryAddMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/20/2009 22:39'!
iconContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAAFIAAAA2CAYAAABUSc7XAAAAGXRFWHRTb2Z0d2FyZQBBZG9i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'! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'topa 3/11/2009 14:00'!
handlesMouseDown: evt

	self enabled ifTrue:
		[evt hand waitForClicksOrDrag: self event: evt].
	^ true! !

!XpfUserStoryAddMorph methodsFor: 'initialization' stamp: 'topa 4/20/2009 17:57'!
initialize

	super initialize.
	self
		image: self class icon.! !

!XpfUserStoryAddMorph methodsFor: 'accessing' stamp: 'topa 3/11/2009 15:20'!
model

	^ model! !

!XpfUserStoryAddMorph methodsFor: 'accessing' stamp: 'topa 3/11/2009 15:20'!
model: anObject

	model := anObject.! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'cs 3/18/2009 15:28'!
mouseDown: evt
	
	^ self performAction openInHand! !

!XpfUserStoryAddMorph methodsFor: 'event handling' stamp: 'mt 4/28/2009 19:20'!
performAction
	"for Button behavior"

	^ XpfUserStoryMorph forUserStory: XpfNewUserStory new! !

RestPrefetchProxyCollection subclass: #XpfProxyCollection
	instanceVariableNames: 'updateCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Proxies'!

!XpfProxyCollection methodsFor: 'adding' stamp: 'mt 5/7/2009 10:54'!
fill: anObject

	super fill: anObject.
	self updateCounter: self updateInterval.! !

!XpfProxyCollection methodsFor: 'updating' stamp: 'mt 5/7/2009 10:51'!
needsUpdate

	| needsUpdate |
	self updateCounter: self updateCounter - 1.
	needsUpdate := self updateCounter = 0.
	self updateCounter <= 0 ifTrue: [self updateCounter: self updateInterval].
	^ needsUpdate! !

!XpfProxyCollection methodsFor: 'accessing' stamp: 'cs 6/11/2009 14:53'!
revision

	| shortRestUri |
	self isLoaded ifFalse: [^ nil].
	shortRestUri := String new.
	(self restUri findTokens: $/) allButLast
		do: [:each | shortRestUri := shortRestUri, each]
		separatedBy: [shortRestUri := shortRestUri, '/'].
	shortRestUri ifEmpty: [^ 0].
	"I am a collection with no parent therefore I have no revision. 0 means always update"
	^ (self repository getObject: '/', shortRestUri) revision! !

!XpfProxyCollection methodsFor: 'accessing' stamp: 'mt 5/7/2009 10:53'!
updateCounter

	^ updateCounter ifNil: [0]! !

!XpfProxyCollection methodsFor: 'accessing' stamp: 'mt 5/7/2009 10:53'!
updateCounter: anObject

	updateCounter := anObject.! !

!XpfProxyCollection methodsFor: 'updating' stamp: 'cs 6/11/2009 14:55'!
updateInterval
	"Tell the client how often a changes request for this entity should be sent."
	
	| shortRestUri parent |
	self isLoaded ifFalse: [^ nil].
	shortRestUri := String new.
	(self restUri findTokens: $/) allButLast
		do: [:each | shortRestUri := shortRestUri, each]
		separatedBy: [shortRestUri := shortRestUri, '/'].
	shortRestUri ifEmpty: [^ 0].
	"I am a collection with no parent therefore I have no revision. 0 means never update"
	parent := self repository getObject: '/', shortRestUri.
	^ parent isLoaded ifTrue: [parent updateInterval] ifFalse: [0]! !

StandardWindow subclass: #XpfClient
	instanceVariableNames: 'sidebar mainPanel userStoryPools historyPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-ProjectTalk'!

!XpfClient class methodsFor: 'defaults' stamp: 'SR 4/14/2009 21:18'!
defaultHeight

	^ 480! !

!XpfClient class methodsFor: 'defaults' stamp: 'SR 4/14/2009 21:19'!
defaultWidth

	^ 640! !

!XpfClient class methodsFor: 'defaults' stamp: 'topa 4/20/2009 14:42'!
font: n at: size
	
	TTCFont registry isEmpty ifTrue: [TTCFont registerAll].
	^  TTCFont familyName: n pointSize: size emphasis: 0! !

!XpfClient class methodsFor: 'initialization' stamp: 'topa 5/18/2009 15:30'!
frameForCount: count index: index

	^ (LayoutFrame new)
		leftFraction: 0; 
		rightFraction: 1; 
		topFraction: (count - index ) * (1/count); 
		bottomFraction: (count - index) + 1 * (1/ count).
! !

!XpfClient class methodsFor: 'defaults' stamp: 'topa 4/20/2009 17:22'!
monoFont

	^ self monoFontAt: 10! !

!XpfClient class methodsFor: 'defaults' stamp: 'topa 4/20/2009 14:41'!
monoFontAt: aPointSize

	^ self font: 'BitstreamVeraSansMono' at: aPointSize! !

!XpfClient class methodsFor: 'user interface' stamp: 'cs 5/27/2009 11:14'!
open
	
	[^ self openProject: XpfLoginProcessor new project]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfClient class methodsFor: 'user interface' stamp: 'cs 6/12/2009 16:00'!
openProject: project
	
	| instance |
	[#(model open) do: [:step |
		World displayWorldSafely.
		step = #model ifTrue: [instance := self new model: project].
		step = #open ifTrue: [instance openInWorld]] displayingProgress: 'Opening client...'.

	^ instance]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfClient class methodsFor: 'defaults' stamp: 'topa 4/20/2009 17:15'!
sansFont

	^ self sansFontAt: 11! !

!XpfClient class methodsFor: 'defaults' stamp: 'topa 4/20/2009 14:42'!
sansFontAt: aPointSize

	^ self font: 'BitstreamVeraSans' at: aPointSize! !

!XpfClient methodsFor: 'initialization' stamp: 'SR 4/17/2009 15:13'!
buttonBar

	^ self newRow: {
		self createAddIterationButton.
		self createToggleHistoryButton.
		self newToolSpacer hResizing: #spaceFill}! !

!XpfClient methodsFor: 'initialization' stamp: 'topa 4/17/2009 17:31'!
createAddIterationButton

	^ IconicButton new
		color: Color transparent;
		target: self;
		borderWidth: 0;
		labelGraphic: MenuIcons xpfAddIteration;
		actionSelector: #createIteration;
		setBalloonText: 'Add new iteration'! !

!XpfClient methodsFor: 'initialization' stamp: 'SR 4/17/2009 15:15'!
createDeleteMorph
	
	^ XpfDeleteMorph new
		bottomLeft: 4@XpfClient defaultHeight + self topLeft;
		model: self model;
		yourself! !

!XpfClient methodsFor: 'initialization' stamp: 'mig 4/15/2009 14:07'!
createFeedbackButton

	| box |

	box := self createBox
		labelGraphic: MenuIcons xpf7LikeFeedback;
		actionSelector: #doFeedback;
		setBalloonText: 'give feedback to the developers'.
	
	"retain title bar height"
	box extent: box extent x @ self boxExtent y.

	labelArea addMorph: box behind: label.
! !

!XpfClient methodsFor: 'initialization' stamp: 'mt 4/2/2009 11:17'!
createFirstIteration

	| result |
	result := self textEntry: 'No iteration found. Choose a name for the first iteration:' title: 'Add initial iteration'. 	
	^ self model addNewIteration: (Dictionary newFrom: {'title' -> (result ifNil: ['New Iteration'])})! !

!XpfClient methodsFor: 'initialization' stamp: 'mt 4/2/2009 11:16'!
createIteration

	| result |
	result := self textEntry: 'Choose a name for the iteration:' title: 'Add iteration'. 
	
	result ifNil: [^ self].
	
	^ self model addNewIteration: (Dictionary newFrom: {'title' -> result})! !

!XpfClient methodsFor: 'initialization' stamp: 'topa 4/17/2009 16:24'!
createToggleHistoryButton

	^ IconicButton new
		color: Color transparent;
		target: self;
		borderWidth: 0;
		labelGraphic: MenuIcons xpfHistory;
		actionSelector: #toggleHistory;
		setBalloonText: 'Toggle visibilty of history panel'! !

!XpfClient methodsFor: 'initialization' stamp: 'SR 4/17/2009 16:31'!
createUserStoryAddMorph
	
	^ XpfUserStoryAddMorph new
		topRight: XpfClient defaultWidth@5 + self topLeft;
		model: (self model iterations detect: [:iter | iter isXpfFutureIteration]);
		yourself! !

!XpfClient methodsFor: 'submorphs-add/remove' stamp: 'mig 4/3/2009 11:15'!
delete

	self model repository stopUpdating.
	super delete.
! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 5/18/2009 15:26'!
deselectAllIterations

	self userStoryPools copy do: [:pool |
		self userStoryPools remove: pool.
		self mainPanel removeMorph: pool scrollPane].
	self updateUserStoryPools.! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 5/18/2009 15:26'!
deselectIteration: anXpfIteration

	| pool |
	pool := self userStoryPools detect: [:morph | morph model id = anXpfIteration id] ifNone: [nil].
	pool ifNotNil: [
		self userStoryPools remove: pool.
		self mainPanel removeMorph: pool scrollPane].
	self updateUserStoryPools.! !

!XpfClient methodsFor: 'feedback' stamp: 'mig 4/15/2009 14:33'!
doFeedback

	| feedback |
	feedback := UIManager default
		multiLineRequest: 'Please enter your feedback:'
		centerAt: self center
		initialAnswer: ''
		answerHeight: Display height / 3.
		
	(feedback isNil or: [feedback isEmpty]) ifTrue: [^ self].
	
	(RestSocket postDocumentFromUrl: self feedbackUrl request: '' content: feedback) isOk
		ifTrue: [self message: 'Feedback was successfully sent to the server. Thank you!!' title: 'Feedback']
		ifFalse: [self abort: 'There was a problem sending the feedback to the server.' title: 'Feedback'].! !

!XpfClient methodsFor: 'feedback' stamp: 'SR 4/15/2009 14:30'!
feedbackUrl

	^ (self model baseUri, 'feedback/mail') asUrl! !

!XpfClient methodsFor: 'as yet unclassified' stamp: 'mfp 4/29/2009 14:59'!
fullScreen

	super fullScreen.
	self bounds setOrigin: self bounds origin corner: ((self bounds origin x + 1200)@self bounds corner y).! !

!XpfClient methodsFor: 'accessing' stamp: 'cs 4/17/2009 16:16'!
historyPanel

	historyPanel ifNil:
		[historyPanel := (XpfHistoryMorph forProject: self model) client: self].
	^ historyPanel! !

!XpfClient methodsFor: 'initialization' stamp: 'topa 5/18/2009 14:47'!
initialize

	super initialize.	
	self
		addMorph: ((self newDialogPanel listDirection: #leftToRight) layoutInset: 2; cellInset: 2)
			frame: (0@0 corner: 1@1);
		extent: self class defaultWidth @ self class defaultHeight;
		userStoryPools: OrderedCollection new;
		sidebar: XpfIterationSidebarMorph new;
		createFeedbackButton.! !

!XpfClient methodsFor: 'initialization' stamp: 'mfp 5/6/2009 11:20'!
initializeUserInterface

	self paneMorphs first
		addMorphBack: (self newColumn: {
			(self newRow: {
				(self newColumn: {self userStoryButtons. self sidebar. self buttonBar}) hResizing: #shrinkWrap; cellInset: 1.
				self mainPanel}) vResizing: #spaceFill; cellInset: 0; yourself.
			self historyPanel}).! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 5/18/2009 15:10'!
mainPanel
	
	mainPanel ifNil: [
		self mainPanel: ((self newColumn: {}) layoutInset: 1; cellInset: 4).
		self mainPanel changeProportionalLayout].
	^ mainPanel! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 17:42'!
mainPanel: anObject

	mainPanel := anObject.! !

!XpfClient methodsFor: 'accessing' stamp: 'SR 4/12/2009 21:10'!
model: anXpfProject

	super model: anXpfProject.
		
	self
		title: anXpfProject title;
		initializeUserInterface.

	(self sidebar)
		addDependent: self;
		model: self model.
	self model isRestProxy ifTrue:
		[anXpfProject repository startUpdating].! !

!XpfClient methodsFor: 'accessing' stamp: 'topa 5/18/2009 15:31'!
selectIteration: anXpfIteration

	| pos newPool scrollPane |
	pos := self model iterations indexOf: anXpfIteration.
	newPool := XpfUserStoryPoolMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		model: anXpfIteration.
	anXpfIteration isXpfFutureIteration ifTrue: [newPool fillStyle: Color white].
	
	scrollPane := (newPool withScrollBars)
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		borderWidth: 0.


	self userStoryPools isEmpty
		ifTrue: [
			self userStoryPools add: newPool.
			self mainPanel addMorph: scrollPane]
		ifFalse: [
			self userStoryPools do: [:pool | 
				(self model iterations indexOf: pool model) > pos ifTrue: [
					self userStoryPools add: newPool before: pool.
					self mainPanel addMorph: scrollPane inFrontOf: pool scrollPane.
					^ self updateUserStoryPools]].
			self userStoryPools add: newPool.
			self mainPanel addMorphBack: scrollPane].
	self updateUserStoryPools.! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 4/1/2009 13:53'!
sidebar

	^ sidebar! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 3/31/2009 17:42'!
sidebar: anXpfIterationSidebarMorph

	sidebar := anXpfIterationSidebarMorph.! !

!XpfClient methodsFor: 'as yet unclassified' stamp: 'cs 4/6/2009 17:47'!
toggleHistory

	self historyPanel
		visible: self historyPanel visible not;
		disableTableLayout: self historyPanel visible not.! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 4/28/2009 12:48'!
update: aSymbol
	
	aSymbol = #iterationDeselectAll ifTrue: [self deselectAllIterations].
	super update: aSymbol.! !

!XpfClient methodsFor: 'accessing' stamp: 'mt 4/28/2009 12:49'!
update: aSymbol with: anObject
	
	aSymbol = #iterationSelected ifTrue: [self selectIteration: anObject].
	aSymbol = #iterationDeselected ifTrue: [self deselectIteration: anObject].
	
	super update: aSymbol with: anObject.! !

!XpfClient methodsFor: 'initialization' stamp: 'topa 5/18/2009 15:27'!
updateUserStoryPools

	| uspCount |
	uspCount := self userStoryPools size.
	
	(uspCount > 0) ifTrue: [
		self userStoryPools withIndexDo: [:userStoryPool :index|
			userStoryPool withScrollBars layoutFrame:
				(self class frameForCount: uspCount index: index)].
		self mainPanel addPaneSplitters].! !

!XpfClient methodsFor: 'initialization' stamp: 'mfp 5/6/2009 11:25'!
userStoryButtons

	^ self newRow: {
		self newToolSpacer hResizing: #spaceFill.
		self createUserStoryAddMorph.
		self newToolSpacer hResizing: #spaceFill.
		self createDeleteMorph.
		self newToolSpacer hResizing: #spaceFill}! !

!XpfClient methodsFor: 'accessing' stamp: 'cs 4/27/2009 17:46'!
userStoryPools

	^ userStoryPools! !

!XpfClient methodsFor: 'accessing' stamp: 'cs 4/27/2009 17:46'!
userStoryPools: anObject

	userStoryPools := anObject.! !

!Morph methodsFor: '*xpf-client' stamp: 'mfp 3/19/2009 14:43'!
acceptsTasks

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'cs 3/10/2009 16:13'!
acceptsUserStories

	^ false! !

!Morph methodsFor: '*xpf-client-polymorph' stamp: 'bs 6/18/2009 09:44'!
addPolymorphColumn

	^ self addMorphBack: (self theme newColumnIn: self for: {})! !

!Morph methodsFor: '*xpf-client-polymorph' stamp: 'bs 6/18/2009 09:42'!
addPolymorphRow

	^ self addMorphBack: (self theme newRowIn: self for: {})! !

!Morph methodsFor: '*xpf-client' stamp: 'SR 4/18/2009 11:25'!
allSubmorphsWith: aConditionBlock do: aBlock 
	"Evaluate the given block for all morphs in this composite morph (including the receiver)."

	submorphs do: [:m | aBlock value: m.
		(aConditionBlock value: m)
			ifTrue: [m allSubmorphsWith: aConditionBlock do: aBlock]].! !

!Morph methodsFor: '*xpf-client' stamp: 'mfp 3/19/2009 16:14'!
isEntityMorphContent

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'topa 3/19/2009 14:53'!
isTaskMorph

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'topa 3/3/2009 23:50'!
isUserStoryMorph

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'SR 4/14/2009 22:01'!
isXpfEntityMorph

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'SR 4/14/2009 21:04'!
isXpfTaskTitleContent

	^ false! !

!Morph methodsFor: '*xpf-client' stamp: 'mfp 3/19/2009 16:15'!
isXpfUserStoryTitleContent

	^ false! !

!Morph methodsFor: '*xpf-client-polymorph' stamp: 'bs 6/30/2009 13:43'!
newColumnFor: controls
	
	|answer|
	answer := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		cellInset: 0.
	controls do: [:m | answer addMorphBack: m].
	^answer! !

!Morph methodsFor: '*xpf-client-polymorph' stamp: 'bs 6/30/2009 13:44'!
newRowFor: controls
	
	|answer|
	answer := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 0.
	controls do: [:m | answer addMorphBack: m].
	^answer! !

Morph subclass: #XpfEstimationCircleMorph
	instanceVariableNames: 'nUnits radius segmentUnitsComputing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Client-Widgets'!

!XpfEstimationCircleMorph class methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 20:23'!
nUnits: anInteger segmentUnitsComputing: aBlock
	^ self new nUnits: anInteger; segmentUnitsComputing: aBlock; yourself! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 18:32'!
diameter
	^ self radius * 2! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 20:29'!
drawOn: aCanvas

	| nPolygons nSegmentPolygons gamma vertices deltaY deltaX segmentColor delta nSegmentsUnit |
	
	aCanvas fillOval: self bounds color: Color veryVeryLightGray borderWidth: 0 borderColor: nil.
	
	nSegmentsUnit := self segmentUnitsComputing value.
	(nSegmentsUnit > 0) ifTrue: [		
		nPolygons := self nUnits * 100.
		nSegmentPolygons := nSegmentsUnit * 100.
		gamma := 360 / nPolygons.
		vertices := OrderedCollection new.
		vertices addAll: {self center. self center + (self radius @ 0)}.

		1 to: nSegmentPolygons do: [:i |
			deltaY := (gamma*i) degreeSin * self radius.
			deltaX := ((self radius * self radius) - (deltaY*deltaY)) sqrt.
			delta := (deltaX rounded * (gamma*i+90) degreeSin sign)@(deltaY rounded).
			vertices add: (self center + delta).
		].
		segmentColor := Color r: 1.0 g: 0.725 b: 0.482.
		aCanvas drawPolygon: vertices color: segmentColor borderWidth: 0 borderColor: nil.		
	].! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 18:32'!
initialize
	super initialize.
	self radius: 30.
	self extent: self diameter @ self diameter.! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 22:33'!
nUnits
	^nUnits ! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 22:24'!
nUnits: anObject
	nUnits := anObject ! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 22:33'!
radius
	^ radius  ! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 19:44'!
radius: anInteger
	radius := anInteger. ! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 22:33'!
segmentUnitsComputing
	^ segmentUnitsComputing! !

!XpfEstimationCircleMorph methodsFor: 'as yet unclassified' stamp: 'bs 7/8/2009 20:22'!
segmentUnitsComputing: aBlock
	segmentUnitsComputing := aBlock.! !
SSHTunnel initialize!
XpfLoginProcessor initialize!
